# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Full fledged AHRS with 9 degrees of freedom
  class BrickIMU < Device
    DEVICE_IDENTIFIER = 16 # :nodoc:
    DEVICE_DISPLAY_NAME = 'IMU Brick' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickIMU#set_acceleration_period. The parameters are the acceleration
    # for the x, y and z axis.
    CALLBACK_ACCELERATION = 31

    # This callback is triggered periodically with the period that is set by
    # BrickIMU#set_magnetic_field_period. The parameters are the magnetic
    # field for the x, y and z axis.
    CALLBACK_MAGNETIC_FIELD = 32

    # This callback is triggered periodically with the period that is set by
    # BrickIMU#set_angular_velocity_period. The parameters are the angular
    # velocity for the x, y and z axis.
    CALLBACK_ANGULAR_VELOCITY = 33

    # This callback is triggered periodically with the period that is set by
    # BrickIMU#set_all_data_period. The parameters are the acceleration,
    # the magnetic field and the angular velocity for the x, y and z axis as
    # well as the temperature of the IMU Brick.
    CALLBACK_ALL_DATA = 34

    # This callback is triggered periodically with the period that is set by
    # BrickIMU#set_orientation_period. The parameters are the orientation
    # (roll, pitch and yaw) of the IMU Brick in Euler angles. See
    # BrickIMU#get_orientation for details.
    CALLBACK_ORIENTATION = 35

    # This callback is triggered periodically with the period that is set by
    # BrickIMU#set_quaternion_period. The parameters are the orientation
    # (x, y, z, w) of the IMU Brick in quaternions. See BrickIMU#get_quaternion
    # for details.
    CALLBACK_QUATERNION = 36

    FUNCTION_GET_ACCELERATION = 1 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD = 2 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY = 3 # :nodoc:
    FUNCTION_GET_ALL_DATA = 4 # :nodoc:
    FUNCTION_GET_ORIENTATION = 5 # :nodoc:
    FUNCTION_GET_QUATERNION = 6 # :nodoc:
    FUNCTION_GET_IMU_TEMPERATURE = 7 # :nodoc:
    FUNCTION_LEDS_ON = 8 # :nodoc:
    FUNCTION_LEDS_OFF = 9 # :nodoc:
    FUNCTION_ARE_LEDS_ON = 10 # :nodoc:
    FUNCTION_SET_ACCELERATION_RANGE = 11 # :nodoc:
    FUNCTION_GET_ACCELERATION_RANGE = 12 # :nodoc:
    FUNCTION_SET_MAGNETOMETER_RANGE = 13 # :nodoc:
    FUNCTION_GET_MAGNETOMETER_RANGE = 14 # :nodoc:
    FUNCTION_SET_CONVERGENCE_SPEED = 15 # :nodoc:
    FUNCTION_GET_CONVERGENCE_SPEED = 16 # :nodoc:
    FUNCTION_SET_CALIBRATION = 17 # :nodoc:
    FUNCTION_GET_CALIBRATION = 18 # :nodoc:
    FUNCTION_SET_ACCELERATION_PERIOD = 19 # :nodoc:
    FUNCTION_GET_ACCELERATION_PERIOD = 20 # :nodoc:
    FUNCTION_SET_MAGNETIC_FIELD_PERIOD = 21 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD_PERIOD = 22 # :nodoc:
    FUNCTION_SET_ANGULAR_VELOCITY_PERIOD = 23 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY_PERIOD = 24 # :nodoc:
    FUNCTION_SET_ALL_DATA_PERIOD = 25 # :nodoc:
    FUNCTION_GET_ALL_DATA_PERIOD = 26 # :nodoc:
    FUNCTION_SET_ORIENTATION_PERIOD = 27 # :nodoc:
    FUNCTION_GET_ORIENTATION_PERIOD = 28 # :nodoc:
    FUNCTION_SET_QUATERNION_PERIOD = 29 # :nodoc:
    FUNCTION_GET_QUATERNION_PERIOD = 30 # :nodoc:
    FUNCTION_ORIENTATION_CALCULATION_ON = 37 # :nodoc:
    FUNCTION_ORIENTATION_CALCULATION_OFF = 38 # :nodoc:
    FUNCTION_IS_ORIENTATION_CALCULATION_ON = 39 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = 231 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = 232 # :nodoc:
    FUNCTION_GET_SEND_TIMEOUT_COUNT = 233 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE = 234 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE = 235 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 237 # :nodoc:
    FUNCTION_ENABLE_STATUS_LED = 238 # :nodoc:
    FUNCTION_DISABLE_STATUS_LED = 239 # :nodoc:
    FUNCTION_IS_STATUS_LED_ENABLED = 240 # :nodoc:
    FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_BRICKLET_PLUGIN = 246 # :nodoc:
    FUNCTION_READ_BRICKLET_PLUGIN = 247 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    CALIBRATION_TYPE_ACCELEROMETER_GAIN = 0 # :nodoc:
    CALIBRATION_TYPE_ACCELEROMETER_BIAS = 1 # :nodoc:
    CALIBRATION_TYPE_MAGNETOMETER_GAIN = 2 # :nodoc:
    CALIBRATION_TYPE_MAGNETOMETER_BIAS = 3 # :nodoc:
    CALIBRATION_TYPE_GYROSCOPE_GAIN = 4 # :nodoc:
    CALIBRATION_TYPE_GYROSCOPE_BIAS = 5 # :nodoc:
    COMMUNICATION_METHOD_NONE = 0 # :nodoc:
    COMMUNICATION_METHOD_USB = 1 # :nodoc:
    COMMUNICATION_METHOD_SPI_STACK = 2 # :nodoc:
    COMMUNICATION_METHOD_CHIBI = 3 # :nodoc:
    COMMUNICATION_METHOD_RS485 = 4 # :nodoc:
    COMMUNICATION_METHOD_WIFI = 5 # :nodoc:
    COMMUNICATION_METHOD_ETHERNET = 6 # :nodoc:
    COMMUNICATION_METHOD_WIFI_V2 = 7 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 4]

      @response_expected[FUNCTION_GET_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_QUATERNION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IMU_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_LEDS_ON] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_LEDS_OFF] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_ARE_LEDS_ON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_RANGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ACCELERATION_RANGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MAGNETOMETER_RANGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MAGNETOMETER_RANGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONVERGENCE_SPEED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONVERGENCE_SPEED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CALIBRATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MAGNETIC_FIELD_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANGULAR_VELOCITY_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ORIENTATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_QUATERNION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_QUATERNION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ORIENTATION_CALCULATION_ON] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_ORIENTATION_CALCULATION_OFF] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_ORIENTATION_CALCULATION_ON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SEND_TIMEOUT_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_STATUS_LED_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_ACCELERATION] = [14, 's s s']
      @callback_formats[CALLBACK_MAGNETIC_FIELD] = [14, 's s s']
      @callback_formats[CALLBACK_ANGULAR_VELOCITY] = [14, 's s s']
      @callback_formats[CALLBACK_ALL_DATA] = [28, 's s s s s s s s s s']
      @callback_formats[CALLBACK_ORIENTATION] = [14, 's s s']
      @callback_formats[CALLBACK_QUATERNION] = [24, 'e e e e']

      @ipcon.add_device self
    end

    # Returns the calibrated acceleration from the accelerometer for the
    # x, y and z axis.
    # 
    # If you want to get the acceleration periodically, it is recommended
    # to use the CALLBACK_ACCELERATION callback and set the period with
    # BrickIMU#set_acceleration_period.
    def get_acceleration
      check_validity

      send_request FUNCTION_GET_ACCELERATION, [], '', 14, 's s s'
    end

    # Returns the calibrated magnetic field from the magnetometer for the
    # x, y and z axis.
    # 
    # If you want to get the magnetic field periodically, it is recommended
    # to use the CALLBACK_MAGNETIC_FIELD callback and set the period with
    # BrickIMU#set_magnetic_field_period.
    def get_magnetic_field
      check_validity

      send_request FUNCTION_GET_MAGNETIC_FIELD, [], '', 14, 's s s'
    end

    # Returns the calibrated angular velocity from the gyroscope for the
    # x, y and z axis in °/14.375s (you have to divide by 14.375 to
    # get the value in °/s).
    # 
    # If you want to get the angular velocity periodically, it is recommended
    # to use the CALLBACK_ANGULAR_VELOCITY callback and set the period with
    # BrickIMU#set_angular_velocity_period.
    def get_angular_velocity
      check_validity

      send_request FUNCTION_GET_ANGULAR_VELOCITY, [], '', 14, 's s s'
    end

    # Returns the data from BrickIMU#get_acceleration, BrickIMU#get_magnetic_field
    # and BrickIMU#get_angular_velocity as well as the temperature of the IMU Brick.
    # 
    # If you want to get the data periodically, it is recommended
    # to use the CALLBACK_ALL_DATA callback and set the period with
    # BrickIMU#set_all_data_period.
    def get_all_data
      check_validity

      send_request FUNCTION_GET_ALL_DATA, [], '', 28, 's s s s s s s s s s'
    end

    # Returns the current orientation (roll, pitch, yaw) of the IMU Brick as Euler
    # angles. Note that Euler angles always experience a
    # `gimbal lock <https://en.wikipedia.org/wiki/Gimbal_lock>`__.
    # 
    # We recommend that you use quaternions instead.
    # 
    # The order to sequence in which the orientation values should be applied is
    # roll, yaw, pitch.
    # 
    # If you want to get the orientation periodically, it is recommended
    # to use the CALLBACK_ORIENTATION callback and set the period with
    # BrickIMU#set_orientation_period.
    def get_orientation
      check_validity

      send_request FUNCTION_GET_ORIENTATION, [], '', 14, 's s s'
    end

    # Returns the current orientation (x, y, z, w) of the IMU as
    # `quaternions <https://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation>`__.
    # 
    # You can go from quaternions to Euler angles with the following formula::
    # 
    #  xAngle = atan2(2*y*w - 2*x*z, 1 - 2*y*y - 2*z*z)
    #  yAngle = atan2(2*x*w - 2*y*z, 1 - 2*x*x - 2*z*z)
    #  zAngle =  asin(2*x*y + 2*z*w)
    # 
    # This process is not reversible, because of the
    # `gimbal lock <https://en.wikipedia.org/wiki/Gimbal_lock>`__.
    # 
    # It is also possible to calculate independent angles. You can calculate
    # yaw, pitch and roll in a right-handed vehicle coordinate system according to
    # DIN70000 with::
    # 
    #  yaw   =  atan2(2*x*y + 2*w*z, w*w + x*x - y*y - z*z)
    #  pitch = -asin(2*w*y - 2*x*z)
    #  roll  = -atan2(2*y*z + 2*w*x, -w*w + x*x + y*y - z*z))
    # 
    # Converting the quaternions to an OpenGL transformation matrix is
    # possible with the following formula::
    # 
    #  matrix = [[1 - 2*(y*y + z*z),     2*(x*y - w*z),     2*(x*z + w*y), 0],
    #            [    2*(x*y + w*z), 1 - 2*(x*x + z*z),     2*(y*z - w*x), 0],
    #            [    2*(x*z - w*y),     2*(y*z + w*x), 1 - 2*(x*x + y*y), 0],
    #            [                0,                 0,                 0, 1]]
    # 
    # If you want to get the quaternions periodically, it is recommended
    # to use the CALLBACK_QUATERNION callback and set the period with
    # BrickIMU#set_quaternion_period.
    def get_quaternion
      check_validity

      send_request FUNCTION_GET_QUATERNION, [], '', 24, 'e e e e'
    end

    # Returns the temperature of the IMU Brick.
    def get_imu_temperature
      check_validity

      send_request FUNCTION_GET_IMU_TEMPERATURE, [], '', 10, 's'
    end

    # Turns the orientation and direction LEDs of the IMU Brick on.
    def leds_on
      check_validity

      send_request FUNCTION_LEDS_ON, [], '', 8, ''
    end

    # Turns the orientation and direction LEDs of the IMU Brick off.
    def leds_off
      check_validity

      send_request FUNCTION_LEDS_OFF, [], '', 8, ''
    end

    # Returns *true* if the orientation and direction LEDs of the IMU Brick
    # are on, *false* otherwise.
    def are_leds_on
      check_validity

      send_request FUNCTION_ARE_LEDS_ON, [], '', 9, '?'
    end

    # Not implemented yet.
    def set_acceleration_range(range)
      check_validity

      send_request FUNCTION_SET_ACCELERATION_RANGE, [range], 'C', 8, ''
    end

    # Not implemented yet.
    def get_acceleration_range
      check_validity

      send_request FUNCTION_GET_ACCELERATION_RANGE, [], '', 9, 'C'
    end

    # Not implemented yet.
    def set_magnetometer_range(range)
      check_validity

      send_request FUNCTION_SET_MAGNETOMETER_RANGE, [range], 'C', 8, ''
    end

    # Not implemented yet.
    def get_magnetometer_range
      check_validity

      send_request FUNCTION_GET_MAGNETOMETER_RANGE, [], '', 9, 'C'
    end

    # Sets the convergence speed of the IMU Brick. The convergence speed
    # determines how the different sensor measurements are fused.
    # 
    # If the orientation of the IMU Brick is off by 10° and the convergence speed is
    # set to 20°/s, it will take 0.5s until the orientation is corrected. However,
    # if the correct orientation is reached and the convergence speed is too high,
    # the orientation will fluctuate with the fluctuations of the accelerometer and
    # the magnetometer.
    # 
    # If you set the convergence speed to 0, practically only the gyroscope is used
    # to calculate the orientation. This gives very smooth movements, but errors of the
    # gyroscope will not be corrected. If you set the convergence speed to something
    # above 500, practically only the magnetometer and the accelerometer are used to
    # calculate the orientation. In this case the movements are abrupt and the values
    # will fluctuate, but there won't be any errors that accumulate over time.
    # 
    # In an application with high angular velocities, we recommend a high convergence
    # speed, so the errors of the gyroscope can be corrected fast. In applications with
    # only slow movements we recommend a low convergence speed. You can change the
    # convergence speed on the fly. So it is possible (and recommended) to increase
    # the convergence speed before an abrupt movement and decrease it afterwards
    # again.
    # 
    # You might want to play around with the convergence speed in the Brick Viewer to
    # get a feeling for a good value for your application.
    def set_convergence_speed(speed)
      check_validity

      send_request FUNCTION_SET_CONVERGENCE_SPEED, [speed], 'S', 8, ''
    end

    # Returns the convergence speed as set by BrickIMU#set_convergence_speed.
    def get_convergence_speed
      check_validity

      send_request FUNCTION_GET_CONVERGENCE_SPEED, [], '', 10, 'S'
    end

    # There are several different types that can be calibrated:
    # 
    #  "Type", "Description", "Values"
    # 
    #  "0",    "Accelerometer Gain", "``[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]``"
    #  "1",    "Accelerometer Bias", "``[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]``"
    #  "2",    "Magnetometer Gain",  "``[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]``"
    #  "3",    "Magnetometer Bias",  "``[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]``"
    #  "4",    "Gyroscope Gain",     "``[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]``"
    #  "5",    "Gyroscope Bias",     "``[bias xl, bias yl, bias zl, temp l, bias xh, bias yh, bias zh, temp h, 0, 0]``"
    # 
    # The calibration via gain and bias is done with the following formula::
    # 
    #  new_value = (bias + orig_value) * gain_mul / gain_div
    # 
    # If you really want to write your own calibration software, please keep
    # in mind that you first have to undo the old calibration (set bias to 0 and
    # gain to 1/1) and that you have to average over several thousand values
    # to obtain a usable result in the end.
    # 
    # The gyroscope bias is highly dependent on the temperature, so you have to
    # calibrate the bias two times with different temperatures. The values ``xl``,
    # ``yl``, ``zl`` and ``temp l`` are the bias for ``x``, ``y``, ``z`` and the
    # corresponding temperature for a low temperature. The values ``xh``, ``yh``,
    # ``zh`` and ``temp h`` are the same for a high temperatures. The temperature
    # difference should be at least 5°C. If you have a temperature where the
    # IMU Brick is mostly used, you should use this temperature for one of the
    # sampling points.
    # 
    # .. note::
    #  We highly recommend that you use the Brick Viewer to calibrate your
    #  IMU Brick.
    def set_calibration(typ, data)
      check_validity

      send_request FUNCTION_SET_CALIBRATION, [typ, data], 'C s10', 8, ''
    end

    # Returns the calibration for a given type as set by BrickIMU#set_calibration.
    def get_calibration(typ)
      check_validity

      send_request FUNCTION_GET_CALIBRATION, [typ], 'C', 28, 's10'
    end

    # Sets the period with which the CALLBACK_ACCELERATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_acceleration_period(period)
      check_validity

      send_request FUNCTION_SET_ACCELERATION_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMU#set_acceleration_period.
    def get_acceleration_period
      check_validity

      send_request FUNCTION_GET_ACCELERATION_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_MAGNETIC_FIELD callback is
    # triggered periodically. A value of 0 turns the callback off.
    def set_magnetic_field_period(period)
      check_validity

      send_request FUNCTION_SET_MAGNETIC_FIELD_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMU#set_magnetic_field_period.
    def get_magnetic_field_period
      check_validity

      send_request FUNCTION_GET_MAGNETIC_FIELD_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ANGULAR_VELOCITY callback is
    # triggered periodically. A value of 0 turns the callback off.
    def set_angular_velocity_period(period)
      check_validity

      send_request FUNCTION_SET_ANGULAR_VELOCITY_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMU#set_angular_velocity_period.
    def get_angular_velocity_period
      check_validity

      send_request FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ALL_DATA callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_all_data_period(period)
      check_validity

      send_request FUNCTION_SET_ALL_DATA_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMU#set_all_data_period.
    def get_all_data_period
      check_validity

      send_request FUNCTION_GET_ALL_DATA_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ORIENTATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_orientation_period(period)
      check_validity

      send_request FUNCTION_SET_ORIENTATION_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMU#set_orientation_period.
    def get_orientation_period
      check_validity

      send_request FUNCTION_GET_ORIENTATION_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_QUATERNION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_quaternion_period(period)
      check_validity

      send_request FUNCTION_SET_QUATERNION_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMU#set_quaternion_period.
    def get_quaternion_period
      check_validity

      send_request FUNCTION_GET_QUATERNION_PERIOD, [], '', 12, 'L'
    end

    # Turns the orientation calculation of the IMU Brick on.
    # 
    # As default the calculation is on.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Firmware)
    def orientation_calculation_on
      check_validity

      send_request FUNCTION_ORIENTATION_CALCULATION_ON, [], '', 8, ''
    end

    # Turns the orientation calculation of the IMU Brick off.
    # 
    # If the calculation is off, BrickIMU#get_orientation will return
    # the last calculated value until the calculation is turned on again.
    # 
    # The trigonometric functions that are needed to calculate the orientation
    # are very expensive. We recommend to turn the orientation calculation
    # off if the orientation is not needed, to free calculation time for the
    # sensor fusion algorithm.
    # 
    # As default the calculation is on.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Firmware)
    def orientation_calculation_off
      check_validity

      send_request FUNCTION_ORIENTATION_CALCULATION_OFF, [], '', 8, ''
    end

    # Returns *true* if the orientation calculation of the IMU Brick
    # is on, *false* otherwise.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Firmware)
    def is_orientation_calculation_on
      check_validity

      send_request FUNCTION_IS_ORIENTATION_CALCULATION_ON, [], '', 9, '?'
    end

    # The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
    # enabled, the Brick will try to adapt the baudrate for the communication
    # between Bricks and Bricklets according to the amount of data that is transferred.
    # 
    # The baudrate will be increased exponentially if lots of data is sent/received and
    # decreased linearly if little data is sent/received.
    # 
    # This lowers the baudrate in applications where little data is transferred (e.g.
    # a weather station) and increases the robustness. If there is lots of data to transfer
    # (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
    # 
    # In cases where some data has to transferred as fast as possible every few seconds
    # (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
    # the dynamic baudrate off to get the highest possible performance.
    # 
    # The maximum value of the baudrate can be set per port with the function
    # BrickIMU#set_spitfp_baudrate. If the dynamic baudrate is disabled, the baudrate
    # as set by BrickIMU#set_spitfp_baudrate will be used statically.
    # 
    # .. versionadded:: 2.3.5$nbsp;(Firmware)
    def set_spitfp_baudrate_config(enable_dynamic_baudrate, minimum_dynamic_baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, [enable_dynamic_baudrate, minimum_dynamic_baudrate], '? L', 8, ''
    end

    # Returns the baudrate config, see BrickIMU#set_spitfp_baudrate_config.
    # 
    # .. versionadded:: 2.3.5$nbsp;(Firmware)
    def get_spitfp_baudrate_config
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, [], '', 13, '? L'
    end

    # Returns the timeout count for the different communication methods.
    # 
    # The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
    # 
    # This function is mostly used for debugging during development, in normal operation
    # the counters should nearly always stay at 0.
    # 
    # .. versionadded:: 2.3.3$nbsp;(Firmware)
    def get_send_timeout_count(communication_method)
      check_validity

      send_request FUNCTION_GET_SEND_TIMEOUT_COUNT, [communication_method], 'C', 12, 'L'
    end

    # Sets the baudrate for a specific Bricklet port.
    # 
    # If you want to increase the throughput of Bricklets you can increase
    # the baudrate. If you get a high error count because of high
    # interference (see BrickIMU#get_spitfp_error_count) you can decrease the
    # baudrate.
    # 
    # If the dynamic baudrate feature is enabled, the baudrate set by this
    # function corresponds to the maximum baudrate (see BrickIMU#set_spitfp_baudrate_config).
    # 
    # Regulatory testing is done with the default baudrate. If CE compatibility
    # or similar is necessary in your applications we recommend to not change
    # the baudrate.
    # 
    # .. versionadded:: 2.3.3$nbsp;(Firmware)
    def set_spitfp_baudrate(bricklet_port, baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE, [bricklet_port, baudrate], 'k L', 8, ''
    end

    # Returns the baudrate for a given Bricklet port, see BrickIMU#set_spitfp_baudrate.
    # 
    # .. versionadded:: 2.3.3$nbsp;(Firmware)
    def get_spitfp_baudrate(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE, [bricklet_port], 'k', 12, 'L'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Brick side. All
    # Bricklets have a similar function that returns the errors on the Bricklet side.
    # 
    # .. versionadded:: 2.3.3$nbsp;(Firmware)
    def get_spitfp_error_count(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [bricklet_port], 'k', 24, 'L L L L'
    end

    # Enables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    # 
    # .. versionadded:: 2.3.1$nbsp;(Firmware)
    def enable_status_led
      check_validity

      send_request FUNCTION_ENABLE_STATUS_LED, [], '', 8, ''
    end

    # Disables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    # 
    # .. versionadded:: 2.3.1$nbsp;(Firmware)
    def disable_status_led
      check_validity

      send_request FUNCTION_DISABLE_STATUS_LED, [], '', 8, ''
    end

    # Returns *true* if the status LED is enabled, *false* otherwise.
    # 
    # .. versionadded:: 2.3.1$nbsp;(Firmware)
    def is_status_led_enabled
      check_validity

      send_request FUNCTION_IS_STATUS_LED_ENABLED, [], '', 9, '?'
    end

    # Returns the firmware and protocol version and the name of the Bricklet for a
    # given port.
    # 
    # This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
    # plugins.
    def get_protocol1_bricklet_name(port)
      check_validity

      send_request FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, [port], 'k', 52, 'C C3 Z40'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has an
    # accuracy of ±15%. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Brick. Calling this function
    # on a Brick inside of a stack will reset the whole stack.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes 32 bytes of firmware to the bricklet attached at the given port.
    # The bytes are written to the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_bricklet_plugin(port, offset, chunk)
      check_validity

      send_request FUNCTION_WRITE_BRICKLET_PLUGIN, [port, offset, chunk], 'k C C32', 8, ''
    end

    # Reads 32 bytes of firmware from the bricklet attached at the given port.
    # The bytes are read starting at the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def read_bricklet_plugin(port, offset)
      check_validity

      send_request FUNCTION_READ_BRICKLET_PLUGIN, [port, offset], 'k C', 40, 'C32'
    end

    # Returns the UID, the UID where the Brick is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position is the position in the stack from '0' (bottom) to '8' (top).
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
