# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures acceleration in three axis
  class BrickletAccelerometerV2 < Device
    DEVICE_IDENTIFIER = 2130 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Accelerometer Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletAccelerometerV2#set_acceleration_callback_configuration.
    # 
    # The parameters are the same as BrickletAccelerometerV2#get_acceleration.
    CALLBACK_ACCELERATION = 8

    # Returns 30 acceleration values with 16 bit resolution. The data rate can
    # be configured with BrickletAccelerometerV2#set_configuration and this callback can be
    # enabled with BrickletAccelerometerV2#set_continuous_acceleration_configuration.
    # 
    # The returned values are raw ADC data. If you want to put this data into
    # a FFT to determine the occurrences of specific frequencies we recommend
    # that you use the data as is. It has all of the ADC noise in it. This noise
    # looks like pure noise at first glance, but it might still have some frequnecy
    # information in it that can be utilized by the FFT.
    # 
    # Otherwise you have to use the following formulas that depend on the
    # full scale range (see BrickletAccelerometerV2#set_configuration) to calculate
    # the data in gₙ/10000 (same unit that is returned by BrickletAccelerometerV2#get_acceleration):
    # 
    # * Full scale 2g: acceleration = value * 625 / 1024
    # * Full scale 4g: acceleration = value * 1250 / 1024
    # * Full scale 8g: acceleration = value * 2500 / 1024
    # 
    # The data is formated in the sequence "x, y, z, x, y, z, ..." depending on
    # the enabled axis. Examples:
    # 
    # * x, y, z enabled: "x, y, z, ..." 10x repeated
    # * x, z enabled: "x, z, ..." 15x repeated
    # * y enabled: "y, ..." 30x repeated
    CALLBACK_CONTINUOUS_ACCELERATION_16_BIT = 11

    # Returns 60 acceleration values with 8 bit resolution. The data rate can
    # be configured with BrickletAccelerometerV2#set_configuration and this callback can be
    # enabled with BrickletAccelerometerV2#set_continuous_acceleration_configuration.
    # 
    # The returned values are raw ADC data. If you want to put this data into
    # a FFT to determine the occurrences of specific frequencies we recommend
    # that you use the data as is. It has all of the ADC noise in it. This noise
    # looks like pure noise at first glance, but it might still have some frequnecy
    # information in it that can be utilized by the FFT.
    # 
    # Otherwise you have to use the following formulas that depend on the
    # full scale range (see BrickletAccelerometerV2#set_configuration) to calculate
    # the data in gₙ/10000 (same unit that is returned by BrickletAccelerometerV2#get_acceleration):
    # 
    # * Full scale 2g: acceleration = value * 256 * 625 / 1024
    # * Full scale 4g: acceleration = value * 256 * 1250 / 1024
    # * Full scale 8g: acceleration = value * 256 * 2500 / 1024
    # 
    # The data is formated in the sequence "x, y, z, x, y, z, ..." depending on
    # the enabled axis. Examples:
    # 
    # * x, y, z enabled: "x, y, z, ..." 20x repeated
    # * x, z enabled: "x, z, ..." 30x repeated
    # * y enabled: "y, ..." 60x repeated
    CALLBACK_CONTINUOUS_ACCELERATION_8_BIT = 12

    FUNCTION_GET_ACCELERATION = 1 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 3 # :nodoc:
    FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION = 4 # :nodoc:
    FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION = 5 # :nodoc:
    FUNCTION_SET_INFO_LED_CONFIG = 6 # :nodoc:
    FUNCTION_GET_INFO_LED_CONFIG = 7 # :nodoc:
    FUNCTION_SET_CONTINUOUS_ACCELERATION_CONFIGURATION = 9 # :nodoc:
    FUNCTION_GET_CONTINUOUS_ACCELERATION_CONFIGURATION = 10 # :nodoc:
    FUNCTION_SET_FILTER_CONFIGURATION = 13 # :nodoc:
    FUNCTION_GET_FILTER_CONFIGURATION = 14 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    DATA_RATE_0_781HZ = 0 # :nodoc:
    DATA_RATE_1_563HZ = 1 # :nodoc:
    DATA_RATE_3_125HZ = 2 # :nodoc:
    DATA_RATE_6_2512HZ = 3 # :nodoc:
    DATA_RATE_12_5HZ = 4 # :nodoc:
    DATA_RATE_25HZ = 5 # :nodoc:
    DATA_RATE_50HZ = 6 # :nodoc:
    DATA_RATE_100HZ = 7 # :nodoc:
    DATA_RATE_200HZ = 8 # :nodoc:
    DATA_RATE_400HZ = 9 # :nodoc:
    DATA_RATE_800HZ = 10 # :nodoc:
    DATA_RATE_1600HZ = 11 # :nodoc:
    DATA_RATE_3200HZ = 12 # :nodoc:
    DATA_RATE_6400HZ = 13 # :nodoc:
    DATA_RATE_12800HZ = 14 # :nodoc:
    DATA_RATE_25600HZ = 15 # :nodoc:
    FULL_SCALE_2G = 0 # :nodoc:
    FULL_SCALE_4G = 1 # :nodoc:
    FULL_SCALE_8G = 2 # :nodoc:
    INFO_LED_CONFIG_OFF = 0 # :nodoc:
    INFO_LED_CONFIG_ON = 1 # :nodoc:
    INFO_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    RESOLUTION_8BIT = 0 # :nodoc:
    RESOLUTION_16BIT = 1 # :nodoc:
    IIR_BYPASS_APPLIED = 0 # :nodoc:
    IIR_BYPASS_BYPASSED = 1 # :nodoc:
    LOW_PASS_FILTER_NINTH = 0 # :nodoc:
    LOW_PASS_FILTER_HALF = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_GET_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_INFO_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_INFO_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONTINUOUS_ACCELERATION_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CONTINUOUS_ACCELERATION_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_FILTER_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_FILTER_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_ACCELERATION] = [20, 'l l l']
      @callback_formats[CALLBACK_CONTINUOUS_ACCELERATION_16_BIT] = [68, 's30']
      @callback_formats[CALLBACK_CONTINUOUS_ACCELERATION_8_BIT] = [68, 'c60']

      @ipcon.add_device self
    end

    # Returns the acceleration in x, y and z direction. The values
    # are given in gₙ/10000 (1gₙ = 9.80665m/s²). The range is
    # configured with BrickletAccelerometerV2#set_configuration.
    # 
    # If you want to get the acceleration periodically, it is recommended
    # to use the CALLBACK_ACCELERATION callback and set the period with
    # BrickletAccelerometerV2#set_acceleration_callback_configuration.
    def get_acceleration
      check_validity

      send_request FUNCTION_GET_ACCELERATION, [], '', 20, 'l l l'
    end

    # Configures the data rate and full scale range.
    # Possible values are:
    # 
    # * Data rate of 0.781Hz to 25600Hz.
    # * Full scale range of ±2g up to ±8g.
    # 
    # Decreasing data rate or full scale range will also decrease the noise on
    # the data.
    def set_configuration(data_rate, full_scale)
      check_validity

      send_request FUNCTION_SET_CONFIGURATION, [data_rate, full_scale], 'C C', 8, ''
    end

    # Returns the configuration as set by BrickletAccelerometerV2#set_configuration.
    def get_configuration
      check_validity

      send_request FUNCTION_GET_CONFIGURATION, [], '', 10, 'C C'
    end

    # The period is the period with which the CALLBACK_ACCELERATION
    # callback is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # If this callback is enabled, the CALLBACK_CONTINUOUS_ACCELERATION_16_BIT callback
    # and CALLBACK_CONTINUOUS_ACCELERATION_8_BIT callback will automatically be disabled.
    def set_acceleration_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletAccelerometerV2#set_acceleration_callback_configuration.
    def get_acceleration_callback_configuration
      check_validity

      send_request FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # Configures the info LED (marked as "Force" on the Bricklet) to be either turned off,
    # turned on, or blink in heartbeat mode.
    def set_info_led_config(config)
      check_validity

      send_request FUNCTION_SET_INFO_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletAccelerometerV2#set_info_led_config
    def get_info_led_config
      check_validity

      send_request FUNCTION_GET_INFO_LED_CONFIG, [], '', 9, 'C'
    end

    # For high throughput of acceleration data (> 1000Hz) you have to use the
    # CALLBACK_CONTINUOUS_ACCELERATION_16_BIT or CALLBACK_CONTINUOUS_ACCELERATION_8_BIT
    # callbacks.
    # 
    # You can enable the callback for each axis (x, y, z) individually and choose a
    # resolution of 8 bit or 16 bit.
    # 
    # If at least one of the axis is enabled and the resolution is set to 8 bit,
    # the CALLBACK_CONTINUOUS_ACCELERATION_8_BIT callback is activated. If at least
    # one of the axis is enabled and the resolution is set to 16 bit,
    # the CALLBACK_CONTINUOUS_ACCELERATION_16_BIT callback is activated.
    # 
    # The returned values are raw ADC data. If you want to put this data into
    # a FFT to determine the occurrences of specific frequencies we recommend
    # that you use the data as is. It has all of the ADC noise in it. This noise
    # looks like pure noise at first glance, but it might still have some frequnecy
    # information in it that can be utilized by the FFT.
    # 
    # Otherwise you have to use the following formulas that depend on the configured
    # resolution (8/16 bit) and the full scale range (see BrickletAccelerometerV2#set_configuration) to calculate
    # the data in gₙ/10000 (same unit that is returned by BrickletAccelerometerV2#get_acceleration):
    # 
    # * 16 bit, full scale 2g: acceleration = value * 625 / 1024
    # * 16 bit, full scale 4g: acceleration = value * 1250 / 1024
    # * 16 bit, full scale 8g: acceleration = value * 2500 / 1024
    # 
    # If a resolution of 8 bit is used, only the 8 most significant bits will be
    # transferred, so you can use the following formulas:
    # 
    # * 8 bit, full scale 2g: acceleration = value * 256 * 625 / 1024
    # * 8 bit, full scale 4g: acceleration = value * 256 * 1250 / 1024
    # * 8 bit, full scale 8g: acceleration = value * 256 * 2500 / 1024
    # 
    # If no axis is enabled, both callbacks are disabled. If one of the continuous
    # callbacks is enabled, the CALLBACK_ACCELERATION callback is disabled.
    # 
    # The maximum throughput depends on the exact configuration:
    # 
    #  "Number of axis enabled", "Throughput 8 bit", "Throughout 16 bit"
    # 
    #  "1", "25600Hz", "25600Hz"
    #  "2", "25600Hz", "15000Hz"
    #  "3", "20000Hz", "10000Hz"
    def set_continuous_acceleration_configuration(enable_x, enable_y, enable_z, resolution)
      check_validity

      send_request FUNCTION_SET_CONTINUOUS_ACCELERATION_CONFIGURATION, [enable_x, enable_y, enable_z, resolution], '? ? ? C', 8, ''
    end

    # Returns the continuous acceleration configuration as set by
    # BrickletAccelerometerV2#set_continuous_acceleration_configuration.
    def get_continuous_acceleration_configuration
      check_validity

      send_request FUNCTION_GET_CONTINUOUS_ACCELERATION_CONFIGURATION, [], '', 12, '? ? ? C'
    end

    # Configures IIR Bypass filter mode and low pass filter roll off corner frequency.
    # 
    # The filter can be applied or bypassed and the corner frequency can be
    # half or a ninth of the output data rate.
    # 
    # .. image:: /Images/Bricklets/bricklet_accelerometer_v2_filter.png
    #    :scale: 100 %
    #    :alt: Accelerometer filter
    #    :align: center
    #    :target: ../../_images/Bricklets/bricklet_accelerometer_v2_filter.png
    # 
    # .. versionadded:: 2.0.2$nbsp;(Plugin)
    def set_filter_configuration(iir_bypass, low_pass_filter)
      check_validity

      send_request FUNCTION_SET_FILTER_CONFIGURATION, [iir_bypass, low_pass_filter], 'C C', 8, ''
    end

    # Returns the configuration as set by BrickletAccelerometerV2#set_filter_configuration.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Plugin)
    def get_filter_configuration
      check_validity

      send_request FUNCTION_GET_FILTER_CONFIGURATION, [], '', 10, 'C C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletAccelerometerV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletAccelerometerV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletAccelerometerV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletAccelerometerV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
