# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures DC voltage between 0V and 45V
  class BrickletAnalogIn < Device
    DEVICE_IDENTIFIER = 219 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Analog In Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletAnalogIn#set_voltage_callback_period. The parameter is the voltage of the
    # sensor.
    # 
    # The CALLBACK_VOLTAGE callback is only triggered if the voltage has changed since
    # the last triggering.
    CALLBACK_VOLTAGE = 13

    # This callback is triggered periodically with the period that is set by
    # BrickletAnalogIn#set_analog_value_callback_period. The parameter is the analog
    # value of the sensor.
    # 
    # The CALLBACK_ANALOG_VALUE callback is only triggered if the voltage has changed
    # since the last triggering.
    CALLBACK_ANALOG_VALUE = 14

    # This callback is triggered when the threshold as set by
    # BrickletAnalogIn#set_voltage_callback_threshold is reached.
    # The parameter is the voltage of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletAnalogIn#set_debounce_period.
    CALLBACK_VOLTAGE_REACHED = 15

    # This callback is triggered when the threshold as set by
    # BrickletAnalogIn#set_analog_value_callback_threshold is reached.
    # The parameter is the analog value of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletAnalogIn#set_debounce_period.
    CALLBACK_ANALOG_VALUE_REACHED = 16

    FUNCTION_GET_VOLTAGE = 1 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE = 2 # :nodoc:
    FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 4 # :nodoc:
    FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6 # :nodoc:
    FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 7 # :nodoc:
    FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 8 # :nodoc:
    FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 11 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 12 # :nodoc:
    FUNCTION_SET_RANGE = 17 # :nodoc:
    FUNCTION_GET_RANGE = 18 # :nodoc:
    FUNCTION_SET_AVERAGING = 19 # :nodoc:
    FUNCTION_GET_AVERAGING = 20 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    RANGE_AUTOMATIC = 0 # :nodoc:
    RANGE_UP_TO_6V = 1 # :nodoc:
    RANGE_UP_TO_10V = 2 # :nodoc:
    RANGE_UP_TO_36V = 3 # :nodoc:
    RANGE_UP_TO_45V = 4 # :nodoc:
    RANGE_UP_TO_3V = 5 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 3]

      @response_expected[FUNCTION_GET_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RANGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RANGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_AVERAGING] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_AVERAGING] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_VOLTAGE] = [10, 'S']
      @callback_formats[CALLBACK_ANALOG_VALUE] = [10, 'S']
      @callback_formats[CALLBACK_VOLTAGE_REACHED] = [10, 'S']
      @callback_formats[CALLBACK_ANALOG_VALUE_REACHED] = [10, 'S']

      @ipcon.add_device self
    end

    # Returns the voltage of the sensor. The resolution between 0 and 6V is about 2mV.
    # Between 6 and 45V the resolution is about 10mV.
    # 
    # If you want to get the voltage periodically, it is recommended to use the
    # CALLBACK_VOLTAGE callback and set the period with
    # BrickletAnalogIn#set_voltage_callback_period.
    def get_voltage
      check_validity

      send_request FUNCTION_GET_VOLTAGE, [], '', 10, 'S'
    end

    # Returns the value as read by a 12-bit analog-to-digital converter.
    # 
    # .. note::
    #  The value returned by BrickletAnalogIn#get_voltage is averaged over several samples
    #  to yield less noise, while BrickletAnalogIn#get_analog_value gives back raw
    #  unfiltered analog values. The only reason to use BrickletAnalogIn#get_analog_value is,
    #  if you need the full resolution of the analog-to-digital converter.
    # 
    # If you want the analog value periodically, it is recommended to use the
    # CALLBACK_ANALOG_VALUE callback and set the period with
    # BrickletAnalogIn#set_analog_value_callback_period.
    def get_analog_value
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE, [], '', 10, 'S'
    end

    # Sets the period with which the CALLBACK_VOLTAGE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_VOLTAGE callback is only triggered if the voltage has changed since
    # the last triggering.
    def set_voltage_callback_period(period)
      check_validity

      send_request FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletAnalogIn#set_voltage_callback_period.
    def get_voltage_callback_period
      check_validity

      send_request FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ANALOG_VALUE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_ANALOG_VALUE callback is only triggered if the analog value has
    # changed since the last triggering.
    def set_analog_value_callback_period(period)
      check_validity

      send_request FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletAnalogIn#set_analog_value_callback_period.
    def get_analog_value_callback_period
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the thresholds for the CALLBACK_VOLTAGE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the voltage is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the voltage is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the voltage is greater than the min value (max is ignored)"
    def set_voltage_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 8, ''
    end

    # Returns the threshold as set by BrickletAnalogIn#set_voltage_callback_threshold.
    def get_voltage_callback_threshold
      check_validity

      send_request FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, [], '', 13, 'k S S'
    end

    # Sets the thresholds for the CALLBACK_ANALOG_VALUE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
    def set_analog_value_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 8, ''
    end

    # Returns the threshold as set by BrickletAnalogIn#set_analog_value_callback_threshold.
    def get_analog_value_callback_threshold
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, [], '', 13, 'k S S'
    end

    # Sets the period with which the threshold callbacks
    # 
    # * CALLBACK_VOLTAGE_REACHED,
    # * CALLBACK_ANALOG_VALUE_REACHED
    # 
    # are triggered, if the thresholds
    # 
    # * BrickletAnalogIn#set_voltage_callback_threshold,
    # * BrickletAnalogIn#set_analog_value_callback_threshold
    # 
    # keep being reached.
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickletAnalogIn#set_debounce_period.
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Sets the measurement range. Possible ranges:
    # 
    # * 0: Automatically switched
    # * 1: 0V - 6.05V, ~1.48mV resolution
    # * 2: 0V - 10.32V, ~2.52mV resolution
    # * 3: 0V - 36.30V, ~8.86mV resolution
    # * 4: 0V - 45.00V, ~11.25mV resolution
    # * 5: 0V - 3.3V, ~0.81mV resolution, new in version 2.0.3$nbsp;(Plugin)
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def set_range(range)
      check_validity

      send_request FUNCTION_SET_RANGE, [range], 'C', 8, ''
    end

    # Returns the measurement range as set by BrickletAnalogIn#set_range.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def get_range
      check_validity

      send_request FUNCTION_GET_RANGE, [], '', 9, 'C'
    end

    # Set the length of a averaging for the voltage value.
    # 
    # Setting the length to 0 will turn the averaging completely off. If the
    # averaging is off, there is more noise on the data, but the data is without
    # delay.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def set_averaging(average)
      check_validity

      send_request FUNCTION_SET_AVERAGING, [average], 'C', 8, ''
    end

    # Returns the averaging configuration as set by BrickletAnalogIn#set_averaging.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def get_averaging
      check_validity

      send_request FUNCTION_GET_AVERAGING, [], '', 9, 'C'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
