# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Generates configurable DC voltage between 0V and 12V
  class BrickletAnalogOutV2 < Device
    DEVICE_IDENTIFIER = 256 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Analog Out Bricklet 2.0' # :nodoc:

    FUNCTION_SET_OUTPUT_VOLTAGE = 1 # :nodoc:
    FUNCTION_GET_OUTPUT_VOLTAGE = 2 # :nodoc:
    FUNCTION_GET_INPUT_VOLTAGE = 3 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:


    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_OUTPUT_VOLTAGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_OUTPUT_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_INPUT_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE


      @ipcon.add_device self
    end

    # Sets the voltage.
    def set_output_voltage(voltage)
      check_validity

      send_request FUNCTION_SET_OUTPUT_VOLTAGE, [voltage], 'S', 8, ''
    end

    # Returns the voltage as set by BrickletAnalogOutV2#set_output_voltage.
    def get_output_voltage
      check_validity

      send_request FUNCTION_GET_OUTPUT_VOLTAGE, [], '', 10, 'S'
    end

    # Returns the input voltage.
    def get_input_voltage
      check_validity

      send_request FUNCTION_GET_INPUT_VOLTAGE, [], '', 10, 'S'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

  end
end
