# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures air pressure and altitude changes
  class BrickletBarometerV2 < Device
    DEVICE_IDENTIFIER = 2117 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Barometer Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletBarometerV2#set_air_pressure_callback_configuration.
    # 
    # The parameter is the same as BrickletBarometerV2#get_air_pressure.
    CALLBACK_AIR_PRESSURE = 4

    # This callback is triggered periodically according to the configuration set by
    # BrickletBarometerV2#set_altitude_callback_configuration.
    # 
    # The parameter is the same as BrickletBarometerV2#get_altitude.
    CALLBACK_ALTITUDE = 8

    # This callback is triggered periodically according to the configuration set by
    # BrickletBarometerV2#set_temperature_callback_configuration.
    # 
    # The parameter is the same as BrickletBarometerV2#get_temperature.
    CALLBACK_TEMPERATURE = 12

    FUNCTION_GET_AIR_PRESSURE = 1 # :nodoc:
    FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_GET_ALTITUDE = 5 # :nodoc:
    FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_GET_TEMPERATURE = 9 # :nodoc:
    FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = 10 # :nodoc:
    FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = 11 # :nodoc:
    FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION = 13 # :nodoc:
    FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION = 14 # :nodoc:
    FUNCTION_SET_REFERENCE_AIR_PRESSURE = 15 # :nodoc:
    FUNCTION_GET_REFERENCE_AIR_PRESSURE = 16 # :nodoc:
    FUNCTION_SET_CALIBRATION = 17 # :nodoc:
    FUNCTION_GET_CALIBRATION = 18 # :nodoc:
    FUNCTION_SET_SENSOR_CONFIGURATION = 19 # :nodoc:
    FUNCTION_GET_SENSOR_CONFIGURATION = 20 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    DATA_RATE_OFF = 0 # :nodoc:
    DATA_RATE_1HZ = 1 # :nodoc:
    DATA_RATE_10HZ = 2 # :nodoc:
    DATA_RATE_25HZ = 3 # :nodoc:
    DATA_RATE_50HZ = 4 # :nodoc:
    DATA_RATE_75HZ = 5 # :nodoc:
    LOW_PASS_FILTER_OFF = 0 # :nodoc:
    LOW_PASS_FILTER_1_9TH = 1 # :nodoc:
    LOW_PASS_FILTER_1_20TH = 2 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_AIR_PRESSURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALTITUDE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_REFERENCE_AIR_PRESSURE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_REFERENCE_AIR_PRESSURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CALIBRATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SENSOR_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_AIR_PRESSURE] = [12, 'l']
      @callback_formats[CALLBACK_ALTITUDE] = [12, 'l']
      @callback_formats[CALLBACK_TEMPERATURE] = [12, 'l']

      @ipcon.add_device self
    end

    # Returns the measured air pressure.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_AIR_PRESSURE callback. You can set the callback configuration
    # with BrickletBarometerV2#set_air_pressure_callback_configuration.
    def get_air_pressure
      check_validity

      send_request FUNCTION_GET_AIR_PRESSURE, [], '', 12, 'l'
    end

    # The period is the period with which the CALLBACK_AIR_PRESSURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_AIR_PRESSURE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_air_pressure_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k l l', 8, ''
    end

    # Returns the callback configuration as set by BrickletBarometerV2#set_air_pressure_callback_configuration.
    def get_air_pressure_callback_configuration
      check_validity

      send_request FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION, [], '', 22, 'L ? k l l'
    end

    # Returns the relative altitude of the air pressure sensor. The value
    # is calculated based on the difference between the
    # current air pressure and the reference air pressure that can be set
    # with BrickletBarometerV2#set_reference_air_pressure.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_ALTITUDE callback. You can set the callback configuration
    # with BrickletBarometerV2#set_altitude_callback_configuration.
    def get_altitude
      check_validity

      send_request FUNCTION_GET_ALTITUDE, [], '', 12, 'l'
    end

    # The period is the period with which the CALLBACK_ALTITUDE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_ALTITUDE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_altitude_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k l l', 8, ''
    end

    # Returns the callback configuration as set by BrickletBarometerV2#set_altitude_callback_configuration.
    def get_altitude_callback_configuration
      check_validity

      send_request FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION, [], '', 22, 'L ? k l l'
    end

    # Returns the temperature of the air pressure sensor.
    # 
    # This temperature is used internally for temperature compensation
    # of the air pressure measurement. It is not as accurate as the
    # temperature measured by the :ref:`temperature_v2_bricklet` or the
    # :ref:`temperature_ir_v2_bricklet`.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_TEMPERATURE callback. You can set the callback configuration
    # with BrickletBarometerV2#set_temperature_callback_configuration.
    def get_temperature
      check_validity

      send_request FUNCTION_GET_TEMPERATURE, [], '', 12, 'l'
    end

    # The period is the period with which the CALLBACK_TEMPERATURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_TEMPERATURE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_temperature_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k l l', 8, ''
    end

    # Returns the callback configuration as set by BrickletBarometerV2#set_temperature_callback_configuration.
    def get_temperature_callback_configuration
      check_validity

      send_request FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, [], '', 22, 'L ? k l l'
    end

    # Sets the length of a `moving averaging <https://en.wikipedia.org/wiki/Moving_average>`__
    # for the air pressure and temperature measurements.
    # 
    # Setting the length to 1 will turn the averaging off. With less
    # averaging, there is more noise on the data.
    # 
    # If you want to do long term measurements the longest moving average will give
    # the cleanest results.
    def set_moving_average_configuration(moving_average_length_air_pressure, moving_average_length_temperature)
      check_validity

      send_request FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION, [moving_average_length_air_pressure, moving_average_length_temperature], 'S S', 8, ''
    end

    # Returns the moving average configuration as set by
    # BrickletBarometerV2#set_moving_average_configuration.
    def get_moving_average_configuration
      check_validity

      send_request FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION, [], '', 12, 'S S'
    end

    # Sets the reference air pressure for the altitude calculation.
    # Setting the reference to the
    # current air pressure results in a calculated altitude of 0mm. Passing 0 is
    # a shortcut for passing the current air pressure as reference.
    # 
    # Well known reference values are the Q codes
    # `QNH <https://en.wikipedia.org/wiki/QNH>`__ and
    # `QFE <https://en.wikipedia.org/wiki/Mean_sea_level_pressure#Mean_sea_level_pressure>`__
    # used in aviation.
    def set_reference_air_pressure(air_pressure)
      check_validity

      send_request FUNCTION_SET_REFERENCE_AIR_PRESSURE, [air_pressure], 'l', 8, ''
    end

    # Returns the reference air pressure as set by BrickletBarometerV2#set_reference_air_pressure.
    def get_reference_air_pressure
      check_validity

      send_request FUNCTION_GET_REFERENCE_AIR_PRESSURE, [], '', 12, 'l'
    end

    # Sets the one point calibration (OPC) values for the air pressure measurement.
    # 
    # Before the Bricklet can be calibrated any previous calibration has to be removed
    # by setting ``measured air pressure`` and ``actual air pressure`` to 0.
    # 
    # Then the current air pressure has to be measured using the Bricklet
    # (``measured air pressure``) and with an accurate reference barometer
    # (``actual air pressure``) at the same time and passed to this function.
    # 
    # After proper calibration the air pressure measurement can achieve an accuracy
    # up to 0.2 hPa.
    # 
    # The calibration is saved in the EEPROM of the Bricklet and only needs to be
    # configured once.
    def set_calibration(measured_air_pressure, actual_air_pressure)
      check_validity

      send_request FUNCTION_SET_CALIBRATION, [measured_air_pressure, actual_air_pressure], 'l l', 8, ''
    end

    # Returns the air pressure one point calibration values as set by
    # BrickletBarometerV2#set_calibration.
    def get_calibration
      check_validity

      send_request FUNCTION_GET_CALIBRATION, [], '', 16, 'l l'
    end

    # Configures the data rate and air pressure low pass filter. The low pass filter
    # cut-off frequency (if enabled) can be set to 1/9th or 1/20th of the configure
    # data rate to decrease the noise on the air pressure data.
    # 
    # The low pass filter configuration only applies to the air pressure measurement.
    # There is no low pass filter for the temperature measurement.
    # 
    # A higher data rate will result in a less precise temperature because of
    # self-heating of the sensor. If the accuracy of the temperature reading is
    # important to you, we would recommend the 1Hz data rate.
    def set_sensor_configuration(data_rate, air_pressure_low_pass_filter)
      check_validity

      send_request FUNCTION_SET_SENSOR_CONFIGURATION, [data_rate, air_pressure_low_pass_filter], 'C C', 8, ''
    end

    # Returns the sensor configuration as set by BrickletBarometerV2#set_sensor_configuration.
    def get_sensor_configuration
      check_validity

      send_request FUNCTION_GET_SENSOR_CONFIGURATION, [], '', 10, 'C C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletBarometerV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletBarometerV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletBarometerV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletBarometerV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
