# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures color (RGB value), illuminance and color temperature
  class BrickletColor < Device
    DEVICE_IDENTIFIER = 243 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Color Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletColor#set_color_callback_period. The parameter is the color
    # of the sensor as RGBC.
    # 
    # The CALLBACK_COLOR callback is only triggered if the color has changed since the
    # last triggering.
    CALLBACK_COLOR = 8

    # This callback is triggered when the threshold as set by
    # BrickletColor#set_color_callback_threshold is reached.
    # The parameter is the color
    # of the sensor as RGBC.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletColor#set_debounce_period.
    CALLBACK_COLOR_REACHED = 9

    # This callback is triggered periodically with the period that is set by
    # BrickletColor#set_illuminance_callback_period. The parameter is the illuminance.
    # See BrickletColor#get_illuminance for how to interpret this value.
    # 
    # The CALLBACK_ILLUMINANCE callback is only triggered if the illuminance has changed
    # since the last triggering.
    CALLBACK_ILLUMINANCE = 21

    # This callback is triggered periodically with the period that is set by
    # BrickletColor#set_color_temperature_callback_period. The parameter is the
    # color temperature.
    # 
    # The CALLBACK_COLOR_TEMPERATURE callback is only triggered if the color temperature
    # has changed since the last triggering.
    CALLBACK_COLOR_TEMPERATURE = 22

    FUNCTION_GET_COLOR = 1 # :nodoc:
    FUNCTION_SET_COLOR_CALLBACK_PERIOD = 2 # :nodoc:
    FUNCTION_GET_COLOR_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_SET_COLOR_CALLBACK_THRESHOLD = 4 # :nodoc:
    FUNCTION_GET_COLOR_CALLBACK_THRESHOLD = 5 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 6 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 7 # :nodoc:
    FUNCTION_LIGHT_ON = 10 # :nodoc:
    FUNCTION_LIGHT_OFF = 11 # :nodoc:
    FUNCTION_IS_LIGHT_ON = 12 # :nodoc:
    FUNCTION_SET_CONFIG = 13 # :nodoc:
    FUNCTION_GET_CONFIG = 14 # :nodoc:
    FUNCTION_GET_ILLUMINANCE = 15 # :nodoc:
    FUNCTION_GET_COLOR_TEMPERATURE = 16 # :nodoc:
    FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD = 17 # :nodoc:
    FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD = 18 # :nodoc:
    FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_PERIOD = 19 # :nodoc:
    FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_PERIOD = 20 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    LIGHT_ON = 0 # :nodoc:
    LIGHT_OFF = 1 # :nodoc:
    GAIN_1X = 0 # :nodoc:
    GAIN_4X = 1 # :nodoc:
    GAIN_16X = 2 # :nodoc:
    GAIN_60X = 3 # :nodoc:
    INTEGRATION_TIME_2MS = 0 # :nodoc:
    INTEGRATION_TIME_24MS = 1 # :nodoc:
    INTEGRATION_TIME_101MS = 2 # :nodoc:
    INTEGRATION_TIME_154MS = 3 # :nodoc:
    INTEGRATION_TIME_700MS = 4 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_COLOR] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COLOR_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_COLOR_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COLOR_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_COLOR_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_LIGHT_ON] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_LIGHT_OFF] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_LIGHT_ON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ILLUMINANCE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_COLOR_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_COLOR] = [16, 'S S S S']
      @callback_formats[CALLBACK_COLOR_REACHED] = [16, 'S S S S']
      @callback_formats[CALLBACK_ILLUMINANCE] = [12, 'L']
      @callback_formats[CALLBACK_COLOR_TEMPERATURE] = [10, 'S']

      @ipcon.add_device self
    end

    # Returns the measured color of the sensor.
    # 
    # The red (r), green (g), blue (b) and clear (c) colors are measured
    # with four different photodiodes that are responsive at different
    # wavelengths:
    # 
    # .. image:: /Images/Bricklets/bricklet_color_wavelength_chart_600.jpg
    #    :scale: 100 %
    #    :alt: Chart Responsivity / Wavelength
    #    :align: center
    #    :target: ../../_images/Bricklets/bricklet_color_wavelength_chart_600.jpg
    # 
    # If you want to get the color periodically, it is recommended
    # to use the CALLBACK_COLOR callback and set the period with
    # BrickletColor#set_color_callback_period.
    def get_color
      check_validity

      send_request FUNCTION_GET_COLOR, [], '', 16, 'S S S S'
    end

    # Sets the period with which the CALLBACK_COLOR callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_COLOR callback is only triggered if the color has changed since the
    # last triggering.
    def set_color_callback_period(period)
      check_validity

      send_request FUNCTION_SET_COLOR_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletColor#set_color_callback_period.
    def get_color_callback_period
      check_validity

      send_request FUNCTION_GET_COLOR_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the thresholds for the CALLBACK_COLOR_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
    def set_color_callback_threshold(option, min_r, max_r, min_g, max_g, min_b, max_b, min_c, max_c)
      check_validity

      send_request FUNCTION_SET_COLOR_CALLBACK_THRESHOLD, [option, min_r, max_r, min_g, max_g, min_b, max_b, min_c, max_c], 'k S S S S S S S S', 8, ''
    end

    # Returns the threshold as set by BrickletColor#set_color_callback_threshold.
    def get_color_callback_threshold
      check_validity

      send_request FUNCTION_GET_COLOR_CALLBACK_THRESHOLD, [], '', 25, 'k S S S S S S S S'
    end

    # Sets the period with which the threshold callback
    # 
    # * CALLBACK_COLOR_REACHED
    # 
    # is triggered, if the threshold
    # 
    # * BrickletColor#set_color_callback_threshold
    # 
    # keeps being reached.
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickletColor#set_debounce_period.
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Turns the LED on.
    def light_on
      check_validity

      send_request FUNCTION_LIGHT_ON, [], '', 8, ''
    end

    # Turns the LED off.
    def light_off
      check_validity

      send_request FUNCTION_LIGHT_OFF, [], '', 8, ''
    end

    # Returns the state of the LED. Possible values are:
    # 
    # * 0: On
    # * 1: Off
    def is_light_on
      check_validity

      send_request FUNCTION_IS_LIGHT_ON, [], '', 9, 'C'
    end

    # Sets the configuration of the sensor. Gain and integration time
    # can be configured in this way.
    # 
    # For configuring the gain:
    # 
    # * 0: 1x Gain
    # * 1: 4x Gain
    # * 2: 16x Gain
    # * 3: 60x Gain
    # 
    # For configuring the integration time:
    # 
    # * 0: 2.4ms
    # * 1: 24ms
    # * 2: 101ms
    # * 3: 154ms
    # * 4: 700ms
    # 
    # Increasing the gain enables the sensor to detect a
    # color from a higher distance.
    # 
    # The integration time provides a trade-off between conversion time
    # and accuracy. With a longer integration time the values read will
    # be more accurate but it will take longer time to get the conversion
    # results.
    def set_config(gain, integration_time)
      check_validity

      send_request FUNCTION_SET_CONFIG, [gain, integration_time], 'C C', 8, ''
    end

    # Returns the configuration as set by BrickletColor#set_config.
    def get_config
      check_validity

      send_request FUNCTION_GET_CONFIG, [], '', 10, 'C C'
    end

    # Returns the illuminance affected by the gain and integration time as
    # set by BrickletColor#set_config. To get the illuminance in Lux apply this formula::
    # 
    #  lux = illuminance * 700 / gain / integration_time
    # 
    # To get a correct illuminance measurement make sure that the color
    # values themselves are not saturated. The color value (R, G or B)
    # is saturated if it is equal to the maximum value of 65535.
    # In that case you have to reduce the gain, see BrickletColor#set_config.
    def get_illuminance
      check_validity

      send_request FUNCTION_GET_ILLUMINANCE, [], '', 12, 'L'
    end

    # Returns the color temperature.
    # 
    # To get a correct color temperature measurement make sure that the color
    # values themselves are not saturated. The color value (R, G or B)
    # is saturated if it is equal to the maximum value of 65535.
    # In that case you have to reduce the gain, see BrickletColor#set_config.
    def get_color_temperature
      check_validity

      send_request FUNCTION_GET_COLOR_TEMPERATURE, [], '', 10, 'S'
    end

    # Sets the period with which the CALLBACK_ILLUMINANCE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_ILLUMINANCE callback is only triggered if the illuminance has changed
    # since the last triggering.
    def set_illuminance_callback_period(period)
      check_validity

      send_request FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletColor#set_illuminance_callback_period.
    def get_illuminance_callback_period
      check_validity

      send_request FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_COLOR_TEMPERATURE callback is
    # triggered periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_COLOR_TEMPERATURE callback is only triggered if the color temperature
    # has changed since the last triggering.
    def set_color_temperature_callback_period(period)
      check_validity

      send_request FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletColor#set_color_temperature_callback_period.
    def get_color_temperature_callback_period
      check_validity

      send_request FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
