# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Full fledged AHRS with 9 degrees of freedom
  class BrickletIMUV3 < Device
    DEVICE_IDENTIFIER = 2161 # :nodoc:
    DEVICE_DISPLAY_NAME = 'IMU Bricklet 3.0' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_acceleration_callback_configuration. The parameters are the acceleration
    # for the x, y and z axis.
    CALLBACK_ACCELERATION = 33

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_magnetic_field_callback_configuration. The parameters are the magnetic
    # field for the x, y and z axis.
    CALLBACK_MAGNETIC_FIELD = 34

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_angular_velocity_callback_configuration. The parameters are the angular
    # velocity for the x, y and z axis.
    CALLBACK_ANGULAR_VELOCITY = 35

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_temperature_callback_configuration. The parameter is the temperature.
    CALLBACK_TEMPERATURE = 36

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_linear_acceleration_callback_configuration. The parameters are the
    # linear acceleration for the x, y and z axis.
    CALLBACK_LINEAR_ACCELERATION = 37

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_gravity_vector_callback_configuration. The parameters gravity vector
    # for the x, y and z axis.
    CALLBACK_GRAVITY_VECTOR = 38

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_orientation_callback_configuration. The parameters are the orientation
    # (heading (yaw), roll, pitch) of the IMU Brick in Euler angles. See
    # BrickletIMUV3#get_orientation for details.
    CALLBACK_ORIENTATION = 39

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_quaternion_callback_configuration. The parameters are the orientation
    # (w, x, y, z) of the IMU Brick in quaternions. See BrickletIMUV3#get_quaternion
    # for details.
    CALLBACK_QUATERNION = 40

    # This callback is triggered periodically with the period that is set by
    # BrickletIMUV3#set_all_data_callback_configuration. The parameters are as for
    # BrickletIMUV3#get_all_data.
    CALLBACK_ALL_DATA = 41

    FUNCTION_GET_ACCELERATION = 1 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD = 2 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY = 3 # :nodoc:
    FUNCTION_GET_TEMPERATURE = 4 # :nodoc:
    FUNCTION_GET_ORIENTATION = 5 # :nodoc:
    FUNCTION_GET_LINEAR_ACCELERATION = 6 # :nodoc:
    FUNCTION_GET_GRAVITY_VECTOR = 7 # :nodoc:
    FUNCTION_GET_QUATERNION = 8 # :nodoc:
    FUNCTION_GET_ALL_DATA = 9 # :nodoc:
    FUNCTION_SAVE_CALIBRATION = 10 # :nodoc:
    FUNCTION_SET_SENSOR_CONFIGURATION = 11 # :nodoc:
    FUNCTION_GET_SENSOR_CONFIGURATION = 12 # :nodoc:
    FUNCTION_SET_SENSOR_FUSION_MODE = 13 # :nodoc:
    FUNCTION_GET_SENSOR_FUSION_MODE = 14 # :nodoc:
    FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION = 15 # :nodoc:
    FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION = 16 # :nodoc:
    FUNCTION_SET_MAGNETIC_FIELD_CALLBACK_CONFIGURATION = 17 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD_CALLBACK_CONFIGURATION = 18 # :nodoc:
    FUNCTION_SET_ANGULAR_VELOCITY_CALLBACK_CONFIGURATION = 19 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY_CALLBACK_CONFIGURATION = 20 # :nodoc:
    FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = 21 # :nodoc:
    FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = 22 # :nodoc:
    FUNCTION_SET_ORIENTATION_CALLBACK_CONFIGURATION = 23 # :nodoc:
    FUNCTION_GET_ORIENTATION_CALLBACK_CONFIGURATION = 24 # :nodoc:
    FUNCTION_SET_LINEAR_ACCELERATION_CALLBACK_CONFIGURATION = 25 # :nodoc:
    FUNCTION_GET_LINEAR_ACCELERATION_CALLBACK_CONFIGURATION = 26 # :nodoc:
    FUNCTION_SET_GRAVITY_VECTOR_CALLBACK_CONFIGURATION = 27 # :nodoc:
    FUNCTION_GET_GRAVITY_VECTOR_CALLBACK_CONFIGURATION = 28 # :nodoc:
    FUNCTION_SET_QUATERNION_CALLBACK_CONFIGURATION = 29 # :nodoc:
    FUNCTION_GET_QUATERNION_CALLBACK_CONFIGURATION = 30 # :nodoc:
    FUNCTION_SET_ALL_DATA_CALLBACK_CONFIGURATION = 31 # :nodoc:
    FUNCTION_GET_ALL_DATA_CALLBACK_CONFIGURATION = 32 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    MAGNETOMETER_RATE_2HZ = 0 # :nodoc:
    MAGNETOMETER_RATE_6HZ = 1 # :nodoc:
    MAGNETOMETER_RATE_8HZ = 2 # :nodoc:
    MAGNETOMETER_RATE_10HZ = 3 # :nodoc:
    MAGNETOMETER_RATE_15HZ = 4 # :nodoc:
    MAGNETOMETER_RATE_20HZ = 5 # :nodoc:
    MAGNETOMETER_RATE_25HZ = 6 # :nodoc:
    MAGNETOMETER_RATE_30HZ = 7 # :nodoc:
    GYROSCOPE_RANGE_2000DPS = 0 # :nodoc:
    GYROSCOPE_RANGE_1000DPS = 1 # :nodoc:
    GYROSCOPE_RANGE_500DPS = 2 # :nodoc:
    GYROSCOPE_RANGE_250DPS = 3 # :nodoc:
    GYROSCOPE_RANGE_125DPS = 4 # :nodoc:
    GYROSCOPE_BANDWIDTH_523HZ = 0 # :nodoc:
    GYROSCOPE_BANDWIDTH_230HZ = 1 # :nodoc:
    GYROSCOPE_BANDWIDTH_116HZ = 2 # :nodoc:
    GYROSCOPE_BANDWIDTH_47HZ = 3 # :nodoc:
    GYROSCOPE_BANDWIDTH_23HZ = 4 # :nodoc:
    GYROSCOPE_BANDWIDTH_12HZ = 5 # :nodoc:
    GYROSCOPE_BANDWIDTH_64HZ = 6 # :nodoc:
    GYROSCOPE_BANDWIDTH_32HZ = 7 # :nodoc:
    ACCELEROMETER_RANGE_2G = 0 # :nodoc:
    ACCELEROMETER_RANGE_4G = 1 # :nodoc:
    ACCELEROMETER_RANGE_8G = 2 # :nodoc:
    ACCELEROMETER_RANGE_16G = 3 # :nodoc:
    ACCELEROMETER_BANDWIDTH_7_81HZ = 0 # :nodoc:
    ACCELEROMETER_BANDWIDTH_15_63HZ = 1 # :nodoc:
    ACCELEROMETER_BANDWIDTH_31_25HZ = 2 # :nodoc:
    ACCELEROMETER_BANDWIDTH_62_5HZ = 3 # :nodoc:
    ACCELEROMETER_BANDWIDTH_125HZ = 4 # :nodoc:
    ACCELEROMETER_BANDWIDTH_250HZ = 5 # :nodoc:
    ACCELEROMETER_BANDWIDTH_500HZ = 6 # :nodoc:
    ACCELEROMETER_BANDWIDTH_1000HZ = 7 # :nodoc:
    SENSOR_FUSION_OFF = 0 # :nodoc:
    SENSOR_FUSION_ON = 1 # :nodoc:
    SENSOR_FUSION_ON_WITHOUT_MAGNETOMETER = 2 # :nodoc:
    SENSOR_FUSION_ON_WITHOUT_FAST_MAGNETOMETER_CALIBRATION = 3 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_LINEAR_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_GRAVITY_VECTOR] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_QUATERNION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SAVE_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SENSOR_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_FUSION_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SENSOR_FUSION_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MAGNETIC_FIELD_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANGULAR_VELOCITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ORIENTATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_LINEAR_ACCELERATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_LINEAR_ACCELERATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GRAVITY_VECTOR_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_GRAVITY_VECTOR_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_QUATERNION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_QUATERNION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_DATA_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_ACCELERATION] = [14, 's s s']
      @callback_formats[CALLBACK_MAGNETIC_FIELD] = [14, 's s s']
      @callback_formats[CALLBACK_ANGULAR_VELOCITY] = [14, 's s s']
      @callback_formats[CALLBACK_TEMPERATURE] = [9, 'c']
      @callback_formats[CALLBACK_LINEAR_ACCELERATION] = [14, 's s s']
      @callback_formats[CALLBACK_GRAVITY_VECTOR] = [14, 's s s']
      @callback_formats[CALLBACK_ORIENTATION] = [14, 's s s']
      @callback_formats[CALLBACK_QUATERNION] = [16, 's s s s']
      @callback_formats[CALLBACK_ALL_DATA] = [54, 's3 s3 s3 s3 s4 s3 s3 c C']

      @ipcon.add_device self
    end

    # Returns the calibrated acceleration from the accelerometer for the
    # x, y and z axis. The acceleration is in the range configured with
    # BrickletIMUV3#set_sensor_configuration.
    # 
    # If you want to get the acceleration periodically, it is recommended
    # to use the CALLBACK_ACCELERATION callback and set the period with
    # BrickletIMUV3#set_acceleration_callback_configuration.
    def get_acceleration
      check_validity

      send_request FUNCTION_GET_ACCELERATION, [], '', 14, 's s s'
    end

    # Returns the calibrated magnetic field from the magnetometer for the
    # x, y and z axis.
    # 
    # If you want to get the magnetic field periodically, it is recommended
    # to use the CALLBACK_MAGNETIC_FIELD callback and set the period with
    # BrickletIMUV3#set_magnetic_field_callback_configuration.
    def get_magnetic_field
      check_validity

      send_request FUNCTION_GET_MAGNETIC_FIELD, [], '', 14, 's s s'
    end

    # Returns the calibrated angular velocity from the gyroscope for the
    # x, y and z axis. The angular velocity is in the range configured with
    # BrickletIMUV3#set_sensor_configuration.
    # 
    # If you want to get the angular velocity periodically, it is recommended
    # to use the CALLBACK_ANGULAR_VELOCITY acallback nd set the period with
    # BrickletIMUV3#set_angular_velocity_callback_configuration.
    def get_angular_velocity
      check_validity

      send_request FUNCTION_GET_ANGULAR_VELOCITY, [], '', 14, 's s s'
    end

    # Returns the temperature of the IMU Brick.
    # The temperature is measured in the core of the BNO055 IC, it is not the
    # ambient temperature
    def get_temperature
      check_validity

      send_request FUNCTION_GET_TEMPERATURE, [], '', 9, 'c'
    end

    # Returns the current orientation (heading, roll, pitch) of the IMU Brick as
    # independent Euler angles. Note that Euler angles always
    # experience a `gimbal lock <https://en.wikipedia.org/wiki/Gimbal_lock>`__.
    # We recommend that you use quaternions instead, if you need the absolute
    # orientation.
    # 
    # If you want to get the orientation periodically, it is recommended
    # to use the CALLBACK_ORIENTATION callback and set the period with
    # BrickletIMUV3#set_orientation_callback_configuration.
    def get_orientation
      check_validity

      send_request FUNCTION_GET_ORIENTATION, [], '', 14, 's s s'
    end

    # Returns the linear acceleration of the IMU Brick for the
    # x, y and z axis. The acceleration is in the range configured with
    # BrickletIMUV3#set_sensor_configuration.
    # 
    # The linear acceleration is the acceleration in each of the three
    # axis of the IMU Brick with the influences of gravity removed.
    # 
    # It is also possible to get the gravity vector with the influence of linear
    # acceleration removed, see BrickletIMUV3#get_gravity_vector.
    # 
    # If you want to get the linear acceleration periodically, it is recommended
    # to use the CALLBACK_LINEAR_ACCELERATION callback and set the period with
    # BrickletIMUV3#set_linear_acceleration_callback_configuration.
    def get_linear_acceleration
      check_validity

      send_request FUNCTION_GET_LINEAR_ACCELERATION, [], '', 14, 's s s'
    end

    # Returns the current gravity vector of the IMU Brick for the
    # x, y and z axis.
    # 
    # The gravity vector is the acceleration that occurs due to gravity.
    # Influences of additional linear acceleration are removed.
    # 
    # It is also possible to get the linear acceleration with the influence
    # of gravity removed, see BrickletIMUV3#get_linear_acceleration.
    # 
    # If you want to get the gravity vector periodically, it is recommended
    # to use the CALLBACK_GRAVITY_VECTOR callback and set the period with
    # BrickletIMUV3#set_gravity_vector_callback_configuration.
    def get_gravity_vector
      check_validity

      send_request FUNCTION_GET_GRAVITY_VECTOR, [], '', 14, 's s s'
    end

    # Returns the current orientation (w, x, y, z) of the IMU Brick as
    # `quaternions <https://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation>`__.
    # 
    # You have to divide the return values by 16383 (14 bit) to get
    # the usual range of -1.0 to +1.0 for quaternions.
    # 
    # If you want to get the quaternions periodically, it is recommended
    # to use the CALLBACK_QUATERNION callback and set the period with
    # BrickletIMUV3#set_quaternion_callback_configuration.
    def get_quaternion
      check_validity

      send_request FUNCTION_GET_QUATERNION, [], '', 16, 's s s s'
    end

    # Return all of the available data of the IMU Brick.
    # 
    # * acceleration (see BrickletIMUV3#get_acceleration)
    # * magnetic field (see BrickletIMUV3#get_magnetic_field)
    # * angular velocity (see BrickletIMUV3#get_angular_velocity)
    # * Euler angles (see BrickletIMUV3#get_orientation)
    # * quaternion (see BrickletIMUV3#get_quaternion)
    # * linear acceleration (see BrickletIMUV3#get_linear_acceleration)
    # * gravity vector (see BrickletIMUV3#get_gravity_vector)
    # * temperature (see BrickletIMUV3#get_temperature)
    # * calibration status (see below)
    # 
    # The calibration status consists of four pairs of two bits. Each pair
    # of bits represents the status of the current calibration.
    # 
    # * bit 0-1: Magnetometer
    # * bit 2-3: Accelerometer
    # * bit 4-5: Gyroscope
    # * bit 6-7: System
    # 
    # A value of 0 means for "not calibrated" and a value of 3 means
    # "fully calibrated". In your program you should always be able to
    # ignore the calibration status, it is used by the calibration
    # window of the Brick Viewer and it can be ignored after the first
    # calibration. See the documentation in the calibration window for
    # more information regarding the calibration of the IMU Brick.
    # 
    # If you want to get the data periodically, it is recommended
    # to use the CALLBACK_ALL_DATA callback and set the period with
    # BrickletIMUV3#set_all_data_callback_configuration.
    def get_all_data
      check_validity

      send_request FUNCTION_GET_ALL_DATA, [], '', 54, 's3 s3 s3 s3 s4 s3 s3 c C'
    end

    # A call of this function saves the current calibration to be used
    # as a starting point for the next restart of continuous calibration
    # of the IMU Brick.
    # 
    # A return value of *true* means that the calibration could be used and
    # *false* means that it could not be used (this happens if the calibration
    # status is not "fully calibrated").
    # 
    # This function is used by the calibration window of the Brick Viewer, you
    # should not need to call it in your program.
    def save_calibration
      check_validity

      send_request FUNCTION_SAVE_CALIBRATION, [], '', 9, '?'
    end

    # Sets the available sensor configuration for the Magnetometer, Gyroscope and
    # Accelerometer. The Accelerometer Range is user selectable in all fusion modes,
    # all other configurations are auto-controlled in fusion mode.
    def set_sensor_configuration(magnetometer_rate, gyroscope_range, gyroscope_bandwidth, accelerometer_range, accelerometer_bandwidth)
      check_validity

      send_request FUNCTION_SET_SENSOR_CONFIGURATION, [magnetometer_rate, gyroscope_range, gyroscope_bandwidth, accelerometer_range, accelerometer_bandwidth], 'C C C C C', 8, ''
    end

    # Returns the sensor configuration as set by BrickletIMUV3#set_sensor_configuration.
    def get_sensor_configuration
      check_validity

      send_request FUNCTION_GET_SENSOR_CONFIGURATION, [], '', 13, 'C C C C C'
    end

    # If the fusion mode is turned off, the functions BrickletIMUV3#get_acceleration,
    # BrickletIMUV3#get_magnetic_field and BrickletIMUV3#get_angular_velocity return uncalibrated
    # and uncompensated sensor data. All other sensor data getters return no data.
    # 
    # Since firmware version 2.0.6 you can also use a fusion mode without magnetometer.
    # In this mode the calculated orientation is relative (with magnetometer it is
    # absolute with respect to the earth). However, the calculation can't be influenced
    # by spurious magnetic fields.
    # 
    # Since firmware version 2.0.13 you can also use a fusion mode without fast
    # magnetometer calibration. This mode is the same as the normal fusion mode,
    # but the fast magnetometer calibration is turned off. So to find the orientation
    # the first time will likely take longer, but small magnetic influences might
    # not affect the automatic calibration as much.
    def set_sensor_fusion_mode(mode)
      check_validity

      send_request FUNCTION_SET_SENSOR_FUSION_MODE, [mode], 'C', 8, ''
    end

    # Returns the sensor fusion mode as set by BrickletIMUV3#set_sensor_fusion_mode.
    def get_sensor_fusion_mode
      check_validity

      send_request FUNCTION_GET_SENSOR_FUSION_MODE, [], '', 9, 'C'
    end

    # The period is the period with which the CALLBACK_ACCELERATION callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_acceleration_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_acceleration_callback_configuration.
    def get_acceleration_callback_configuration
      check_validity

      send_request FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_MAGNETIC_FIELD callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_magnetic_field_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_MAGNETIC_FIELD_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_magnetic_field_callback_configuration.
    def get_magnetic_field_callback_configuration
      check_validity

      send_request FUNCTION_GET_MAGNETIC_FIELD_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_ANGULAR_VELOCITY callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_angular_velocity_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ANGULAR_VELOCITY_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_angular_velocity_callback_configuration.
    def get_angular_velocity_callback_configuration
      check_validity

      send_request FUNCTION_GET_ANGULAR_VELOCITY_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_TEMPERATURE callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_temperature_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_temperature_callback_configuration.
    def get_temperature_callback_configuration
      check_validity

      send_request FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_ORIENTATION callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_orientation_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ORIENTATION_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_orientation_callback_configuration.
    def get_orientation_callback_configuration
      check_validity

      send_request FUNCTION_GET_ORIENTATION_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_LINEAR_ACCELERATION callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_linear_acceleration_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_LINEAR_ACCELERATION_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_linear_acceleration_callback_configuration.
    def get_linear_acceleration_callback_configuration
      check_validity

      send_request FUNCTION_GET_LINEAR_ACCELERATION_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_GRAVITY_VECTOR callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_gravity_vector_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_GRAVITY_VECTOR_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_gravity_vector_callback_configuration.
    def get_gravity_vector_callback_configuration
      check_validity

      send_request FUNCTION_GET_GRAVITY_VECTOR_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_QUATERNION callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_quaternion_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_QUATERNION_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_quaternion_callback_configuration.
    def get_quaternion_callback_configuration
      check_validity

      send_request FUNCTION_GET_QUATERNION_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_ALL_DATA callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_all_data_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ALL_DATA_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by BrickletIMUV3#set_all_data_callback_configuration.
    def get_all_data_callback_configuration
      check_validity

      send_request FUNCTION_GET_ALL_DATA_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletIMUV3#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletIMUV3#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletIMUV3#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletIMUV3#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
