# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures two DC currents between 0mA and 20mA (IEC 60381-1)
  class BrickletIndustrialDual020mA < Device
    DEVICE_IDENTIFIER = 228 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Industrial Dual 0-20mA Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletIndustrialDual020mA#set_current_callback_period. The parameter is the current of the
    # sensor.
    # 
    # The CALLBACK_CURRENT callback is only triggered if the current has changed since the
    # last triggering.
    CALLBACK_CURRENT = 10

    # This callback is triggered when the threshold as set by
    # BrickletIndustrialDual020mA#set_current_callback_threshold is reached.
    # The parameter is the current of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletIndustrialDual020mA#set_debounce_period.
    CALLBACK_CURRENT_REACHED = 11

    FUNCTION_GET_CURRENT = 1 # :nodoc:
    FUNCTION_SET_CURRENT_CALLBACK_PERIOD = 2 # :nodoc:
    FUNCTION_GET_CURRENT_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = 4 # :nodoc:
    FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = 5 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 6 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 7 # :nodoc:
    FUNCTION_SET_SAMPLE_RATE = 8 # :nodoc:
    FUNCTION_GET_SAMPLE_RATE = 9 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    SAMPLE_RATE_240_SPS = 0 # :nodoc:
    SAMPLE_RATE_60_SPS = 1 # :nodoc:
    SAMPLE_RATE_15_SPS = 2 # :nodoc:
    SAMPLE_RATE_4_SPS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CURRENT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SAMPLE_RATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SAMPLE_RATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_CURRENT] = [13, 'C l']
      @callback_formats[CALLBACK_CURRENT_REACHED] = [13, 'C l']

      @ipcon.add_device self
    end

    # Returns the current of the specified sensor.
    # 
    # It is possible to detect if an IEC 60381-1 compatible sensor is connected
    # and if it works properly.
    # 
    # If the returned current is below 4mA, there is likely no sensor connected
    # or the sensor may be defect. If the returned current is over 20mA, there might
    # be a short circuit or the sensor may be defect.
    # 
    # If you want to get the current periodically, it is recommended to use the
    # CALLBACK_CURRENT callback and set the period with
    # BrickletIndustrialDual020mA#set_current_callback_period.
    def get_current(sensor)
      check_validity

      send_request FUNCTION_GET_CURRENT, [sensor], 'C', 12, 'l'
    end

    # Sets the period with which the CALLBACK_CURRENT callback is triggered
    # periodically for the given sensor. A value of 0 turns the callback off.
    # 
    # The CALLBACK_CURRENT callback is only triggered if the current has changed since the
    # last triggering.
    def set_current_callback_period(sensor, period)
      check_validity

      send_request FUNCTION_SET_CURRENT_CALLBACK_PERIOD, [sensor, period], 'C L', 8, ''
    end

    # Returns the period as set by BrickletIndustrialDual020mA#set_current_callback_period.
    def get_current_callback_period(sensor)
      check_validity

      send_request FUNCTION_GET_CURRENT_CALLBACK_PERIOD, [sensor], 'C', 12, 'L'
    end

    # Sets the thresholds for the CALLBACK_CURRENT_REACHED callback for the given
    # sensor.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the current is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the current is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
    def set_current_callback_threshold(sensor, option, min, max)
      check_validity

      send_request FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, [sensor, option, min, max], 'C k l l', 8, ''
    end

    # Returns the threshold as set by BrickletIndustrialDual020mA#set_current_callback_threshold.
    def get_current_callback_threshold(sensor)
      check_validity

      send_request FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, [sensor], 'C', 17, 'k l l'
    end

    # Sets the period with which the threshold callback
    # 
    # * CALLBACK_CURRENT_REACHED
    # 
    # is triggered, if the threshold
    # 
    # * BrickletIndustrialDual020mA#set_current_callback_threshold
    # 
    # keeps being reached.
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickletIndustrialDual020mA#set_debounce_period.
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Sets the sample rate to either 240, 60, 15 or 4 samples per second.
    # The resolution for the rates is 12, 14, 16 and 18 bit respectively.
    # 
    #  "Value", "Description"
    # 
    #  "0",    "240 samples per second, 12 bit resolution"
    #  "1",    "60 samples per second, 14 bit resolution"
    #  "2",    "15 samples per second, 16 bit resolution"
    #  "3",    "4 samples per second, 18 bit resolution"
    def set_sample_rate(rate)
      check_validity

      send_request FUNCTION_SET_SAMPLE_RATE, [rate], 'C', 8, ''
    end

    # Returns the sample rate as set by BrickletIndustrialDual020mA#set_sample_rate.
    def get_sample_rate
      check_validity

      send_request FUNCTION_GET_SAMPLE_RATE, [], '', 9, 'C'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
