# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures distance up to 40m with laser light
  class BrickletLaserRangeFinderV2 < Device
    DEVICE_IDENTIFIER = 2144 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Laser Range Finder Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletLaserRangeFinderV2#set_distance_callback_configuration.
    # 
    # The parameter is the same as BrickletLaserRangeFinderV2#get_distance.
    CALLBACK_DISTANCE = 4

    # This callback is triggered periodically according to the configuration set by
    # BrickletLaserRangeFinderV2#set_velocity_callback_configuration.
    # 
    # The parameter is the same as BrickletLaserRangeFinderV2#get_velocity.
    CALLBACK_VELOCITY = 8

    FUNCTION_GET_DISTANCE = 1 # :nodoc:
    FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_GET_VELOCITY = 5 # :nodoc:
    FUNCTION_SET_VELOCITY_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_VELOCITY_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_SET_ENABLE = 9 # :nodoc:
    FUNCTION_GET_ENABLE = 10 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 11 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 12 # :nodoc:
    FUNCTION_SET_MOVING_AVERAGE = 13 # :nodoc:
    FUNCTION_GET_MOVING_AVERAGE = 14 # :nodoc:
    FUNCTION_SET_OFFSET_CALIBRATION = 15 # :nodoc:
    FUNCTION_GET_OFFSET_CALIBRATION = 16 # :nodoc:
    FUNCTION_SET_DISTANCE_LED_CONFIG = 17 # :nodoc:
    FUNCTION_GET_DISTANCE_LED_CONFIG = 18 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    DISTANCE_LED_CONFIG_OFF = 0 # :nodoc:
    DISTANCE_LED_CONFIG_ON = 1 # :nodoc:
    DISTANCE_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    DISTANCE_LED_CONFIG_SHOW_DISTANCE = 3 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_DISTANCE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VELOCITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VELOCITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ENABLE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ENABLE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOVING_AVERAGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOVING_AVERAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_OFFSET_CALIBRATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_OFFSET_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DISTANCE_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_DISTANCE_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_DISTANCE] = [10, 's']
      @callback_formats[CALLBACK_VELOCITY] = [10, 's']

      @ipcon.add_device self
    end

    # Returns the measured distance.
    # 
    # The laser has to be enabled, see BrickletLaserRangeFinderV2#set_enable.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_DISTANCE callback. You can set the callback configuration
    # with BrickletLaserRangeFinderV2#set_distance_callback_configuration.
    def get_distance
      check_validity

      send_request FUNCTION_GET_DISTANCE, [], '', 10, 's'
    end

    # The period is the period with which the CALLBACK_DISTANCE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_DISTANCE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_distance_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k s s', 8, ''
    end

    # Returns the callback configuration as set by BrickletLaserRangeFinderV2#set_distance_callback_configuration.
    def get_distance_callback_configuration
      check_validity

      send_request FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k s s'
    end

    # Returns the measured velocity. The value has a range of -12800 to 12700
    # and is given in 1/100 m/s.
    # 
    # The velocity measurement only produces stables results if a fixed
    # measurement rate (see BrickletLaserRangeFinderV2#set_configuration) is configured. Also the laser
    # has to be enabled, see BrickletLaserRangeFinderV2#set_enable.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_VELOCITY callback. You can set the callback configuration
    # with BrickletLaserRangeFinderV2#set_velocity_callback_configuration.
    def get_velocity
      check_validity

      send_request FUNCTION_GET_VELOCITY, [], '', 10, 's'
    end

    # The period is the period with which the CALLBACK_VELOCITY callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_VELOCITY callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_velocity_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_VELOCITY_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k s s', 8, ''
    end

    # Returns the callback configuration as set by BrickletLaserRangeFinderV2#set_velocity_callback_configuration.
    def get_velocity_callback_configuration
      check_validity

      send_request FUNCTION_GET_VELOCITY_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k s s'
    end

    # Enables the laser of the LIDAR if set to *true*.
    # 
    # We recommend that you wait 250ms after enabling the laser before
    # the first call of BrickletLaserRangeFinderV2#get_distance to ensure stable measurements.
    def set_enable(enable)
      check_validity

      send_request FUNCTION_SET_ENABLE, [enable], '?', 8, ''
    end

    # Returns the value as set by BrickletLaserRangeFinderV2#set_enable.
    def get_enable
      check_validity

      send_request FUNCTION_GET_ENABLE, [], '', 9, '?'
    end

    # The **Acquisition Count** defines the number of times the Laser Range Finder Bricklet
    # will integrate acquisitions to find a correlation record peak. With a higher count,
    # the Bricklet can measure longer distances. With a lower count, the rate increases. The
    # allowed values are 1-255.
    # 
    # If you set **Enable Quick Termination** to true, the distance measurement will be terminated
    # early if a high peak was already detected. This means that a higher measurement rate can be achieved
    # and long distances can be measured at the same time. However, the chance of false-positive
    # distance measurements increases.
    # 
    # Normally the distance is calculated with a detection algorithm that uses peak value,
    # signal strength and noise. You can however also define a fixed **Threshold Value**.
    # Set this to a low value if you want to measure the distance to something that has
    # very little reflection (e.g. glass) and set it to a high value if you want to measure
    # the distance to something with a very high reflection (e.g. mirror). Set this to 0 to
    # use the default algorithm. The other allowed values are 1-255.
    # 
    # Set the **Measurement Frequency** to force a fixed measurement rate. If set to 0,
    # the Laser Range Finder Bricklet will use the optimal frequency according to the other
    # configurations and the actual measured distance. Since the rate is not fixed in this case,
    # the velocity measurement is not stable. For a stable velocity measurement you should
    # set a fixed measurement frequency. The lower the frequency, the higher is the resolution
    # of the calculated velocity. The allowed values are 10Hz-500Hz (and 0 to turn the fixed
    # frequency off).
    # 
    # The default values for Acquisition Count, Enable Quick Termination, Threshold Value and
    # Measurement Frequency are 128, false, 0 and 0.
    def set_configuration(acquisition_count, enable_quick_termination, threshold_value, measurement_frequency)
      check_validity

      send_request FUNCTION_SET_CONFIGURATION, [acquisition_count, enable_quick_termination, threshold_value, measurement_frequency], 'C ? C S', 8, ''
    end

    # Returns the configuration as set by BrickletLaserRangeFinderV2#set_configuration.
    def get_configuration
      check_validity

      send_request FUNCTION_GET_CONFIGURATION, [], '', 13, 'C ? C S'
    end

    # Sets the length of a `moving averaging <https://en.wikipedia.org/wiki/Moving_average>`__
    # for the distance and velocity.
    # 
    # Setting the length to 0 will turn the averaging completely off. With less
    # averaging, there is more noise on the data.
    def set_moving_average(distance_average_length, velocity_average_length)
      check_validity

      send_request FUNCTION_SET_MOVING_AVERAGE, [distance_average_length, velocity_average_length], 'C C', 8, ''
    end

    # Returns the length moving average as set by BrickletLaserRangeFinderV2#set_moving_average.
    def get_moving_average
      check_validity

      send_request FUNCTION_GET_MOVING_AVERAGE, [], '', 10, 'C C'
    end

    # The offset is added to the measured distance.
    # It is saved in non-volatile memory, you only have to set it once.
    # 
    # The Bricklet comes with a per-sensor factory-calibrated offset value,
    # you should not have to call this function.
    # 
    # If you want to re-calibrate the offset you first have to set it to 0.
    # Calculate the offset by measuring the distance to a known distance
    # and set it again.
    def set_offset_calibration(offset)
      check_validity

      send_request FUNCTION_SET_OFFSET_CALIBRATION, [offset], 's', 8, ''
    end

    # Returns the offset value as set by BrickletLaserRangeFinderV2#set_offset_calibration.
    def get_offset_calibration
      check_validity

      send_request FUNCTION_GET_OFFSET_CALIBRATION, [], '', 10, 's'
    end

    # Configures the distance LED to be either turned off, turned on, blink in
    # heartbeat mode or show the distance (brighter = object is nearer).
    def set_distance_led_config(config)
      check_validity

      send_request FUNCTION_SET_DISTANCE_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletLaserRangeFinderV2#set_distance_led_config
    def get_distance_led_config
      check_validity

      send_request FUNCTION_GET_DISTANCE_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletLaserRangeFinderV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletLaserRangeFinderV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletLaserRangeFinderV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletLaserRangeFinderV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
