# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Controls up to 320 RGB LEDs
  class BrickletLEDStrip < Device
    DEVICE_IDENTIFIER = 231 # :nodoc:
    DEVICE_DISPLAY_NAME = 'LED Strip Bricklet' # :nodoc:

    # This callback is triggered directly after a new frame is rendered. The
    # parameter is the number of RGB or RGBW LEDs in that frame.
    # 
    # You should send the data for the next frame directly after this callback
    # was triggered.
    # 
    # For an explanation of the general approach see BrickletLEDStrip#set_rgb_values.
    CALLBACK_FRAME_RENDERED = 6

    FUNCTION_SET_RGB_VALUES = 1 # :nodoc:
    FUNCTION_GET_RGB_VALUES = 2 # :nodoc:
    FUNCTION_SET_FRAME_DURATION = 3 # :nodoc:
    FUNCTION_GET_FRAME_DURATION = 4 # :nodoc:
    FUNCTION_GET_SUPPLY_VOLTAGE = 5 # :nodoc:
    FUNCTION_SET_CLOCK_FREQUENCY = 7 # :nodoc:
    FUNCTION_GET_CLOCK_FREQUENCY = 8 # :nodoc:
    FUNCTION_SET_CHIP_TYPE = 9 # :nodoc:
    FUNCTION_GET_CHIP_TYPE = 10 # :nodoc:
    FUNCTION_SET_RGBW_VALUES = 11 # :nodoc:
    FUNCTION_GET_RGBW_VALUES = 12 # :nodoc:
    FUNCTION_SET_CHANNEL_MAPPING = 13 # :nodoc:
    FUNCTION_GET_CHANNEL_MAPPING = 14 # :nodoc:
    FUNCTION_ENABLE_FRAME_RENDERED_CALLBACK = 15 # :nodoc:
    FUNCTION_DISABLE_FRAME_RENDERED_CALLBACK = 16 # :nodoc:
    FUNCTION_IS_FRAME_RENDERED_CALLBACK_ENABLED = 17 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    CHIP_TYPE_WS2801 = 2801 # :nodoc:
    CHIP_TYPE_WS2811 = 2811 # :nodoc:
    CHIP_TYPE_WS2812 = 2812 # :nodoc:
    CHIP_TYPE_LPD8806 = 8806 # :nodoc:
    CHIP_TYPE_APA102 = 102 # :nodoc:
    CHANNEL_MAPPING_RGB = 6 # :nodoc:
    CHANNEL_MAPPING_RBG = 9 # :nodoc:
    CHANNEL_MAPPING_BRG = 33 # :nodoc:
    CHANNEL_MAPPING_BGR = 36 # :nodoc:
    CHANNEL_MAPPING_GRB = 18 # :nodoc:
    CHANNEL_MAPPING_GBR = 24 # :nodoc:
    CHANNEL_MAPPING_RGBW = 27 # :nodoc:
    CHANNEL_MAPPING_RGWB = 30 # :nodoc:
    CHANNEL_MAPPING_RBGW = 39 # :nodoc:
    CHANNEL_MAPPING_RBWG = 45 # :nodoc:
    CHANNEL_MAPPING_RWGB = 54 # :nodoc:
    CHANNEL_MAPPING_RWBG = 57 # :nodoc:
    CHANNEL_MAPPING_GRWB = 78 # :nodoc:
    CHANNEL_MAPPING_GRBW = 75 # :nodoc:
    CHANNEL_MAPPING_GBWR = 108 # :nodoc:
    CHANNEL_MAPPING_GBRW = 99 # :nodoc:
    CHANNEL_MAPPING_GWBR = 120 # :nodoc:
    CHANNEL_MAPPING_GWRB = 114 # :nodoc:
    CHANNEL_MAPPING_BRGW = 135 # :nodoc:
    CHANNEL_MAPPING_BRWG = 141 # :nodoc:
    CHANNEL_MAPPING_BGRW = 147 # :nodoc:
    CHANNEL_MAPPING_BGWR = 156 # :nodoc:
    CHANNEL_MAPPING_BWRG = 177 # :nodoc:
    CHANNEL_MAPPING_BWGR = 180 # :nodoc:
    CHANNEL_MAPPING_WRBG = 201 # :nodoc:
    CHANNEL_MAPPING_WRGB = 198 # :nodoc:
    CHANNEL_MAPPING_WGBR = 216 # :nodoc:
    CHANNEL_MAPPING_WGRB = 210 # :nodoc:
    CHANNEL_MAPPING_WBGR = 228 # :nodoc:
    CHANNEL_MAPPING_WBRG = 225 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 3]

      @response_expected[FUNCTION_SET_RGB_VALUES] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RGB_VALUES] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_FRAME_DURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_FRAME_DURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SUPPLY_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CLOCK_FREQUENCY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CLOCK_FREQUENCY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHIP_TYPE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIP_TYPE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RGBW_VALUES] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RGBW_VALUES] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHANNEL_MAPPING] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHANNEL_MAPPING] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_FRAME_RENDERED_CALLBACK] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_DISABLE_FRAME_RENDERED_CALLBACK] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_IS_FRAME_RENDERED_CALLBACK_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_FRAME_RENDERED] = [10, 'S']

      @ipcon.add_device self
    end

    # Sets *length* RGB values for the LEDs starting from *index*.
    # 
    # To make the colors show correctly you need to configure the chip type
    # (BrickletLEDStrip#set_chip_type) and a 3-channel channel mapping (BrickletLEDStrip#set_channel_mapping)
    # according to the connected LEDs.
    # 
    # Example: If you set
    # 
    # * index to 5,
    # * length to 3,
    # * r to [255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    # * g to [0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] and
    # * b to [0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    # 
    # the LED with index 5 will be red, 6 will be green and 7 will be blue.
    # 
    # .. note:: Depending on the LED circuitry colors can be permuted.
    # 
    # The colors will be transfered to actual LEDs when the next
    # frame duration ends, see BrickletLEDStrip#set_frame_duration.
    # 
    # Generic approach:
    # 
    # * Set the frame duration to a value that represents
    #   the number of frames per second you want to achieve.
    # * Set all of the LED colors for one frame.
    # * Wait for the CALLBACK_FRAME_RENDERED callback.
    # * Set all of the LED colors for next frame.
    # * Wait for the CALLBACK_FRAME_RENDERED callback.
    # * and so on.
    # 
    # This approach ensures that you can change the LED colors with
    # a fixed frame rate.
    # 
    # The actual number of controllable LEDs depends on the number of free
    # Bricklet ports. See :ref:`here <led_strip_bricklet_ram_constraints>` for more
    # information. A call of BrickletLEDStrip#set_rgb_values with index + length above the
    # bounds is ignored completely.
    def set_rgb_values(index, length, r, g, b)
      check_validity

      send_request FUNCTION_SET_RGB_VALUES, [index, length, r, g, b], 'S C C16 C16 C16', 8, ''
    end

    # Returns *length* R, G and B values starting from the
    # given LED *index*.
    # 
    # The values are the last values that were set by BrickletLEDStrip#set_rgb_values.
    def get_rgb_values(index, length)
      check_validity

      send_request FUNCTION_GET_RGB_VALUES, [index, length], 'S C', 56, 'C16 C16 C16'
    end

    # Sets the frame duration.
    # 
    # Example: If you want to achieve 20 frames per second, you should
    # set the frame duration to 50ms (50ms * 20 = 1 second).
    # 
    # For an explanation of the general approach see BrickletLEDStrip#set_rgb_values.
    def set_frame_duration(duration)
      check_validity

      send_request FUNCTION_SET_FRAME_DURATION, [duration], 'S', 8, ''
    end

    # Returns the frame duration as set by BrickletLEDStrip#set_frame_duration.
    def get_frame_duration
      check_validity

      send_request FUNCTION_GET_FRAME_DURATION, [], '', 10, 'S'
    end

    # Returns the current supply voltage of the LEDs.
    def get_supply_voltage
      check_validity

      send_request FUNCTION_GET_SUPPLY_VOLTAGE, [], '', 10, 'S'
    end

    # Sets the frequency of the clock.
    # 
    # The Bricklet will choose the nearest achievable frequency, which may
    # be off by a few Hz. You can get the exact frequency that is used by
    # calling BrickletLEDStrip#get_clock_frequency.
    # 
    # If you have problems with flickering LEDs, they may be bits flipping. You
    # can fix this by either making the connection between the LEDs and the
    # Bricklet shorter or by reducing the frequency.
    # 
    # With a decreasing frequency your maximum frames per second will decrease
    # too.
    # 
    # .. note::
    #  The frequency in firmware version 2.0.0 is fixed at 2MHz.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def set_clock_frequency(frequency)
      check_validity

      send_request FUNCTION_SET_CLOCK_FREQUENCY, [frequency], 'L', 8, ''
    end

    # Returns the currently used clock frequency as set by BrickletLEDStrip#set_clock_frequency.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def get_clock_frequency
      check_validity

      send_request FUNCTION_GET_CLOCK_FREQUENCY, [], '', 12, 'L'
    end

    # Sets the type of the LED driver chip. We currently support the chips
    # 
    # * WS2801,
    # * WS2811,
    # * WS2812 / SK6812 / NeoPixel RGB,
    # * SK6812RGBW / NeoPixel RGBW (Chip Type = WS2812),
    # * LPD8806 and
    # * APA102 / DotStar.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Plugin)
    def set_chip_type(chip)
      check_validity

      send_request FUNCTION_SET_CHIP_TYPE, [chip], 'S', 8, ''
    end

    # Returns the currently used chip type as set by BrickletLEDStrip#set_chip_type.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Plugin)
    def get_chip_type
      check_validity

      send_request FUNCTION_GET_CHIP_TYPE, [], '', 10, 'S'
    end

    # Sets *length* RGBW values for the LEDs starting from *index*.
    # 
    # To make the colors show correctly you need to configure the chip type
    # (BrickletLEDStrip#set_chip_type) and a 4-channel channel mapping (BrickletLEDStrip#set_channel_mapping)
    # according to the connected LEDs.
    # 
    # The maximum length is 12, the index goes from 0 to 239 and the rgbw values
    # have 8 bits each.
    # 
    # Example: If you set
    # 
    # * index to 5,
    # * length to 4,
    # * r to [255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    # * g to [0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    # * b to [0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0] and
    # * w to [0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    # 
    # the LED with index 5 will be red, 6 will be green, 7 will be blue and 8 will be white.
    # 
    # .. note:: Depending on the LED circuitry colors can be permuted.
    # 
    # The colors will be transfered to actual LEDs when the next
    # frame duration ends, see BrickletLEDStrip#set_frame_duration.
    # 
    # Generic approach:
    # 
    # * Set the frame duration to a value that represents
    #   the number of frames per second you want to achieve.
    # * Set all of the LED colors for one frame.
    # * Wait for the CALLBACK_FRAME_RENDERED callback.
    # * Set all of the LED colors for next frame.
    # * Wait for the CALLBACK_FRAME_RENDERED callback.
    # * and so on.
    # 
    # This approach ensures that you can change the LED colors with
    # a fixed frame rate.
    # 
    # The actual number of controllable LEDs depends on the number of free
    # Bricklet ports. See :ref:`here <led_strip_bricklet_ram_constraints>` for more
    # information. A call of BrickletLEDStrip#set_rgbw_values with index + length above the
    # bounds is ignored completely.
    # 
    # The LPD8806 LED driver chips have 7-bit channels for RGB. Internally the LED
    # Strip Bricklets divides the 8-bit values set using this function by 2 to make
    # them 7-bit. Therefore, you can just use the normal value range (0-255) for
    # LPD8806 LEDs.
    # 
    # The brightness channel of the APA102 LED driver chips has 5-bit. Internally the
    # LED Strip Bricklets divides the 8-bit values set using this function by 8 to make
    # them 5-bit. Therefore, you can just use the normal value range (0-255) for
    # the brightness channel of APA102 LEDs.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def set_rgbw_values(index, length, r, g, b, w)
      check_validity

      send_request FUNCTION_SET_RGBW_VALUES, [index, length, r, g, b, w], 'S C C12 C12 C12 C12', 8, ''
    end

    # Returns *length* RGBW values starting from the given *index*.
    # 
    # The values are the last values that were set by BrickletLEDStrip#set_rgbw_values.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def get_rgbw_values(index, length)
      check_validity

      send_request FUNCTION_GET_RGBW_VALUES, [index, length], 'S C', 56, 'C12 C12 C12 C12'
    end

    # Sets the channel mapping for the connected LEDs.
    # 
    # BrickletLEDStrip#set_rgb_values and BrickletLEDStrip#set_rgbw_values take the data in RGB(W) order.
    # But the connected LED driver chips might have their 3 or 4 channels in a
    # different order. For example, the WS2801 chips typically use BGR order, the
    # WS2812 chips typically use GRB order and the APA102 chips typically use WBGR
    # order.
    # 
    # The APA102 chips are special. They have three 8-bit channels for RGB
    # and an additional 5-bit channel for the overall brightness of the RGB LED
    # making them 4-channel chips. Internally the brightness channel is the first
    # channel, therefore one of the Wxyz channel mappings should be used. Then
    # the W channel controls the brightness.
    # 
    # If a 3-channel mapping is selected then BrickletLEDStrip#set_rgb_values has to be used.
    # Calling BrickletLEDStrip#set_rgbw_values with a 3-channel mapping will produce incorrect
    # results. Vice-versa if a 4-channel mapping is selected then
    # BrickletLEDStrip#set_rgbw_values has to be used. Calling BrickletLEDStrip#set_rgb_values with a
    # 4-channel mapping will produce incorrect results.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def set_channel_mapping(mapping)
      check_validity

      send_request FUNCTION_SET_CHANNEL_MAPPING, [mapping], 'C', 8, ''
    end

    # Returns the currently used channel mapping as set by BrickletLEDStrip#set_channel_mapping.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def get_channel_mapping
      check_validity

      send_request FUNCTION_GET_CHANNEL_MAPPING, [], '', 9, 'C'
    end

    # Enables the CALLBACK_FRAME_RENDERED callback.
    # 
    # By default the callback is enabled.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def enable_frame_rendered_callback
      check_validity

      send_request FUNCTION_ENABLE_FRAME_RENDERED_CALLBACK, [], '', 8, ''
    end

    # Disables the CALLBACK_FRAME_RENDERED callback.
    # 
    # By default the callback is enabled.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def disable_frame_rendered_callback
      check_validity

      send_request FUNCTION_DISABLE_FRAME_RENDERED_CALLBACK, [], '', 8, ''
    end

    # Returns *true* if the CALLBACK_FRAME_RENDERED callback is enabled, *false* otherwise.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def is_frame_rendered_callback_enabled
      check_validity

      send_request FUNCTION_IS_FRAME_RENDERED_CALLBACK_ENABLED, [], '', 9, '?'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
