# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Motorized Linear Potentiometer
  class BrickletMotorizedLinearPoti < Device
    DEVICE_IDENTIFIER = 267 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Motorized Linear Poti Bricklet' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletMotorizedLinearPoti#set_position_callback_configuration.
    # 
    # The parameter is the same as BrickletMotorizedLinearPoti#get_position.
    CALLBACK_POSITION = 4

    # This callback is triggered if a new position as set by
    # BrickletMotorizedLinearPoti#set_motor_position is reached.
    # 
    # The parameter is the current position.
    CALLBACK_POSITION_REACHED = 10

    FUNCTION_GET_POSITION = 1 # :nodoc:
    FUNCTION_SET_POSITION_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_POSITION_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_SET_MOTOR_POSITION = 5 # :nodoc:
    FUNCTION_GET_MOTOR_POSITION = 6 # :nodoc:
    FUNCTION_CALIBRATE = 7 # :nodoc:
    FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION = 8 # :nodoc:
    FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION = 9 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    DRIVE_MODE_FAST = 0 # :nodoc:
    DRIVE_MODE_SMOOTH = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_POSITION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_POSITION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOTOR_POSITION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOTOR_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_CALIBRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_POSITION] = [10, 'S']
      @callback_formats[CALLBACK_POSITION_REACHED] = [10, 'S']

      @ipcon.add_device self
    end

    # Returns the position of the linear potentiometer. The value is
    # between 0 (slider down) and 100 (slider up).
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_POSITION callback. You can set the callback configuration
    # with BrickletMotorizedLinearPoti#set_position_callback_configuration.
    def get_position
      check_validity

      send_request FUNCTION_GET_POSITION, [], '', 10, 'S'
    end

    # The period is the period with which the CALLBACK_POSITION callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_POSITION callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_position_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_POSITION_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k S S', 8, ''
    end

    # Returns the callback configuration as set by BrickletMotorizedLinearPoti#set_position_callback_configuration.
    def get_position_callback_configuration
      check_validity

      send_request FUNCTION_GET_POSITION_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k S S'
    end

    # Sets the position of the potentiometer. The motorized potentiometer will
    # immediately start to approach the position. Depending on the chosen drive mode,
    # the position will either be reached as fast as possible or in a slow but smooth
    # motion.
    # 
    # The position has to be between 0 (slider down) and 100 (slider up).
    # 
    # If you set the hold position parameter to true, the position will automatically
    # be retained. If a user changes the position of the potentiometer, it will
    # automatically drive back to the original set point.
    # 
    # If the hold position parameter is set to false, the potentiometer can be changed
    # again by the user as soon as the set point was reached once.
    def set_motor_position(position, drive_mode, hold_position)
      check_validity

      send_request FUNCTION_SET_MOTOR_POSITION, [position, drive_mode, hold_position], 'S C ?', 8, ''
    end

    # Returns the last motor position as set by BrickletMotorizedLinearPoti#set_motor_position. This is not
    # the current position (use BrickletMotorizedLinearPoti#get_position to get the current position). This
    # is the last used set point and configuration.
    # 
    # The position reached parameter is true if the position has been reached at one point.
    # The position may have been changed again in the meantime by the user.
    def get_motor_position
      check_validity

      send_request FUNCTION_GET_MOTOR_POSITION, [], '', 13, 'S C ? ?'
    end

    # Starts a calibration procedure. The potentiometer will be driven to the extreme
    # points to calibrate the potentiometer.
    # 
    # The calibration is saved in flash, it does not have to be called on every start up.
    # 
    # The Motorized Linear Poti Bricklet is already factory-calibrated during
    # testing at Tinkerforge.
    def calibrate
      check_validity

      send_request FUNCTION_CALIBRATE, [], '', 8, ''
    end

    # Enables/Disables CALLBACK_POSITION_REACHED callback.
    def set_position_reached_callback_configuration(enabled)
      check_validity

      send_request FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION, [enabled], '?', 8, ''
    end

    # Returns the CALLBACK_POSITION_REACHED callback configuration
    # as set by BrickletMotorizedLinearPoti#set_position_reached_callback_configuration.
    def get_position_reached_callback_configuration
      check_validity

      send_request FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION, [], '', 9, '?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletMotorizedLinearPoti#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletMotorizedLinearPoti#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletMotorizedLinearPoti#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletMotorizedLinearPoti#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
