# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Capacitive touch sensor for 12 electrodes
  class BrickletMultiTouchV2 < Device
    DEVICE_IDENTIFIER = 2129 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Multi Touch Bricklet 2.0' # :nodoc:

    # Returns the current touch state, see BrickletMultiTouchV2#get_touch_state for
    # information about the state.
    # 
    # This callback is triggered every time the touch state changes with
    # a given period (see BrickletMultiTouchV2#set_touch_state_callback_configuration)
    CALLBACK_TOUCH_STATE = 4

    FUNCTION_GET_TOUCH_STATE = 1 # :nodoc:
    FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_RECALIBRATE = 5 # :nodoc:
    FUNCTION_SET_ELECTRODE_CONFIG = 6 # :nodoc:
    FUNCTION_GET_ELECTRODE_CONFIG = 7 # :nodoc:
    FUNCTION_SET_ELECTRODE_SENSITIVITY = 8 # :nodoc:
    FUNCTION_GET_ELECTRODE_SENSITIVITY = 9 # :nodoc:
    FUNCTION_SET_TOUCH_LED_CONFIG = 10 # :nodoc:
    FUNCTION_GET_TOUCH_LED_CONFIG = 11 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    TOUCH_LED_CONFIG_OFF = 0 # :nodoc:
    TOUCH_LED_CONFIG_ON = 1 # :nodoc:
    TOUCH_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    TOUCH_LED_CONFIG_SHOW_TOUCH = 3 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_TOUCH_STATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RECALIBRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_ELECTRODE_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ELECTRODE_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ELECTRODE_SENSITIVITY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ELECTRODE_SENSITIVITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TOUCH_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_TOUCH_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_TOUCH_STATE] = [10, '?13']

      @ipcon.add_device self
    end

    # Returns the current touch state. The state is given as a array of
    # bools.
    # 
    # Element 0 to 11 represent the 12 electrodes and element 12 represents
    # the proximity.
    # 
    # If an electrode is touched, the corresponding element is *true*. If
    # a hand or similar is in proximity to the electrodes, element 12 is
    # *true*.
    # 
    # The proximity is activated with a distance of 1-2cm. An electrode
    # is already counted as touched if a finger is nearly touching the
    # electrode. This means that you can put a piece of paper or foil
    # or similar on top of a electrode to build a touch panel with
    # a professional look.
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_TOUCH_STATE callback. You can set the callback configuration
    # with BrickletMultiTouchV2#set_touch_state_callback_configuration.
    def get_touch_state
      check_validity

      send_request FUNCTION_GET_TOUCH_STATE, [], '', 10, '?13'
    end

    # The period is the period with which the CALLBACK_TOUCH_STATE callback
    # is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_touch_state_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletMultiTouchV2#set_touch_state_callback_configuration.
    def get_touch_state_callback_configuration
      check_validity

      send_request FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # Recalibrates the electrodes. Call this function whenever you changed
    # or moved you electrodes.
    def recalibrate
      check_validity

      send_request FUNCTION_RECALIBRATE, [], '', 8, ''
    end

    # Enables/disables electrodes with a bool array (see BrickletMultiTouchV2#get_touch_state).
    # 
    # *True* enables the electrode, *false* disables the electrode. A
    # disabled electrode will always return *false* as its state. If you
    # don't need all electrodes you can disable the electrodes that are
    # not needed.
    # 
    # It is recommended that you disable the proximity electrode (element 12) if
    # the proximity feature is not needed. This will reduce the amount of
    # traffic that is produced by the CALLBACK_TOUCH_STATE callback.
    # 
    # Disabling electrodes will also reduce power consumption.
    def set_electrode_config(enabled_electrodes)
      check_validity

      send_request FUNCTION_SET_ELECTRODE_CONFIG, [enabled_electrodes], '?13', 8, ''
    end

    # Returns the electrode configuration, as set by BrickletMultiTouchV2#set_electrode_config.
    def get_electrode_config
      check_validity

      send_request FUNCTION_GET_ELECTRODE_CONFIG, [], '', 10, '?13'
    end

    # Sets the sensitivity of the electrodes. An electrode with a high sensitivity
    # will register a touch earlier then an electrode with a low sensitivity.
    # 
    # If you build a big electrode you might need to decrease the sensitivity, since
    # the area that can be charged will get bigger. If you want to be able to
    # activate an electrode from further away you need to increase the sensitivity.
    # 
    # After a new sensitivity is set, you likely want to call BrickletMultiTouchV2#recalibrate
    # to calibrate the electrodes with the newly defined sensitivity.
    def set_electrode_sensitivity(sensitivity)
      check_validity

      send_request FUNCTION_SET_ELECTRODE_SENSITIVITY, [sensitivity], 'C', 8, ''
    end

    # Returns the current sensitivity, as set by BrickletMultiTouchV2#set_electrode_sensitivity.
    def get_electrode_sensitivity
      check_validity

      send_request FUNCTION_GET_ELECTRODE_SENSITIVITY, [], '', 9, 'C'
    end

    # Configures the touch LED to be either turned off, turned on, blink in
    # heartbeat mode or show the touch state (electrode touched = LED on).
    def set_touch_led_config(config)
      check_validity

      send_request FUNCTION_SET_TOUCH_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletMultiTouchV2#set_touch_led_config
    def get_touch_led_config
      check_validity

      send_request FUNCTION_GET_TOUCH_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletMultiTouchV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletMultiTouchV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletMultiTouchV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletMultiTouchV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
