# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # 3.3cm (1.3") OLED display with 128x64 pixels
  class BrickletOLED128x64V2 < Device
    DEVICE_IDENTIFIER = 2112 # :nodoc:
    DEVICE_DISPLAY_NAME = 'OLED 128x64 Bricklet 2.0' # :nodoc:

    FUNCTION_WRITE_PIXELS_LOW_LEVEL = 1 # :nodoc:
    FUNCTION_READ_PIXELS_LOW_LEVEL = 2 # :nodoc:
    FUNCTION_CLEAR_DISPLAY = 3 # :nodoc:
    FUNCTION_SET_DISPLAY_CONFIGURATION = 4 # :nodoc:
    FUNCTION_GET_DISPLAY_CONFIGURATION = 5 # :nodoc:
    FUNCTION_WRITE_LINE = 6 # :nodoc:
    FUNCTION_DRAW_BUFFERED_FRAME = 7 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_WRITE_PIXELS_LOW_LEVEL] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_READ_PIXELS_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_CLEAR_DISPLAY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_DISPLAY_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_DISPLAY_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_WRITE_LINE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DRAW_BUFFERED_FRAME] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE


      @ipcon.add_device self
    end

    # Writes pixels to the specified window.
    # 
    # The pixels are written into the window line by line top to bottom
    # and each line is written from left to right.
    # 
    # If automatic draw is enabled (default) the pixels are directly written to
    # the screen. Only pixels that have actually changed are updated on the screen,
    # the rest stays the same.
    # 
    # If automatic draw is disabled the pixels are written to an internal buffer and
    # the buffer is transferred to the display only after BrickletOLED128x64V2#draw_buffered_frame
    # is called. This can be used to avoid flicker when drawing a complex frame in
    # multiple steps.
    # 
    # Automatic draw can be configured with the BrickletOLED128x64V2#set_display_configuration
    # function.
    def write_pixels_low_level(x_start, y_start, x_end, y_end, pixels_length, pixels_chunk_offset, pixels_chunk_data)
      check_validity

      send_request FUNCTION_WRITE_PIXELS_LOW_LEVEL, [x_start, y_start, x_end, y_end, pixels_length, pixels_chunk_offset, pixels_chunk_data], 'C C C C S S ?448', 8, ''
    end

    # Reads pixels from the specified window.
    # 
    # The pixels are read from the window line by line top to bottom
    # and each line is read from left to right.
    # 
    # If automatic draw is enabled (default) the pixels that are read are always the
    # same that are shown on the display.
    # 
    # If automatic draw is disabled the pixels are read from the internal buffer
    # (see BrickletOLED128x64V2#draw_buffered_frame).
    # 
    # Automatic draw can be configured with the BrickletOLED128x64V2#set_display_configuration
    # function.
    def read_pixels_low_level(x_start, y_start, x_end, y_end)
      check_validity

      send_request FUNCTION_READ_PIXELS_LOW_LEVEL, [x_start, y_start, x_end, y_end], 'C C C C', 72, 'S S ?480'
    end

    # Clears the complete content of the display.
    # 
    # If automatic draw is enabled (default) the pixels are directly cleared.
    # 
    # If automatic draw is disabled the the internal buffer is cleared and
    # the buffer is transferred to the display only after BrickletOLED128x64V2#draw_buffered_frame
    # is called. This can be used to avoid flicker when drawing a complex frame in
    # multiple steps.
    # 
    # Automatic draw can be configured with the BrickletOLED128x64V2#set_display_configuration
    # function.
    def clear_display
      check_validity

      send_request FUNCTION_CLEAR_DISPLAY, [], '', 8, ''
    end

    # Sets the configuration of the display.
    # 
    # You can set a contrast value from 0 to 255 and you can invert the color
    # (white/black) of the display.
    # 
    # If automatic draw is set to *true*, the display is automatically updated with every
    # call of BrickletOLED128x64V2#write_pixels or BrickletOLED128x64V2#write_line. If it is set to false, the
    # changes are written into an internal buffer and only shown on the display after
    # a call of BrickletOLED128x64V2#draw_buffered_frame.
    def set_display_configuration(contrast, invert, automatic_draw)
      check_validity

      send_request FUNCTION_SET_DISPLAY_CONFIGURATION, [contrast, invert, automatic_draw], 'C ? ?', 8, ''
    end

    # Returns the configuration as set by BrickletOLED128x64V2#set_display_configuration.
    def get_display_configuration
      check_validity

      send_request FUNCTION_GET_DISPLAY_CONFIGURATION, [], '', 11, 'C ? ?'
    end

    # Writes text to a specific line with a specific position.
    # The text can have a maximum of 22 characters.
    # 
    # For example: (1, 10, "Hello") will write *Hello* in the middle of the
    # second line of the display.
    # 
    # The display uses a special 5x7 pixel charset. You can view the characters
    # of the charset in Brick Viewer.
    # 
    # If automatic draw is enabled (default) the text is directly written to
    # the screen. Only pixels that have actually changed are updated on the screen,
    # the rest stays the same.
    # 
    # If automatic draw is disabled the text is written to an internal buffer and
    # the buffer is transferred to the display only after BrickletOLED128x64V2#draw_buffered_frame
    # is called. This can be used to avoid flicker when drawing a complex frame in
    # multiple steps.
    # 
    # Automatic draw can be configured with the BrickletOLED128x64V2#set_display_configuration
    # function.
    def write_line(line, position, text)
      check_validity

      send_request FUNCTION_WRITE_LINE, [line, position, text], 'C C Z22', 8, ''
    end

    # Draws the currently buffered frame. Normally each call of BrickletOLED128x64V2#write_pixels and
    # BrickletOLED128x64V2#write_line draws directly onto the display. If you turn automatic draw off
    # (BrickletOLED128x64V2#set_display_configuration), the data is written in an internal buffer and
    # only transferred to the display by calling this function. This can be used to
    # avoid flicker when drawing a complex frame in multiple steps.
    # 
    # Set the `force complete redraw` to *true* to redraw the whole display
    # instead of only the changed parts. Normally it should not be necessary to set this to
    # *true*. It may only become necessary in case of stuck pixels because of errors.
    def draw_buffered_frame(force_complete_redraw)
      check_validity

      send_request FUNCTION_DRAW_BUFFERED_FRAME, [force_complete_redraw], '?', 8, ''
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletOLED128x64V2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletOLED128x64V2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletOLED128x64V2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletOLED128x64V2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Writes pixels to the specified window.
    # 
    # The pixels are written into the window line by line top to bottom
    # and each line is written from left to right.
    # 
    # If automatic draw is enabled (default) the pixels are directly written to
    # the screen. Only pixels that have actually changed are updated on the screen,
    # the rest stays the same.
    # 
    # If automatic draw is disabled the pixels are written to an internal buffer and
    # the buffer is transferred to the display only after BrickletOLED128x64V2#draw_buffered_frame
    # is called. This can be used to avoid flicker when drawing a complex frame in
    # multiple steps.
    # 
    # Automatic draw can be configured with the BrickletOLED128x64V2#set_display_configuration
    # function.
    def write_pixels(x_start, y_start, x_end, y_end, pixels)
      if pixels.length > 65535
        raise ArgumentError, 'Pixels can be at most 65535 items long'
      end

      pixels_length = pixels.length
      pixels_chunk_offset = 0

      if pixels_length == 0
        pixels_chunk_data = [false] * 448
        ret = write_pixels_low_level x_start, y_start, x_end, y_end, pixels_length, pixels_chunk_offset, pixels_chunk_data
      else
        ret = nil # assigned in block

        @stream_mutex.synchronize {
          while pixels_chunk_offset < pixels_length
            pixels_chunk_data = pixels[pixels_chunk_offset, 448]

            if pixels_chunk_data.length < 448
              pixels_chunk_data += [false] * (448 - pixels_chunk_data.length)
            end

            ret = write_pixels_low_level x_start, y_start, x_end, y_end, pixels_length, pixels_chunk_offset, pixels_chunk_data
            pixels_chunk_offset += 448
          end
        }
      end

      ret
    end

    # Reads pixels from the specified window.
    # 
    # The pixels are read from the window line by line top to bottom
    # and each line is read from left to right.
    # 
    # If automatic draw is enabled (default) the pixels that are read are always the
    # same that are shown on the display.
    # 
    # If automatic draw is disabled the pixels are read from the internal buffer
    # (see BrickletOLED128x64V2#draw_buffered_frame).
    # 
    # Automatic draw can be configured with the BrickletOLED128x64V2#set_display_configuration
    # function.
    def read_pixels(x_start, y_start, x_end, y_end)
      pixels_length = nil # assigned in block
      pixels_data = nil # assigned in block

      @stream_mutex.synchronize {
        ret = read_pixels_low_level x_start, y_start, x_end, y_end
        pixels_length = ret[0]
        pixels_chunk_offset = ret[1]
        pixels_out_of_sync = pixels_chunk_offset != 0
        pixels_data = ret[2]

        while not pixels_out_of_sync and pixels_data.length < pixels_length
          ret = read_pixels_low_level x_start, y_start, x_end, y_end
          pixels_length = ret[0]
          pixels_chunk_offset = ret[1]
          pixels_out_of_sync = pixels_chunk_offset != pixels_data.length
          pixels_data += ret[2]
        end

        if pixels_out_of_sync # discard remaining stream to bring it back in-sync
          while pixels_chunk_offset + 480 < pixels_length
            ret = read_pixels_low_level x_start, y_start, x_end, y_end
            pixels_length = ret[0]
            pixels_chunk_offset = ret[1]
          end

          raise StreamOutOfSyncException, 'Pixels stream is out-of-sync'
        end
      }

      pixels_data[0, pixels_length]
    end

  end
end
