# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Drives one brushed DC motor with up to 36V and 10A
  class BrickletPerformanceDC < Device
    DEVICE_IDENTIFIER = 2156 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Performance DC Bricklet' # :nodoc:

    # This callback is triggered if either the current consumption
    # is too high or the temperature of the driver chip is too high
    # (above 150°C) or the user defined thermal shutdown is triggered (see BrickletPerformanceDC#set_thermal_shutdown).
    # n case of a voltage below 6V (input voltage) this
    # callback is triggered as well.
    # 
    # If this callback is triggered, the driver chip gets disabled at the same time.
    # That means, BrickletPerformanceDC#set_enabled has to be called to drive the motor again.
    CALLBACK_EMERGENCY_SHUTDOWN = 35

    # This callback is triggered whenever a set velocity is reached. For example:
    # If a velocity of 0 is present, acceleration is set to 5000 and velocity
    # to 10000, the CALLBACK_VELOCITY_REACHED callback will be triggered after about
    # 2 seconds, when the set velocity is actually reached.
    # 
    # .. note::
    #  Since we can't get any feedback from the DC motor, this only works if the
    #  acceleration (see BrickletPerformanceDC#set_motion) is set smaller or equal to the
    #  maximum acceleration of the motor. Otherwise the motor will lag behind the
    #  control value and the callback will be triggered too early.
    CALLBACK_VELOCITY_REACHED = 36

    # This callback is triggered with the period that is set by
    # BrickletPerformanceDC#set_current_velocity_callback_configuration. The parameter is the *current*
    # velocity used by the motor.
    # 
    # The CALLBACK_CURRENT_VELOCITY callback is only triggered after the set period
    # if there is a change in the velocity.
    CALLBACK_CURRENT_VELOCITY = 37

    # This callback is triggered by GPIO changes if it is activated through BrickletPerformanceDC#set_gpio_action.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    CALLBACK_GPIO_STATE = 38

    FUNCTION_SET_ENABLED = 1 # :nodoc:
    FUNCTION_GET_ENABLED = 2 # :nodoc:
    FUNCTION_SET_VELOCITY = 3 # :nodoc:
    FUNCTION_GET_VELOCITY = 4 # :nodoc:
    FUNCTION_GET_CURRENT_VELOCITY = 5 # :nodoc:
    FUNCTION_SET_MOTION = 6 # :nodoc:
    FUNCTION_GET_MOTION = 7 # :nodoc:
    FUNCTION_FULL_BRAKE = 8 # :nodoc:
    FUNCTION_SET_DRIVE_MODE = 9 # :nodoc:
    FUNCTION_GET_DRIVE_MODE = 10 # :nodoc:
    FUNCTION_SET_PWM_FREQUENCY = 11 # :nodoc:
    FUNCTION_GET_PWM_FREQUENCY = 12 # :nodoc:
    FUNCTION_GET_POWER_STATISTICS = 13 # :nodoc:
    FUNCTION_SET_THERMAL_SHUTDOWN = 14 # :nodoc:
    FUNCTION_GET_THERMAL_SHUTDOWN = 15 # :nodoc:
    FUNCTION_SET_GPIO_CONFIGURATION = 16 # :nodoc:
    FUNCTION_GET_GPIO_CONFIGURATION = 17 # :nodoc:
    FUNCTION_SET_GPIO_ACTION = 18 # :nodoc:
    FUNCTION_GET_GPIO_ACTION = 19 # :nodoc:
    FUNCTION_GET_GPIO_STATE = 20 # :nodoc:
    FUNCTION_SET_ERROR_LED_CONFIG = 21 # :nodoc:
    FUNCTION_GET_ERROR_LED_CONFIG = 22 # :nodoc:
    FUNCTION_SET_CW_LED_CONFIG = 23 # :nodoc:
    FUNCTION_GET_CW_LED_CONFIG = 24 # :nodoc:
    FUNCTION_SET_CCW_LED_CONFIG = 25 # :nodoc:
    FUNCTION_GET_CCW_LED_CONFIG = 26 # :nodoc:
    FUNCTION_SET_GPIO_LED_CONFIG = 27 # :nodoc:
    FUNCTION_GET_GPIO_LED_CONFIG = 28 # :nodoc:
    FUNCTION_SET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION = 29 # :nodoc:
    FUNCTION_GET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION = 30 # :nodoc:
    FUNCTION_SET_VELOCITY_REACHED_CALLBACK_CONFIGURATION = 31 # :nodoc:
    FUNCTION_GET_VELOCITY_REACHED_CALLBACK_CONFIGURATION = 32 # :nodoc:
    FUNCTION_SET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION = 33 # :nodoc:
    FUNCTION_GET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION = 34 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    DRIVE_MODE_DRIVE_BRAKE = 0 # :nodoc:
    DRIVE_MODE_DRIVE_COAST = 1 # :nodoc:
    GPIO_ACTION_NONE = 0 # :nodoc:
    GPIO_ACTION_NORMAL_STOP_RISING_EDGE = 1 # :nodoc:
    GPIO_ACTION_NORMAL_STOP_FALLING_EDGE = 2 # :nodoc:
    GPIO_ACTION_FULL_BRAKE_RISING_EDGE = 4 # :nodoc:
    GPIO_ACTION_FULL_BRAKE_FALLING_EDGE = 8 # :nodoc:
    GPIO_ACTION_CALLBACK_RISING_EDGE = 16 # :nodoc:
    GPIO_ACTION_CALLBACK_FALLING_EDGE = 32 # :nodoc:
    ERROR_LED_CONFIG_OFF = 0 # :nodoc:
    ERROR_LED_CONFIG_ON = 1 # :nodoc:
    ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    ERROR_LED_CONFIG_SHOW_ERROR = 3 # :nodoc:
    CW_LED_CONFIG_OFF = 0 # :nodoc:
    CW_LED_CONFIG_ON = 1 # :nodoc:
    CW_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    CW_LED_CONFIG_SHOW_CW_AS_FORWARD = 3 # :nodoc:
    CW_LED_CONFIG_SHOW_CW_AS_BACKWARD = 4 # :nodoc:
    CCW_LED_CONFIG_OFF = 0 # :nodoc:
    CCW_LED_CONFIG_ON = 1 # :nodoc:
    CCW_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    CCW_LED_CONFIG_SHOW_CCW_AS_FORWARD = 3 # :nodoc:
    CCW_LED_CONFIG_SHOW_CCW_AS_BACKWARD = 4 # :nodoc:
    GPIO_LED_CONFIG_OFF = 0 # :nodoc:
    GPIO_LED_CONFIG_ON = 1 # :nodoc:
    GPIO_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    GPIO_LED_CONFIG_SHOW_GPIO_ACTIVE_HIGH = 3 # :nodoc:
    GPIO_LED_CONFIG_SHOW_GPIO_ACTIVE_LOW = 4 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_SET_ENABLED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VELOCITY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CURRENT_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOTION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOTION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_FULL_BRAKE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_DRIVE_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_DRIVE_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_PWM_FREQUENCY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_PWM_FREQUENCY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_POWER_STATISTICS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_THERMAL_SHUTDOWN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_THERMAL_SHUTDOWN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GPIO_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_GPIO_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GPIO_ACTION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_GPIO_ACTION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_GPIO_STATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ERROR_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ERROR_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CW_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CW_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CCW_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CCW_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GPIO_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_GPIO_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VELOCITY_REACHED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VELOCITY_REACHED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_EMERGENCY_SHUTDOWN] = [8, '']
      @callback_formats[CALLBACK_VELOCITY_REACHED] = [10, 's']
      @callback_formats[CALLBACK_CURRENT_VELOCITY] = [10, 's']
      @callback_formats[CALLBACK_GPIO_STATE] = [9, '?2']

      @ipcon.add_device self
    end

    # Enables/Disables the driver chip. The driver parameters can be configured
    # (velocity, acceleration, etc) before it is enabled.
    def set_enabled(enabled)
      check_validity

      send_request FUNCTION_SET_ENABLED, [enabled], '?', 8, ''
    end

    # Returns *true* if the driver chip is enabled, *false* otherwise.
    def get_enabled
      check_validity

      send_request FUNCTION_GET_ENABLED, [], '', 9, '?'
    end

    # Sets the velocity of the motor. Whereas -32767 is full speed backward,
    # 0 is stop and 32767 is full speed forward. Depending on the
    # acceleration (see BrickletPerformanceDC#set_motion), the motor is not immediately
    # brought to the velocity but smoothly accelerated.
    # 
    # The velocity describes the duty cycle of the PWM with which the motor is
    # controlled, e.g. a velocity of 3277 sets a PWM with a 10% duty cycle.
    # You can not only control the duty cycle of the PWM but also the frequency,
    # see BrickletPerformanceDC#set_pwm_frequency.
    def set_velocity(velocity)
      check_validity

      send_request FUNCTION_SET_VELOCITY, [velocity], 's', 8, ''
    end

    # Returns the velocity as set by BrickletPerformanceDC#set_velocity.
    def get_velocity
      check_validity

      send_request FUNCTION_GET_VELOCITY, [], '', 10, 's'
    end

    # Returns the *current* velocity of the motor. This value is different
    # from BrickletPerformanceDC#get_velocity whenever the motor is currently accelerating
    # to a goal set by BrickletPerformanceDC#set_velocity.
    def get_current_velocity
      check_validity

      send_request FUNCTION_GET_CURRENT_VELOCITY, [], '', 10, 's'
    end

    # Sets the acceleration and deceleration of the motor. It is given in *velocity/s*.
    # An acceleration of 10000 means, that every second the velocity is increased
    # by 10000 (or about 30% duty cycle).
    # 
    # For example: If the current velocity is 0 and you want to accelerate to a
    # velocity of 16000 (about 50% duty cycle) in 10 seconds, you should set
    # an acceleration of 1600.
    # 
    # If acceleration and deceleration is set to 0, there is no speed ramping, i.e. a
    # new velocity is immediately given to the motor.
    def set_motion(acceleration, deceleration)
      check_validity

      send_request FUNCTION_SET_MOTION, [acceleration, deceleration], 'S S', 8, ''
    end

    # Returns the acceleration/deceleration as set by BrickletPerformanceDC#set_motion.
    def get_motion
      check_validity

      send_request FUNCTION_GET_MOTION, [], '', 12, 'S S'
    end

    # Executes an active full brake.
    # 
    # .. warning::
    #  This function is for emergency purposes,
    #  where an immediate brake is necessary. Depending on the current velocity and
    #  the strength of the motor, a full brake can be quite violent.
    # 
    # Call BrickletPerformanceDC#set_velocity with 0 if you just want to stop the motor.
    def full_brake
      check_validity

      send_request FUNCTION_FULL_BRAKE, [], '', 8, ''
    end

    # Sets the drive mode. Possible modes are:
    # 
    # * 0 = Drive/Brake
    # * 1 = Drive/Coast
    # 
    # These modes are different kinds of motor controls.
    # 
    # In Drive/Brake mode, the motor is always either driving or braking. There
    # is no freewheeling. Advantages are: A more linear correlation between
    # PWM and velocity, more exact accelerations and the possibility to drive
    # with slower velocities.
    # 
    # In Drive/Coast mode, the motor is always either driving or freewheeling.
    # Advantages are: Less current consumption and less demands on the motor and
    # driver chip.
    def set_drive_mode(mode)
      check_validity

      send_request FUNCTION_SET_DRIVE_MODE, [mode], 'C', 8, ''
    end

    # Returns the drive mode, as set by BrickletPerformanceDC#set_drive_mode.
    def get_drive_mode
      check_validity

      send_request FUNCTION_GET_DRIVE_MODE, [], '', 9, 'C'
    end

    # Sets the frequency of the PWM with which the motor is driven.
    # Often a high frequency
    # is less noisy and the motor runs smoother. However, with a low frequency
    # there are less switches and therefore fewer switching losses. Also with
    # most motors lower frequencies enable higher torque.
    # 
    # If you have no idea what all this means, just ignore this function and use
    # the default frequency, it will very likely work fine.
    def set_pwm_frequency(frequency)
      check_validity

      send_request FUNCTION_SET_PWM_FREQUENCY, [frequency], 'S', 8, ''
    end

    # Returns the PWM frequency as set by BrickletPerformanceDC#set_pwm_frequency.
    def get_pwm_frequency
      check_validity

      send_request FUNCTION_GET_PWM_FREQUENCY, [], '', 10, 'S'
    end

    # Returns input voltage, current usage and temperature of the driver.
    def get_power_statistics
      check_validity

      send_request FUNCTION_GET_POWER_STATISTICS, [], '', 14, 'S S s'
    end

    # Sets a temperature threshold that is used for thermal shutdown.
    # 
    # Additionally to this user defined threshold the driver chip will shut down at a
    # temperature of 150°C.
    # 
    # If a thermal shutdown is triggered the driver is disabled and has to be
    # explicitly re-enabled with BrickletPerformanceDC#set_enabled.
    def set_thermal_shutdown(temperature)
      check_validity

      send_request FUNCTION_SET_THERMAL_SHUTDOWN, [temperature], 'C', 8, ''
    end

    # Returns the thermal shutdown temperature as set by BrickletPerformanceDC#set_thermal_shutdown.
    def get_thermal_shutdown
      check_validity

      send_request FUNCTION_GET_THERMAL_SHUTDOWN, [], '', 9, 'C'
    end

    # Sets the GPIO configuration for the given channel.
    # You can configure a debounce and the deceleration that is used if the action is
    # configured as ``normal stop``. See BrickletPerformanceDC#set_gpio_action.
    def set_gpio_configuration(channel, debounce, stop_deceleration)
      check_validity

      send_request FUNCTION_SET_GPIO_CONFIGURATION, [channel, debounce, stop_deceleration], 'C S S', 8, ''
    end

    # Returns the GPIO configuration for a channel as set by BrickletPerformanceDC#set_gpio_configuration.
    def get_gpio_configuration(channel)
      check_validity

      send_request FUNCTION_GET_GPIO_CONFIGURATION, [channel], 'C', 12, 'S S'
    end

    # Sets the GPIO action for the given channel.
    # 
    # The action can be a normal stop, a full brake or a callback. Each for a rising
    # edge or falling edge. The actions are a bitmask they can be used at the same time.
    # You can for example trigger a full brake and a callback at the same time or for
    # rising and falling edge.
    # 
    # The deceleration speed for the normal stop can be configured with
    # BrickletPerformanceDC#set_gpio_configuration.
    def set_gpio_action(channel, action)
      check_validity

      send_request FUNCTION_SET_GPIO_ACTION, [channel, action], 'C L', 8, ''
    end

    # Returns the GPIO action for a channel as set by BrickletPerformanceDC#set_gpio_action.
    def get_gpio_action(channel)
      check_validity

      send_request FUNCTION_GET_GPIO_ACTION, [channel], 'C', 12, 'L'
    end

    # Returns the GPIO state for both channels. True if the state is ``high`` and
    # false if the state is ``low``.
    def get_gpio_state
      check_validity

      send_request FUNCTION_GET_GPIO_STATE, [], '', 9, '?2'
    end

    # Configures the error LED to be either turned off, turned on, blink in
    # heartbeat mode or show an error.
    # 
    # If the LED is configured to show errors it has three different states:
    # 
    # * Off: No error present.
    # * 1s interval blinking: Input voltage too low (below 6V).
    # * 250ms interval blinking: Overtemperature or overcurrent.
    def set_error_led_config(config)
      check_validity

      send_request FUNCTION_SET_ERROR_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletPerformanceDC#set_error_led_config
    def get_error_led_config
      check_validity

      send_request FUNCTION_GET_ERROR_LED_CONFIG, [], '', 9, 'C'
    end

    # Configures the CW LED to be either turned off, turned on, blink in
    # heartbeat mode or if the motor turn clockwise.
    def set_cw_led_config(config)
      check_validity

      send_request FUNCTION_SET_CW_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletPerformanceDC#set_cw_led_config
    def get_cw_led_config
      check_validity

      send_request FUNCTION_GET_CW_LED_CONFIG, [], '', 9, 'C'
    end

    # Configures the CCW LED to be either turned off, turned on, blink in
    # heartbeat mode or if the motor turn counter-clockwise.
    def set_ccw_led_config(config)
      check_validity

      send_request FUNCTION_SET_CCW_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletPerformanceDC#set_ccw_led_config
    def get_ccw_led_config
      check_validity

      send_request FUNCTION_GET_CCW_LED_CONFIG, [], '', 9, 'C'
    end

    # Configures the GPIO LED to be either turned off, turned on, blink in
    # heartbeat mode or the GPIO state.
    # 
    # The GPIO LED can be configured for both channels.
    def set_gpio_led_config(channel, config)
      check_validity

      send_request FUNCTION_SET_GPIO_LED_CONFIG, [channel, config], 'C C', 8, ''
    end

    # Returns the LED configuration as set by BrickletPerformanceDC#set_gpio_led_config
    def get_gpio_led_config(channel)
      check_validity

      send_request FUNCTION_GET_GPIO_LED_CONFIG, [channel], 'C', 9, 'C'
    end

    # Enable/Disable CALLBACK_EMERGENCY_SHUTDOWN callback.
    def set_emergency_shutdown_callback_configuration(enabled)
      check_validity

      send_request FUNCTION_SET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION, [enabled], '?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletPerformanceDC#set_emergency_shutdown_callback_configuration.
    def get_emergency_shutdown_callback_configuration
      check_validity

      send_request FUNCTION_GET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION, [], '', 9, '?'
    end

    # Enable/Disable CALLBACK_VELOCITY_REACHED callback.
    def set_velocity_reached_callback_configuration(enabled)
      check_validity

      send_request FUNCTION_SET_VELOCITY_REACHED_CALLBACK_CONFIGURATION, [enabled], '?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletPerformanceDC#set_velocity_reached_callback_configuration.
    def get_velocity_reached_callback_configuration
      check_validity

      send_request FUNCTION_GET_VELOCITY_REACHED_CALLBACK_CONFIGURATION, [], '', 9, '?'
    end

    # The period is the period with which the CALLBACK_CURRENT_VELOCITY
    # callback is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_current_velocity_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletPerformanceDC#set_current_velocity_callback_configuration.
    def get_current_velocity_callback_configuration
      check_validity

      send_request FUNCTION_GET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletPerformanceDC#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletPerformanceDC#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletPerformanceDC#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletPerformanceDC#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
