# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Reads temperatures from Pt100 und Pt1000 sensors
  class BrickletPTCV2 < Device
    DEVICE_IDENTIFIER = 2101 # :nodoc:
    DEVICE_DISPLAY_NAME = 'PTC Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletPTCV2#set_temperature_callback_configuration.
    # 
    # The parameter is the same as BrickletPTCV2#get_temperature.
    CALLBACK_TEMPERATURE = 4

    # This callback is triggered periodically according to the configuration set by
    # BrickletPTCV2#set_resistance_callback_configuration.
    # 
    # The parameter is the same as BrickletPTCV2#get_resistance.
    CALLBACK_RESISTANCE = 8

    # This callback is triggered periodically according to the configuration set by
    # BrickletPTCV2#set_sensor_connected_callback_configuration.
    # 
    # The parameter is the same as BrickletPTCV2#is_sensor_connected.
    CALLBACK_SENSOR_CONNECTED = 18

    FUNCTION_GET_TEMPERATURE = 1 # :nodoc:
    FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_GET_RESISTANCE = 5 # :nodoc:
    FUNCTION_SET_RESISTANCE_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_RESISTANCE_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_SET_NOISE_REJECTION_FILTER = 9 # :nodoc:
    FUNCTION_GET_NOISE_REJECTION_FILTER = 10 # :nodoc:
    FUNCTION_IS_SENSOR_CONNECTED = 11 # :nodoc:
    FUNCTION_SET_WIRE_MODE = 12 # :nodoc:
    FUNCTION_GET_WIRE_MODE = 13 # :nodoc:
    FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION = 14 # :nodoc:
    FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION = 15 # :nodoc:
    FUNCTION_SET_SENSOR_CONNECTED_CALLBACK_CONFIGURATION = 16 # :nodoc:
    FUNCTION_GET_SENSOR_CONNECTED_CALLBACK_CONFIGURATION = 17 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    FILTER_OPTION_50HZ = 0 # :nodoc:
    FILTER_OPTION_60HZ = 1 # :nodoc:
    WIRE_MODE_2 = 2 # :nodoc:
    WIRE_MODE_3 = 3 # :nodoc:
    WIRE_MODE_4 = 4 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_RESISTANCE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RESISTANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_RESISTANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_NOISE_REJECTION_FILTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_NOISE_REJECTION_FILTER] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_IS_SENSOR_CONNECTED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIRE_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIRE_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_CONNECTED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_SENSOR_CONNECTED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_TEMPERATURE] = [12, 'l']
      @callback_formats[CALLBACK_RESISTANCE] = [12, 'l']
      @callback_formats[CALLBACK_SENSOR_CONNECTED] = [9, '?']

      @ipcon.add_device self
    end

    # Returns the temperature of the connected sensor.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_TEMPERATURE callback. You can set the callback configuration
    # with BrickletPTCV2#set_temperature_callback_configuration.
    def get_temperature
      check_validity

      send_request FUNCTION_GET_TEMPERATURE, [], '', 12, 'l'
    end

    # The period is the period with which the CALLBACK_TEMPERATURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_TEMPERATURE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_temperature_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k l l', 8, ''
    end

    # Returns the callback configuration as set by BrickletPTCV2#set_temperature_callback_configuration.
    def get_temperature_callback_configuration
      check_validity

      send_request FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, [], '', 22, 'L ? k l l'
    end

    # Returns the value as measured by the MAX31865 precision delta-sigma ADC.
    # 
    # The value can be converted with the following formulas:
    # 
    # * Pt100:  resistance = (value * 390) / 32768
    # * Pt1000: resistance = (value * 3900) / 32768
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_RESISTANCE callback. You can set the callback configuration
    # with BrickletPTCV2#set_resistance_callback_configuration.
    def get_resistance
      check_validity

      send_request FUNCTION_GET_RESISTANCE, [], '', 12, 'l'
    end

    # The period is the period with which the CALLBACK_RESISTANCE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_RESISTANCE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_resistance_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_RESISTANCE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k l l', 8, ''
    end

    # Returns the callback configuration as set by BrickletPTCV2#set_resistance_callback_configuration.
    def get_resistance_callback_configuration
      check_validity

      send_request FUNCTION_GET_RESISTANCE_CALLBACK_CONFIGURATION, [], '', 22, 'L ? k l l'
    end

    # Sets the noise rejection filter to either 50Hz (0) or 60Hz (1).
    # Noise from 50Hz or 60Hz power sources (including
    # harmonics of the AC power's fundamental frequency) is
    # attenuated by 82dB.
    def set_noise_rejection_filter(filter)
      check_validity

      send_request FUNCTION_SET_NOISE_REJECTION_FILTER, [filter], 'C', 8, ''
    end

    # Returns the noise rejection filter option as set by
    # BrickletPTCV2#set_noise_rejection_filter
    def get_noise_rejection_filter
      check_validity

      send_request FUNCTION_GET_NOISE_REJECTION_FILTER, [], '', 9, 'C'
    end

    # Returns *true* if the sensor is connected correctly.
    # 
    # If this function
    # returns *false*, there is either no Pt100 or Pt1000 sensor connected,
    # the sensor is connected incorrectly or the sensor itself is faulty.
    # 
    # If you want to get the status automatically, it is recommended to use the
    # CALLBACK_SENSOR_CONNECTED callback. You can set the callback configuration
    # with BrickletPTCV2#set_sensor_connected_callback_configuration.
    def is_sensor_connected
      check_validity

      send_request FUNCTION_IS_SENSOR_CONNECTED, [], '', 9, '?'
    end

    # Sets the wire mode of the sensor. Possible values are 2, 3 and 4 which
    # correspond to 2-, 3- and 4-wire sensors. The value has to match the jumper
    # configuration on the Bricklet.
    def set_wire_mode(mode)
      check_validity

      send_request FUNCTION_SET_WIRE_MODE, [mode], 'C', 8, ''
    end

    # Returns the wire mode as set by BrickletPTCV2#set_wire_mode
    def get_wire_mode
      check_validity

      send_request FUNCTION_GET_WIRE_MODE, [], '', 9, 'C'
    end

    # Sets the length of a `moving averaging <https://en.wikipedia.org/wiki/Moving_average>`__
    # for the resistance and temperature.
    # 
    # Setting the length to 1 will turn the averaging off. With less
    # averaging, there is more noise on the data.
    # 
    # New data is gathered every 20ms. With a moving average of length 1000 the resulting
    # averaging window has a length of 20s. If you want to do long term measurements the longest
    # moving average will give the cleanest results.
    # 
    # The default values match the non-changeable averaging settings of the old PTC Bricklet 1.0
    def set_moving_average_configuration(moving_average_length_resistance, moving_average_length_temperature)
      check_validity

      send_request FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION, [moving_average_length_resistance, moving_average_length_temperature], 'S S', 8, ''
    end

    # Returns the moving average configuration as set by BrickletPTCV2#set_moving_average_configuration.
    def get_moving_average_configuration
      check_validity

      send_request FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION, [], '', 12, 'S S'
    end

    # If you enable this callback, the CALLBACK_SENSOR_CONNECTED callback is triggered
    # every time a Pt sensor is connected/disconnected.
    def set_sensor_connected_callback_configuration(enabled)
      check_validity

      send_request FUNCTION_SET_SENSOR_CONNECTED_CALLBACK_CONFIGURATION, [enabled], '?', 8, ''
    end

    # Returns the configuration as set by BrickletPTCV2#set_sensor_connected_callback_configuration.
    def get_sensor_connected_callback_configuration
      check_validity

      send_request FUNCTION_GET_SENSOR_CONNECTED_CALLBACK_CONFIGURATION, [], '', 9, '?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletPTCV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletPTCV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletPTCV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletPTCV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
