# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # RGB LED Matrix with 8x8 pixel
  class BrickletRGBLEDMatrix < Device
    DEVICE_IDENTIFIER = 272 # :nodoc:
    DEVICE_DISPLAY_NAME = 'RGB LED Matrix Bricklet' # :nodoc:

    # This callback is triggered as soon as a new frame write is started.
    # The LED values are double buffered, so you can send the LED values
    # for the next frame directly after this callback is triggered.
    CALLBACK_FRAME_STARTED = 11

    FUNCTION_SET_RED = 1 # :nodoc:
    FUNCTION_GET_RED = 2 # :nodoc:
    FUNCTION_SET_GREEN = 3 # :nodoc:
    FUNCTION_GET_GREEN = 4 # :nodoc:
    FUNCTION_SET_BLUE = 5 # :nodoc:
    FUNCTION_GET_BLUE = 6 # :nodoc:
    FUNCTION_SET_FRAME_DURATION = 7 # :nodoc:
    FUNCTION_GET_FRAME_DURATION = 8 # :nodoc:
    FUNCTION_DRAW_FRAME = 9 # :nodoc:
    FUNCTION_GET_SUPPLY_VOLTAGE = 10 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_RED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GREEN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_GREEN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BLUE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_BLUE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_FRAME_DURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_FRAME_DURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_DRAW_FRAME] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SUPPLY_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_FRAME_STARTED] = [12, 'L']

      @ipcon.add_device self
    end

    # Sets the 64 red LED values of the matrix.
    def set_red(red)
      check_validity

      send_request FUNCTION_SET_RED, [red], 'C64', 8, ''
    end

    # Returns the red LED values as set by BrickletRGBLEDMatrix#set_red.
    def get_red
      check_validity

      send_request FUNCTION_GET_RED, [], '', 72, 'C64'
    end

    # Sets the 64 green LED values of the matrix.
    def set_green(green)
      check_validity

      send_request FUNCTION_SET_GREEN, [green], 'C64', 8, ''
    end

    # Returns the green LED values as set by BrickletRGBLEDMatrix#set_green.
    def get_green
      check_validity

      send_request FUNCTION_GET_GREEN, [], '', 72, 'C64'
    end

    # Sets the 64 blue LED values of the matrix.
    def set_blue(blue)
      check_validity

      send_request FUNCTION_SET_BLUE, [blue], 'C64', 8, ''
    end

    # Returns the blue LED values as set by BrickletRGBLEDMatrix#set_blue.
    def get_blue
      check_validity

      send_request FUNCTION_GET_BLUE, [], '', 72, 'C64'
    end

    # Sets the frame duration.
    # 
    # Example: If you want to achieve 20 frames per second, you should
    # set the frame duration to 50ms (50ms * 20 = 1 second).
    # 
    # Set this value to 0 to turn the automatic frame write mechanism off.
    # 
    # Approach:
    # 
    # * Call BrickletRGBLEDMatrix#set_frame_duration with value > 0.
    # * Set LED values for first frame with BrickletRGBLEDMatrix#set_red, BrickletRGBLEDMatrix#set_green, BrickletRGBLEDMatrix#set_blue.
    # * Wait for CALLBACK_FRAME_STARTED callback.
    # * Set LED values for second frame with BrickletRGBLEDMatrix#set_red, BrickletRGBLEDMatrix#set_green, BrickletRGBLEDMatrix#set_blue.
    # * Wait for CALLBACK_FRAME_STARTED callback.
    # * and so on.
    # 
    # For frame duration of 0 see BrickletRGBLEDMatrix#draw_frame.
    def set_frame_duration(frame_duration)
      check_validity

      send_request FUNCTION_SET_FRAME_DURATION, [frame_duration], 'S', 8, ''
    end

    # Returns the frame duration as set by BrickletRGBLEDMatrix#set_frame_duration.
    def get_frame_duration
      check_validity

      send_request FUNCTION_GET_FRAME_DURATION, [], '', 10, 'S'
    end

    # If you set the frame duration to 0 (see BrickletRGBLEDMatrix#set_frame_duration), you can use this
    # function to transfer the frame to the matrix.
    # 
    # Approach:
    # 
    # * Call BrickletRGBLEDMatrix#set_frame_duration with 0.
    # * Set LED values for first frame with BrickletRGBLEDMatrix#set_red, BrickletRGBLEDMatrix#set_green, BrickletRGBLEDMatrix#set_blue.
    # * Call BrickletRGBLEDMatrix#draw_frame.
    # * Wait for CALLBACK_FRAME_STARTED callback.
    # * Set LED values for second frame with BrickletRGBLEDMatrix#set_red, BrickletRGBLEDMatrix#set_green, BrickletRGBLEDMatrix#set_blue.
    # * Call BrickletRGBLEDMatrix#draw_frame.
    # * Wait for CALLBACK_FRAME_STARTED callback.
    # * and so on.
    def draw_frame
      check_validity

      send_request FUNCTION_DRAW_FRAME, [], '', 8, ''
    end

    # Returns the current supply voltage of the Bricklet.
    def get_supply_voltage
      check_validity

      send_request FUNCTION_GET_SUPPLY_VOLTAGE, [], '', 10, 'S'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletRGBLEDMatrix#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletRGBLEDMatrix#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletRGBLEDMatrix#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletRGBLEDMatrix#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
