# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # 300° rotary potentiometer
  class BrickletRotaryPoti < Device
    DEVICE_IDENTIFIER = 215 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Rotary Poti Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletRotaryPoti#set_position_callback_period. The parameter is the position of
    # the rotary potentiometer.
    # 
    # The CALLBACK_POSITION callback is only triggered if the position has changed since
    # the last triggering.
    CALLBACK_POSITION = 13

    # This callback is triggered periodically with the period that is set by
    # BrickletRotaryPoti#set_analog_value_callback_period. The parameter is the
    # analog value of the rotary potentiometer.
    # 
    # The CALLBACK_ANALOG_VALUE callback is only triggered if the position has changed
    # since the last triggering.
    CALLBACK_ANALOG_VALUE = 14

    # This callback is triggered when the threshold as set by
    # BrickletRotaryPoti#set_position_callback_threshold is reached.
    # The parameter is the position of the rotary potentiometer.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletRotaryPoti#set_debounce_period.
    CALLBACK_POSITION_REACHED = 15

    # This callback is triggered when the threshold as set by
    # BrickletRotaryPoti#set_analog_value_callback_threshold is reached.
    # The parameter is the analog value of the rotary potentiometer.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletRotaryPoti#set_debounce_period.
    CALLBACK_ANALOG_VALUE_REACHED = 16

    FUNCTION_GET_POSITION = 1 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE = 2 # :nodoc:
    FUNCTION_SET_POSITION_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_GET_POSITION_CALLBACK_PERIOD = 4 # :nodoc:
    FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6 # :nodoc:
    FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = 7 # :nodoc:
    FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = 8 # :nodoc:
    FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 11 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 12 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_POSITION_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_POSITION_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_POSITION_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_POSITION_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_POSITION] = [10, 's']
      @callback_formats[CALLBACK_ANALOG_VALUE] = [10, 'S']
      @callback_formats[CALLBACK_POSITION_REACHED] = [10, 's']
      @callback_formats[CALLBACK_ANALOG_VALUE_REACHED] = [10, 'S']

      @ipcon.add_device self
    end

    # Returns the position of the rotary potentiometer. The value is
    # between -150° (turned left) and 150° (turned right).
    # 
    # If you want to get the position periodically, it is recommended to use the
    # CALLBACK_POSITION callback and set the period with
    # BrickletRotaryPoti#set_position_callback_period.
    def get_position
      check_validity

      send_request FUNCTION_GET_POSITION, [], '', 10, 's'
    end

    # Returns the value as read by a 12-bit analog-to-digital converter.
    # 
    # .. note::
    #  The value returned by BrickletRotaryPoti#get_position is averaged over several samples
    #  to yield less noise, while BrickletRotaryPoti#get_analog_value gives back raw
    #  unfiltered analog values. The only reason to use BrickletRotaryPoti#get_analog_value is,
    #  if you need the full resolution of the analog-to-digital converter.
    # 
    # If you want the analog value periodically, it is recommended to use the
    # CALLBACK_ANALOG_VALUE callback and set the period with
    # BrickletRotaryPoti#set_analog_value_callback_period.
    def get_analog_value
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE, [], '', 10, 'S'
    end

    # Sets the period with which the CALLBACK_POSITION callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_POSITION callback is only triggered if the position has changed since
    # the last triggering.
    def set_position_callback_period(period)
      check_validity

      send_request FUNCTION_SET_POSITION_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletRotaryPoti#set_position_callback_period.
    def get_position_callback_period
      check_validity

      send_request FUNCTION_GET_POSITION_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ANALOG_VALUE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_ANALOG_VALUE callback is only triggered if the analog value has
    # changed since the last triggering.
    def set_analog_value_callback_period(period)
      check_validity

      send_request FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletRotaryPoti#set_analog_value_callback_period.
    def get_analog_value_callback_period
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the thresholds for the CALLBACK_POSITION_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the position is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the position is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the position is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the position is greater than the min value (max is ignored)"
    def set_position_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_POSITION_CALLBACK_THRESHOLD, [option, min, max], 'k s s', 8, ''
    end

    # Returns the threshold as set by BrickletRotaryPoti#set_position_callback_threshold.
    def get_position_callback_threshold
      check_validity

      send_request FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, [], '', 13, 'k s s'
    end

    # Sets the thresholds for the CALLBACK_ANALOG_VALUE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
    def set_analog_value_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 8, ''
    end

    # Returns the threshold as set by BrickletRotaryPoti#set_analog_value_callback_threshold.
    def get_analog_value_callback_threshold
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, [], '', 13, 'k S S'
    end

    # Sets the period with which the threshold callbacks
    # 
    # * CALLBACK_POSITION_REACHED,
    # * CALLBACK_ANALOG_VALUE_REACHED
    # 
    # are triggered, if the thresholds
    # 
    # * BrickletRotaryPoti#set_position_callback_threshold,
    # * BrickletRotaryPoti#set_analog_value_callback_threshold
    # 
    # keep being reached.
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickletRotaryPoti#set_debounce_period.
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
