# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Drives up to 10 RC Servos
  class BrickletServoV2 < Device
    DEVICE_IDENTIFIER = 2157 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Servo Bricklet 2.0' # :nodoc:

    # This callback is triggered when a position set by BrickletServoV2#set_position
    # is reached. If the new position matches the current position then the
    # callback is not triggered, because the servo didn't move.
    # The parameters are the servo and the position that is reached.
    # 
    # You can enable this callback with BrickletServoV2#set_position_reached_callback_configuration.
    # 
    # .. note::
    #  Since we can't get any feedback from the servo, this only works if the
    #  velocity (see BrickletServoV2#set_motion_configuration) is set smaller or equal to the
    #  maximum velocity of the servo. Otherwise the servo will lag behind the
    #  control value and the callback will be triggered too early.
    CALLBACK_POSITION_REACHED = 27

    FUNCTION_GET_STATUS = 1 # :nodoc:
    FUNCTION_SET_ENABLE = 2 # :nodoc:
    FUNCTION_GET_ENABLED = 3 # :nodoc:
    FUNCTION_SET_POSITION = 4 # :nodoc:
    FUNCTION_GET_POSITION = 5 # :nodoc:
    FUNCTION_GET_CURRENT_POSITION = 6 # :nodoc:
    FUNCTION_GET_CURRENT_VELOCITY = 7 # :nodoc:
    FUNCTION_SET_MOTION_CONFIGURATION = 8 # :nodoc:
    FUNCTION_GET_MOTION_CONFIGURATION = 9 # :nodoc:
    FUNCTION_SET_PULSE_WIDTH = 10 # :nodoc:
    FUNCTION_GET_PULSE_WIDTH = 11 # :nodoc:
    FUNCTION_SET_DEGREE = 12 # :nodoc:
    FUNCTION_GET_DEGREE = 13 # :nodoc:
    FUNCTION_SET_PERIOD = 14 # :nodoc:
    FUNCTION_GET_PERIOD = 15 # :nodoc:
    FUNCTION_GET_SERVO_CURRENT = 16 # :nodoc:
    FUNCTION_SET_SERVO_CURRENT_CONFIGURATION = 17 # :nodoc:
    FUNCTION_GET_SERVO_CURRENT_CONFIGURATION = 18 # :nodoc:
    FUNCTION_SET_INPUT_VOLTAGE_CONFIGURATION = 19 # :nodoc:
    FUNCTION_GET_INPUT_VOLTAGE_CONFIGURATION = 20 # :nodoc:
    FUNCTION_GET_OVERALL_CURRENT = 21 # :nodoc:
    FUNCTION_GET_INPUT_VOLTAGE = 22 # :nodoc:
    FUNCTION_SET_CURRENT_CALIBRATION = 23 # :nodoc:
    FUNCTION_GET_CURRENT_CALIBRATION = 24 # :nodoc:
    FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION = 25 # :nodoc:
    FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION = 26 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ENABLE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_POSITION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CURRENT_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CURRENT_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOTION_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOTION_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_PULSE_WIDTH] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_PULSE_WIDTH] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEGREE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_DEGREE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_PERIOD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SERVO_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SERVO_CURRENT_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SERVO_CURRENT_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_INPUT_VOLTAGE_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_INPUT_VOLTAGE_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_OVERALL_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_INPUT_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT_CALIBRATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CURRENT_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_POSITION_REACHED] = [12, 'S s']

      @ipcon.add_device self
    end

    # Returns the status information of the Servo Bricklet 2.0.
    # 
    # The status includes
    # 
    # * for each channel if it is enabled or disabled,
    # * for each channel the current position,
    # * for each channel the current velocity,
    # * for each channel the current usage and
    # * the input voltage.
    # 
    # Please note that the position and the velocity is a snapshot of the
    # current position and velocity of the servo in motion.
    def get_status
      check_validity

      send_request FUNCTION_GET_STATUS, [], '', 72, '?10 s10 s10 S10 S'
    end

    # Enables a servo channel (0 to 9). If a servo is enabled, the configured position,
    # velocity, acceleration, etc. are applied immediately.
    def set_enable(servo_channel, enable)
      check_validity

      send_request FUNCTION_SET_ENABLE, [servo_channel, enable], 'S ?', 8, ''
    end

    # Returns *true* if the specified servo channel is enabled, *false* otherwise.
    def get_enabled(servo_channel)
      check_validity

      send_request FUNCTION_GET_ENABLED, [servo_channel], 'S', 9, '?'
    end

    # Sets the position in °/100 for the specified servo channel.
    # 
    # The default range of the position is -9000 to 9000, but it can be specified
    # according to your servo with BrickletServoV2#set_degree.
    # 
    # If you want to control a linear servo or RC brushless motor controller or
    # similar with the Servo Brick, you can also define lengths or speeds with
    # BrickletServoV2#set_degree.
    def set_position(servo_channel, position)
      check_validity

      send_request FUNCTION_SET_POSITION, [servo_channel, position], 'S s', 8, ''
    end

    # Returns the position of the specified servo channel as set by BrickletServoV2#set_position.
    def get_position(servo_channel)
      check_validity

      send_request FUNCTION_GET_POSITION, [servo_channel], 'S', 10, 's'
    end

    # Returns the *current* position of the specified servo channel. This may not be the
    # value of BrickletServoV2#set_position if the servo is currently approaching a
    # position goal.
    def get_current_position(servo_channel)
      check_validity

      send_request FUNCTION_GET_CURRENT_POSITION, [servo_channel], 'S', 10, 's'
    end

    # Returns the *current* velocity of the specified servo channel. This may not be the
    # velocity specified by BrickletServoV2#set_motion_configuration. if the servo is
    # currently approaching a velocity goal.
    def get_current_velocity(servo_channel)
      check_validity

      send_request FUNCTION_GET_CURRENT_VELOCITY, [servo_channel], 'S', 10, 'S'
    end

    # Sets the maximum velocity of the specified servo channel in °/100s as well as
    # the acceleration and deceleration in °/100s²
    # 
    # With a velocity of 0 °/100s the position will be set immediately (no velocity).
    # 
    # With an acc-/deceleration of 0 °/100s² the velocity will be set immediately
    # (no acc-/deceleration).
    def set_motion_configuration(servo_channel, velocity, acceleration, deceleration)
      check_validity

      send_request FUNCTION_SET_MOTION_CONFIGURATION, [servo_channel, velocity, acceleration, deceleration], 'S L L L', 8, ''
    end

    # Returns the motion configuration as set by BrickletServoV2#set_motion_configuration.
    def get_motion_configuration(servo_channel)
      check_validity

      send_request FUNCTION_GET_MOTION_CONFIGURATION, [servo_channel], 'S', 20, 'L L L'
    end

    # Sets the minimum and maximum pulse width of the specified servo channel in µs.
    # 
    # Usually, servos are controlled with a
    # `PWM <https://en.wikipedia.org/wiki/Pulse-width_modulation>`__, whereby the
    # length of the pulse controls the position of the servo. Every servo has
    # different minimum and maximum pulse widths, these can be specified with
    # this function.
    # 
    # If you have a datasheet for your servo that specifies the minimum and
    # maximum pulse width, you should set the values accordingly. If your servo
    # comes without any datasheet you have to find the values via trial and error.
    # 
    # Both values have a range from 1 to 65535 (unsigned 16-bit integer). The
    # minimum must be smaller than the maximum.
    # 
    # The default values are 1000µs (1ms) and 2000µs (2ms) for minimum and
    # maximum pulse width.
    def set_pulse_width(servo_channel, min, max)
      check_validity

      send_request FUNCTION_SET_PULSE_WIDTH, [servo_channel, min, max], 'S L L', 8, ''
    end

    # Returns the minimum and maximum pulse width for the specified servo channel as set by
    # BrickletServoV2#set_pulse_width.
    def get_pulse_width(servo_channel)
      check_validity

      send_request FUNCTION_GET_PULSE_WIDTH, [servo_channel], 'S', 16, 'L L'
    end

    # Sets the minimum and maximum degree for the specified servo channel (by default
    # given as °/100).
    # 
    # This only specifies the abstract values between which the minimum and maximum
    # pulse width is scaled. For example: If you specify a pulse width of 1000µs
    # to 2000µs and a degree range of -90° to 90°, a call of BrickletServoV2#set_position
    # with 0 will result in a pulse width of 1500µs
    # (-90° = 1000µs, 90° = 2000µs, etc.).
    # 
    # Possible usage:
    # 
    # * The datasheet of your servo specifies a range of 200° with the middle position
    #   at 110°. In this case you can set the minimum to -9000 and the maximum to 11000.
    # * You measure a range of 220° on your servo and you don't have or need a middle
    #   position. In this case you can set the minimum to 0 and the maximum to 22000.
    # * You have a linear servo with a drive length of 20cm, In this case you could
    #   set the minimum to 0 and the maximum to 20000. Now you can set the Position
    #   with BrickletServoV2#set_position with a resolution of cm/100. Also the velocity will
    #   have a resolution of cm/100s and the acceleration will have a resolution of
    #   cm/100s².
    # * You don't care about units and just want the highest possible resolution. In
    #   this case you should set the minimum to -32767 and the maximum to 32767.
    # * You have a brushless motor with a maximum speed of 10000 rpm and want to
    #   control it with a RC brushless motor controller. In this case you can set the
    #   minimum to 0 and the maximum to 10000. BrickletServoV2#set_position now controls the rpm.
    # 
    # Both values have a possible range from -32767 to 32767
    # (signed 16-bit integer). The minimum must be smaller than the maximum.
    # 
    # The default values are -9000 and 9000 for the minimum and maximum degree.
    def set_degree(servo_channel, min, max)
      check_validity

      send_request FUNCTION_SET_DEGREE, [servo_channel, min, max], 'S s s', 8, ''
    end

    # Returns the minimum and maximum degree for the specified servo channel as set by
    # BrickletServoV2#set_degree.
    def get_degree(servo_channel)
      check_validity

      send_request FUNCTION_GET_DEGREE, [servo_channel], 'S', 12, 's s'
    end

    # Sets the period of the specified servo channel in µs.
    # 
    # Usually, servos are controlled with a
    # `PWM <https://en.wikipedia.org/wiki/Pulse-width_modulation>`__. Different
    # servos expect PWMs with different periods. Most servos run well with a
    # period of about 20ms.
    # 
    # If your servo comes with a datasheet that specifies a period, you should
    # set it accordingly. If you don't have a datasheet and you have no idea
    # what the correct period is, the default value (19.5ms) will most likely
    # work fine.
    # 
    # The minimum possible period is 1µs and the maximum is 1000000µs.
    # 
    # The default value is 19.5ms (19500µs).
    def set_period(servo_channel, period)
      check_validity

      send_request FUNCTION_SET_PERIOD, [servo_channel, period], 'S L', 8, ''
    end

    # Returns the period for the specified servo channel as set by BrickletServoV2#set_period.
    def get_period(servo_channel)
      check_validity

      send_request FUNCTION_GET_PERIOD, [servo_channel], 'S', 12, 'L'
    end

    # Returns the current consumption of the specified servo channel in mA.
    def get_servo_current(servo_channel)
      check_validity

      send_request FUNCTION_GET_SERVO_CURRENT, [servo_channel], 'S', 10, 'S'
    end

    # Sets the averaging duration of the current measurement for the specified servo channel in ms.
    def set_servo_current_configuration(servo_channel, averaging_duration)
      check_validity

      send_request FUNCTION_SET_SERVO_CURRENT_CONFIGURATION, [servo_channel, averaging_duration], 'S C', 8, ''
    end

    # Returns the servo current configuration for the specified servo channel as set
    # by BrickletServoV2#set_servo_current_configuration.
    def get_servo_current_configuration(servo_channel)
      check_validity

      send_request FUNCTION_GET_SERVO_CURRENT_CONFIGURATION, [servo_channel], 'S', 9, 'C'
    end

    # Sets the averaging duration of the input voltage measurement for the specified servo channel in ms.
    def set_input_voltage_configuration(averaging_duration)
      check_validity

      send_request FUNCTION_SET_INPUT_VOLTAGE_CONFIGURATION, [averaging_duration], 'C', 8, ''
    end

    # Returns the input voltage configuration as set by BrickletServoV2#set_input_voltage_configuration.
    def get_input_voltage_configuration
      check_validity

      send_request FUNCTION_GET_INPUT_VOLTAGE_CONFIGURATION, [], '', 9, 'C'
    end

    # Returns the current consumption of all servos together in mA.
    def get_overall_current
      check_validity

      send_request FUNCTION_GET_OVERALL_CURRENT, [], '', 10, 'S'
    end

    # Returns the input voltage in mV. The input voltage is
    # given via the black power input connector on the Servo Brick.
    def get_input_voltage
      check_validity

      send_request FUNCTION_GET_INPUT_VOLTAGE, [], '', 10, 'S'
    end

    # Sets an offset value (in mA) for each channel.
    # 
    # Note: On delivery the Servo Bricklet 2.0 is already calibrated.
    def set_current_calibration(offset)
      check_validity

      send_request FUNCTION_SET_CURRENT_CALIBRATION, [offset], 's10', 8, ''
    end

    # Returns the current calibration as set by BrickletServoV2#set_current_calibration.
    def get_current_calibration
      check_validity

      send_request FUNCTION_GET_CURRENT_CALIBRATION, [], '', 28, 's10'
    end

    # Enable/Disable CALLBACK_POSITION_REACHED callback.
    def set_position_reached_callback_configuration(servo_channel, enabled)
      check_validity

      send_request FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION, [servo_channel, enabled], 'S ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletServoV2#set_position_reached_callback_configuration.
    def get_position_reached_callback_configuration(servo_channel)
      check_validity

      send_request FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION, [servo_channel], 'S', 9, '?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletServoV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletServoV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletServoV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletServoV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
