# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Silently drives one bipolar stepper motor with up to 46V and 1.6A per phase
  class BrickletSilentStepperV2 < Device
    DEVICE_IDENTIFIER = 2166 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Silent Stepper Bricklet 2.0' # :nodoc:

    # This callback is triggered when the input voltage drops below the value set by
    # BrickletSilentStepperV2#set_minimum_voltage. The parameter is the current voltage.
    CALLBACK_UNDER_VOLTAGE = 41

    # This callback is triggered when a position set by BrickletSilentStepperV2#set_steps or
    # BrickletSilentStepperV2#set_target_position is reached.
    # 
    # .. note::
    #  Since we can't get any feedback from the stepper motor, this only works if the
    #  acceleration (see BrickletSilentStepperV2#set_speed_ramping) is set smaller or equal to the
    #  maximum acceleration of the motor. Otherwise the motor will lag behind the
    #  control value and the callback will be triggered too early.
    CALLBACK_POSITION_REACHED = 42

    # This callback is triggered periodically with the period that is set by
    # BrickletSilentStepperV2#set_all_callback_configuration. The parameters are: the current velocity,
    # the current position, the remaining steps, the stack voltage, the external
    # voltage and the current consumption of the stepper motor.
    CALLBACK_ALL_DATA = 53

    # This callback is triggered whenever the Silent Stepper Bricklet 2.0 enters a new state.
    # It returns the new state as well as the previous state.
    CALLBACK_NEW_STATE = 54

    # This callback is triggered by GPIO changes if it is activated through BrickletSilentStepperV2#set_gpio_action.
    CALLBACK_GPIO_STATE = 55

    FUNCTION_SET_MAX_VELOCITY = 1 # :nodoc:
    FUNCTION_GET_MAX_VELOCITY = 2 # :nodoc:
    FUNCTION_GET_CURRENT_VELOCITY = 3 # :nodoc:
    FUNCTION_SET_SPEED_RAMPING = 4 # :nodoc:
    FUNCTION_GET_SPEED_RAMPING = 5 # :nodoc:
    FUNCTION_FULL_BRAKE = 6 # :nodoc:
    FUNCTION_SET_CURRENT_POSITION = 7 # :nodoc:
    FUNCTION_GET_CURRENT_POSITION = 8 # :nodoc:
    FUNCTION_SET_TARGET_POSITION = 9 # :nodoc:
    FUNCTION_GET_TARGET_POSITION = 10 # :nodoc:
    FUNCTION_SET_STEPS = 11 # :nodoc:
    FUNCTION_GET_STEPS = 12 # :nodoc:
    FUNCTION_GET_REMAINING_STEPS = 13 # :nodoc:
    FUNCTION_SET_STEP_CONFIGURATION = 14 # :nodoc:
    FUNCTION_GET_STEP_CONFIGURATION = 15 # :nodoc:
    FUNCTION_DRIVE_FORWARD = 16 # :nodoc:
    FUNCTION_DRIVE_BACKWARD = 17 # :nodoc:
    FUNCTION_STOP = 18 # :nodoc:
    FUNCTION_GET_INPUT_VOLTAGE = 19 # :nodoc:
    FUNCTION_SET_MOTOR_CURRENT = 22 # :nodoc:
    FUNCTION_GET_MOTOR_CURRENT = 23 # :nodoc:
    FUNCTION_SET_ENABLED = 24 # :nodoc:
    FUNCTION_GET_ENABLED = 25 # :nodoc:
    FUNCTION_SET_BASIC_CONFIGURATION = 26 # :nodoc:
    FUNCTION_GET_BASIC_CONFIGURATION = 27 # :nodoc:
    FUNCTION_SET_SPREADCYCLE_CONFIGURATION = 28 # :nodoc:
    FUNCTION_GET_SPREADCYCLE_CONFIGURATION = 29 # :nodoc:
    FUNCTION_SET_STEALTH_CONFIGURATION = 30 # :nodoc:
    FUNCTION_GET_STEALTH_CONFIGURATION = 31 # :nodoc:
    FUNCTION_SET_COOLSTEP_CONFIGURATION = 32 # :nodoc:
    FUNCTION_GET_COOLSTEP_CONFIGURATION = 33 # :nodoc:
    FUNCTION_SET_MISC_CONFIGURATION = 34 # :nodoc:
    FUNCTION_GET_MISC_CONFIGURATION = 35 # :nodoc:
    FUNCTION_SET_ERROR_LED_CONFIG = 36 # :nodoc:
    FUNCTION_GET_ERROR_LED_CONFIG = 37 # :nodoc:
    FUNCTION_GET_DRIVER_STATUS = 38 # :nodoc:
    FUNCTION_SET_MINIMUM_VOLTAGE = 39 # :nodoc:
    FUNCTION_GET_MINIMUM_VOLTAGE = 40 # :nodoc:
    FUNCTION_SET_TIME_BASE = 43 # :nodoc:
    FUNCTION_GET_TIME_BASE = 44 # :nodoc:
    FUNCTION_GET_ALL_DATA = 45 # :nodoc:
    FUNCTION_SET_ALL_CALLBACK_CONFIGURATION = 46 # :nodoc:
    FUNCTION_GET_ALL_DATA_CALLBACK_CONFIGURATON = 47 # :nodoc:
    FUNCTION_SET_GPIO_CONFIGURATION = 48 # :nodoc:
    FUNCTION_GET_GPIO_CONFIGURATION = 49 # :nodoc:
    FUNCTION_SET_GPIO_ACTION = 50 # :nodoc:
    FUNCTION_GET_GPIO_ACTION = 51 # :nodoc:
    FUNCTION_GET_GPIO_STATE = 52 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    STEP_RESOLUTION_1 = 8 # :nodoc:
    STEP_RESOLUTION_2 = 7 # :nodoc:
    STEP_RESOLUTION_4 = 6 # :nodoc:
    STEP_RESOLUTION_8 = 5 # :nodoc:
    STEP_RESOLUTION_16 = 4 # :nodoc:
    STEP_RESOLUTION_32 = 3 # :nodoc:
    STEP_RESOLUTION_64 = 2 # :nodoc:
    STEP_RESOLUTION_128 = 1 # :nodoc:
    STEP_RESOLUTION_256 = 0 # :nodoc:
    CHOPPER_MODE_SPREAD_CYCLE = 0 # :nodoc:
    CHOPPER_MODE_FAST_DECAY = 1 # :nodoc:
    FREEWHEEL_MODE_NORMAL = 0 # :nodoc:
    FREEWHEEL_MODE_FREEWHEELING = 1 # :nodoc:
    FREEWHEEL_MODE_COIL_SHORT_LS = 2 # :nodoc:
    FREEWHEEL_MODE_COIL_SHORT_HS = 3 # :nodoc:
    CURRENT_UP_STEP_INCREMENT_1 = 0 # :nodoc:
    CURRENT_UP_STEP_INCREMENT_2 = 1 # :nodoc:
    CURRENT_UP_STEP_INCREMENT_4 = 2 # :nodoc:
    CURRENT_UP_STEP_INCREMENT_8 = 3 # :nodoc:
    CURRENT_DOWN_STEP_DECREMENT_1 = 0 # :nodoc:
    CURRENT_DOWN_STEP_DECREMENT_2 = 1 # :nodoc:
    CURRENT_DOWN_STEP_DECREMENT_8 = 2 # :nodoc:
    CURRENT_DOWN_STEP_DECREMENT_32 = 3 # :nodoc:
    MINIMUM_CURRENT_HALF = 0 # :nodoc:
    MINIMUM_CURRENT_QUARTER = 1 # :nodoc:
    STALLGUARD_MODE_STANDARD = 0 # :nodoc:
    STALLGUARD_MODE_FILTERED = 1 # :nodoc:
    OPEN_LOAD_NONE = 0 # :nodoc:
    OPEN_LOAD_PHASE_A = 1 # :nodoc:
    OPEN_LOAD_PHASE_B = 2 # :nodoc:
    OPEN_LOAD_PHASE_AB = 3 # :nodoc:
    SHORT_TO_GROUND_NONE = 0 # :nodoc:
    SHORT_TO_GROUND_PHASE_A = 1 # :nodoc:
    SHORT_TO_GROUND_PHASE_B = 2 # :nodoc:
    SHORT_TO_GROUND_PHASE_AB = 3 # :nodoc:
    OVER_TEMPERATURE_NONE = 0 # :nodoc:
    OVER_TEMPERATURE_WARNING = 1 # :nodoc:
    OVER_TEMPERATURE_LIMIT = 2 # :nodoc:
    STATE_STOP = 1 # :nodoc:
    STATE_ACCELERATION = 2 # :nodoc:
    STATE_RUN = 3 # :nodoc:
    STATE_DEACCELERATION = 4 # :nodoc:
    STATE_DIRECTION_CHANGE_TO_FORWARD = 5 # :nodoc:
    STATE_DIRECTION_CHANGE_TO_BACKWARD = 6 # :nodoc:
    GPIO_ACTION_NONE = 0 # :nodoc:
    GPIO_ACTION_NORMAL_STOP_RISING_EDGE = 1 # :nodoc:
    GPIO_ACTION_NORMAL_STOP_FALLING_EDGE = 2 # :nodoc:
    GPIO_ACTION_FULL_BRAKE_RISING_EDGE = 4 # :nodoc:
    GPIO_ACTION_FULL_BRAKE_FALLING_EDGE = 8 # :nodoc:
    GPIO_ACTION_CALLBACK_RISING_EDGE = 16 # :nodoc:
    GPIO_ACTION_CALLBACK_FALLING_EDGE = 32 # :nodoc:
    ERROR_LED_CONFIG_OFF = 0 # :nodoc:
    ERROR_LED_CONFIG_ON = 1 # :nodoc:
    ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    ERROR_LED_CONFIG_SHOW_ERROR = 3 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_MAX_VELOCITY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MAX_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CURRENT_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPEED_RAMPING] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPEED_RAMPING] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_FULL_BRAKE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_CURRENT_POSITION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CURRENT_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TARGET_POSITION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_TARGET_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STEPS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STEPS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_REMAINING_STEPS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STEP_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STEP_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_DRIVE_FORWARD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DRIVE_BACKWARD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_STOP] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_INPUT_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOTOR_CURRENT] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOTOR_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ENABLED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BASIC_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_BASIC_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPREADCYCLE_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPREADCYCLE_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STEALTH_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STEALTH_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COOLSTEP_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_COOLSTEP_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MISC_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MISC_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ERROR_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ERROR_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_DRIVER_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MINIMUM_VOLTAGE] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_MINIMUM_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TIME_BASE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_TIME_BASE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA_CALLBACK_CONFIGURATON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GPIO_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_GPIO_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GPIO_ACTION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_GPIO_ACTION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_GPIO_STATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_UNDER_VOLTAGE] = [10, 'S']
      @callback_formats[CALLBACK_POSITION_REACHED] = [12, 'l']
      @callback_formats[CALLBACK_ALL_DATA] = [22, 'S l l S S']
      @callback_formats[CALLBACK_NEW_STATE] = [10, 'C C']
      @callback_formats[CALLBACK_GPIO_STATE] = [9, '?2']

      @ipcon.add_device self
    end

    # Sets the maximum velocity of the stepper motor.
    # This function does *not* start the motor, it merely sets the maximum
    # velocity the stepper motor is accelerated to. To get the motor running use
    # either BrickletSilentStepperV2#set_target_position, BrickletSilentStepperV2#set_steps, BrickletSilentStepperV2#drive_forward or
    # BrickletSilentStepperV2#drive_backward.
    def set_max_velocity(velocity)
      check_validity

      send_request FUNCTION_SET_MAX_VELOCITY, [velocity], 'S', 8, ''
    end

    # Returns the velocity as set by BrickletSilentStepperV2#set_max_velocity.
    def get_max_velocity
      check_validity

      send_request FUNCTION_GET_MAX_VELOCITY, [], '', 10, 'S'
    end

    # Returns the *current* velocity of the stepper motor.
    def get_current_velocity
      check_validity

      send_request FUNCTION_GET_CURRENT_VELOCITY, [], '', 10, 'S'
    end

    # Sets the acceleration and deacceleration of the stepper motor.
    # An acceleration of 1000 means, that
    # every second the velocity is increased by 1000 *steps/s*.
    # 
    # For example: If the current velocity is 0 and you want to accelerate to a
    # velocity of 8000 *steps/s* in 10 seconds, you should set an acceleration
    # of 800 *steps/s²*.
    # 
    # An acceleration/deacceleration of 0 means instantaneous
    # acceleration/deacceleration (not recommended)
    def set_speed_ramping(acceleration, deacceleration)
      check_validity

      send_request FUNCTION_SET_SPEED_RAMPING, [acceleration, deacceleration], 'S S', 8, ''
    end

    # Returns the acceleration and deacceleration as set by
    # BrickletSilentStepperV2#set_speed_ramping.
    def get_speed_ramping
      check_validity

      send_request FUNCTION_GET_SPEED_RAMPING, [], '', 12, 'S S'
    end

    # Executes an active full brake.
    # 
    # .. warning::
    #  This function is for emergency purposes,
    #  where an immediate brake is necessary. Depending on the current velocity and
    #  the strength of the motor, a full brake can be quite violent.
    # 
    # Call BrickletSilentStepperV2#stop if you just want to stop the motor.
    def full_brake
      check_validity

      send_request FUNCTION_FULL_BRAKE, [], '', 8, ''
    end

    # Sets the current steps of the internal step counter. This can be used to
    # set the current position to 0 when some kind of starting position
    # is reached (e.g. when a CNC machine reaches a corner).
    def set_current_position(position)
      check_validity

      send_request FUNCTION_SET_CURRENT_POSITION, [position], 'l', 8, ''
    end

    # Returns the current position of the stepper motor in steps. On startup
    # the position is 0. The steps are counted with all possible driving
    # functions (BrickletSilentStepperV2#set_target_position, BrickletSilentStepperV2#set_steps, BrickletSilentStepperV2#drive_forward or
    # BrickletSilentStepperV2#drive_backward). It also is possible to reset the steps to 0 or
    # set them to any other desired value with BrickletSilentStepperV2#set_current_position.
    def get_current_position
      check_validity

      send_request FUNCTION_GET_CURRENT_POSITION, [], '', 12, 'l'
    end

    # Sets the target position of the stepper motor in steps. For example,
    # if the current position of the motor is 500 and BrickletSilentStepperV2#set_target_position is
    # called with 1000, the stepper motor will drive 500 steps forward. It will
    # use the velocity, acceleration and deacceleration as set by
    # BrickletSilentStepperV2#set_max_velocity and BrickletSilentStepperV2#set_speed_ramping.
    # 
    # A call of BrickletSilentStepperV2#set_target_position with the parameter *x* is equivalent to
    # a call of BrickletSilentStepperV2#set_steps with the parameter
    # (*x* - BrickletSilentStepperV2#get_current_position).
    def set_target_position(position)
      check_validity

      send_request FUNCTION_SET_TARGET_POSITION, [position], 'l', 8, ''
    end

    # Returns the last target position as set by BrickletSilentStepperV2#set_target_position.
    def get_target_position
      check_validity

      send_request FUNCTION_GET_TARGET_POSITION, [], '', 12, 'l'
    end

    # Sets the number of steps the stepper motor should run. Positive values
    # will drive the motor forward and negative values backward.
    # The velocity, acceleration and deacceleration as set by
    # BrickletSilentStepperV2#set_max_velocity and BrickletSilentStepperV2#set_speed_ramping will be used.
    def set_steps(steps)
      check_validity

      send_request FUNCTION_SET_STEPS, [steps], 'l', 8, ''
    end

    # Returns the last steps as set by BrickletSilentStepperV2#set_steps.
    def get_steps
      check_validity

      send_request FUNCTION_GET_STEPS, [], '', 12, 'l'
    end

    # Returns the remaining steps of the last call of BrickletSilentStepperV2#set_steps.
    # For example, if BrickletSilentStepperV2#set_steps is called with 2000 and
    # BrickletSilentStepperV2#get_remaining_steps is called after the motor has run for 500 steps,
    # it will return 1500.
    def get_remaining_steps
      check_validity

      send_request FUNCTION_GET_REMAINING_STEPS, [], '', 12, 'l'
    end

    # Sets the step resolution from full-step up to 1/256-step.
    # 
    # If interpolation is turned on, the Silent Stepper Bricklet 2.0 will always interpolate
    # your step inputs as 1/256-step. If you use full-step mode with interpolation, each
    # step will generate 256 1/256 steps.
    # 
    # For maximum torque use full-step without interpolation. For maximum resolution use
    # 1/256-step. Turn interpolation on to make the Stepper driving less noisy.
    # 
    # If you often change the speed with high acceleration you should turn the
    # interpolation off.
    def set_step_configuration(step_resolution, interpolation)
      check_validity

      send_request FUNCTION_SET_STEP_CONFIGURATION, [step_resolution, interpolation], 'C ?', 8, ''
    end

    # Returns the step mode as set by BrickletSilentStepperV2#set_step_configuration.
    def get_step_configuration
      check_validity

      send_request FUNCTION_GET_STEP_CONFIGURATION, [], '', 10, 'C ?'
    end

    # Drives the stepper motor forward until BrickletSilentStepperV2#drive_backward or
    # BrickletSilentStepperV2#stop is called. The velocity, acceleration and deacceleration as
    # set by BrickletSilentStepperV2#set_max_velocity and BrickletSilentStepperV2#set_speed_ramping will be used.
    def drive_forward
      check_validity

      send_request FUNCTION_DRIVE_FORWARD, [], '', 8, ''
    end

    # Drives the stepper motor backward until BrickletSilentStepperV2#drive_forward or
    # BrickletSilentStepperV2#stop is triggered. The velocity, acceleration and deacceleration as
    # set by BrickletSilentStepperV2#set_max_velocity and BrickletSilentStepperV2#set_speed_ramping will be used.
    def drive_backward
      check_validity

      send_request FUNCTION_DRIVE_BACKWARD, [], '', 8, ''
    end

    # Stops the stepper motor with the deacceleration as set by
    # BrickletSilentStepperV2#set_speed_ramping.
    def stop
      check_validity

      send_request FUNCTION_STOP, [], '', 8, ''
    end

    # Returns the external input voltage. The external input voltage is
    # given via the black power input connector on the Silent Stepper Bricklet 2.0.
    # 
    # If there is an external input voltage and a stack input voltage, the motor
    # will be driven by the external input voltage. If there is only a stack
    # voltage present, the motor will be driven by this voltage.
    # 
    # .. warning::
    #  This means, if you have a high stack voltage and a low external voltage,
    #  the motor will be driven with the low external voltage. If you then remove
    #  the external connection, it will immediately be driven by the high
    #  stack voltage
    def get_input_voltage
      check_validity

      send_request FUNCTION_GET_INPUT_VOLTAGE, [], '', 10, 'S'
    end

    # Sets the current with which the motor will be driven.
    # 
    # .. warning::
    #  Do not set this value above the specifications of your stepper motor.
    #  Otherwise it may damage your motor.
    def set_motor_current(current)
      check_validity

      send_request FUNCTION_SET_MOTOR_CURRENT, [current], 'S', 8, ''
    end

    # Returns the current as set by BrickletSilentStepperV2#set_motor_current.
    def get_motor_current
      check_validity

      send_request FUNCTION_GET_MOTOR_CURRENT, [], '', 10, 'S'
    end

    # Enables/Disables the driver chip. The driver parameters can be configured (maximum velocity,
    # acceleration, etc) before it is enabled.
    # 
    # .. warning::
    #  Disabling the driver chip while the motor is still turning can damage the
    #  driver chip. The motor should be stopped calling BrickletSilentStepperV2#stop function
    #  before disabling the motor power. The BrickletSilentStepperV2#stop function will **not**
    #  wait until the motor is actually stopped. You have to explicitly wait for the
    #  appropriate time after calling the BrickletSilentStepperV2#stop function before calling
    #  the BrickletSilentStepperV2#set_enabled with false function.
    def set_enabled(enabled)
      check_validity

      send_request FUNCTION_SET_ENABLED, [enabled], '?', 8, ''
    end

    # Returns *true* if the stepper driver is enabled, *false* otherwise.
    def get_enabled
      check_validity

      send_request FUNCTION_GET_ENABLED, [], '', 9, '?'
    end

    # Sets the basic configuration parameters for the different modes (Stealth, Coolstep, Classic).
    # 
    # * Standstill Current: This value can be used to lower the current during stand still. This might
    #   be reasonable to reduce the heating of the motor and the Bricklet 2.0. When the motor is in standstill
    #   the configured motor phase current will be driven until the configured
    #   Power Down Time is elapsed. After that the phase current will be reduced to the standstill
    #   current. The elapsed time for this reduction can be configured with the Standstill Delay Time.
    #   The maximum allowed value is the configured maximum motor current
    #   (see BrickletSilentStepperV2#set_motor_current).
    # 
    # * Motor Run Current: The value sets the motor current when the motor is running.
    #   Use a value of at least one half of the global maximum motor current for a good
    #   microstep performance. The maximum allowed value is the current
    #   motor current. The API maps the entered value to 1/32 ... 32/32 of the maximum
    #   motor current. This value should be used to change the motor current during motor movement,
    #   whereas the global maximum motor current should not be changed while the motor is moving
    #   (see BrickletSilentStepperV2#set_motor_current).
    # 
    # * Standstill Delay Time: Controls the duration for motor power down after a motion
    #   as soon as standstill is detected and the Power Down Time is expired. A high Standstill Delay
    #   Time results in a smooth transition that avoids motor jerk during power down.
    # 
    # * Power Down Time: Sets the delay time after a stand still.
    # 
    # * Stealth Threshold: Sets the upper threshold for Stealth mode.
    #   If the velocity of the motor goes above this value, Stealth mode is turned
    #   off. Otherwise it is turned on. In Stealth mode the torque declines with high speed.
    # 
    # * Coolstep Threshold: Sets the lower threshold for Coolstep mode.
    #   The Coolstep Threshold needs to be above the Stealth Threshold.
    # 
    # * Classic Threshold: Sets the lower threshold for classic mode.
    #   In classic mode the stepper becomes more noisy, but the torque is maximized.
    # 
    # * High Velocity Chopper Mode: If High Velocity Chopper Mode is enabled, the stepper control
    #   is optimized to run the stepper motors at high velocities.
    # 
    # If you want to use all three thresholds make sure that
    # Stealth Threshold < Coolstep Threshold < Classic Threshold.
    def set_basic_configuration(standstill_current, motor_run_current, standstill_delay_time, power_down_time, stealth_threshold, coolstep_threshold, classic_threshold, high_velocity_chopper_mode)
      check_validity

      send_request FUNCTION_SET_BASIC_CONFIGURATION, [standstill_current, motor_run_current, standstill_delay_time, power_down_time, stealth_threshold, coolstep_threshold, classic_threshold, high_velocity_chopper_mode], 'S S S S S S S ?', 8, ''
    end

    # Returns the configuration as set by BrickletSilentStepperV2#set_basic_configuration.
    def get_basic_configuration
      check_validity

      send_request FUNCTION_GET_BASIC_CONFIGURATION, [], '', 23, 'S S S S S S S ?'
    end

    # Note: If you don't know what any of this means you can very likely keep all of
    # the values as default!
    # 
    # Sets the Spreadcycle configuration parameters. Spreadcycle is a chopper algorithm which actively
    # controls the motor current flow. More information can be found in the TMC2130 datasheet on page
    # 47 (7 spreadCycle and Classic Chopper).
    # 
    # * Slow Decay Duration: Controls duration of off time setting of slow decay phase.
    #   0 = driver disabled, all bridges off. Use 1 only with Comparator Blank time >= 2.
    # 
    # * Enable Random Slow Decay: Set to false to fix chopper off time as set by Slow Decay Duration.
    #   If you set it to true, Decay Duration is randomly modulated.
    # 
    # * Fast Decay Duration: Sets the fast decay duration. This parameters is
    #   only used if the Chopper Mode is set to Fast Decay.
    # 
    # * Hysteresis Start Value: Sets the hysteresis start value. This parameter is
    #   only used if the Chopper Mode is set to Spread Cycle.
    # 
    # * Hysteresis End Value: Sets the hysteresis end value. This parameter is
    #   only used if the Chopper Mode is set to Spread Cycle.
    # 
    # * Sine Wave Offset: Sets the sine wave offset. This parameters is
    #   only used if the Chopper Mode is set to Fast Decay. 1/512 of the value becomes added to the absolute
    #   value of the sine wave.
    # 
    # * Chopper Mode: 0 = Spread Cycle, 1 = Fast Decay.
    # 
    # * Comparator Blank Time: Sets the blank time of the comparator. Available values are
    # 
    #   * 0 = 16 clocks,
    #   * 1 = 24 clocks,
    #   * 2 = 36 clocks and
    #   * 3 = 54 clocks.
    # 
    #   A value of 1 or 2 is recommended for most applications.
    # 
    # * Fast Decay Without Comparator: If set to true the current comparator usage for termination of the
    #   fast decay cycle is disabled.
    def set_spreadcycle_configuration(slow_decay_duration, enable_random_slow_decay, fast_decay_duration, hysteresis_start_value, hysteresis_end_value, sine_wave_offset, chopper_mode, comparator_blank_time, fast_decay_without_comparator)
      check_validity

      send_request FUNCTION_SET_SPREADCYCLE_CONFIGURATION, [slow_decay_duration, enable_random_slow_decay, fast_decay_duration, hysteresis_start_value, hysteresis_end_value, sine_wave_offset, chopper_mode, comparator_blank_time, fast_decay_without_comparator], 'C ? C C c c C C ?', 8, ''
    end

    # Returns the configuration as set by BrickletSilentStepperV2#set_basic_configuration.
    def get_spreadcycle_configuration
      check_validity

      send_request FUNCTION_GET_SPREADCYCLE_CONFIGURATION, [], '', 17, 'C ? C C c c C C ?'
    end

    # Note: If you don't know what any of this means you can very likely keep all of
    # the values as default!
    # 
    # Sets the configuration relevant for Stealth mode.
    # 
    # * Enable Stealth: If set to true the stealth mode is enabled, if set to false the
    #   stealth mode is disabled, even if the speed is below the threshold set in BrickletSilentStepperV2#set_basic_configuration.
    # 
    # * Amplitude: If autoscale is disabled, the PWM amplitude is scaled by this value. If autoscale is enabled,
    #   this value defines the maximum PWM amplitude change per half wave.
    # 
    # * Gradient: If autoscale is disabled, the PWM gradient is scaled by this value. If autoscale is enabled,
    #   this value defines the maximum PWM gradient. With autoscale a value above 64 is recommended,
    #   otherwise the regulation might not be able to measure the current.
    # 
    # * Enable Autoscale: If set to true, automatic current control is used. Otherwise the user defined
    #   amplitude and gradient are used.
    # 
    # * Force Symmetric: If true, A symmetric PWM cycle is enforced. Otherwise the PWM value may change within each
    #   PWM cycle.
    # 
    # * Freewheel Mode: The freewheel mode defines the behavior in stand still if the Standstill Current
    #   (see BrickletSilentStepperV2#set_basic_configuration) is set to 0.
    def set_stealth_configuration(enable_stealth, amplitude, gradient, enable_autoscale, force_symmetric, freewheel_mode)
      check_validity

      send_request FUNCTION_SET_STEALTH_CONFIGURATION, [enable_stealth, amplitude, gradient, enable_autoscale, force_symmetric, freewheel_mode], '? C C ? ? C', 8, ''
    end

    # Returns the configuration as set by BrickletSilentStepperV2#set_stealth_configuration.
    def get_stealth_configuration
      check_validity

      send_request FUNCTION_GET_STEALTH_CONFIGURATION, [], '', 14, '? C C ? ? C'
    end

    # Note: If you don't know what any of this means you can very likely keep all of
    # the values as default!
    # 
    # Sets the configuration relevant for Coolstep.
    # 
    # * Minimum Stallguard Value: If the Stallguard result falls below this value*32, the motor current
    #   is increased to reduce motor load angle. A value of 0 turns Coolstep off.
    # 
    # * Maximum Stallguard Value: If the Stallguard result goes above
    #   (Min Stallguard Value + Max Stallguard Value + 1) * 32, the motor current is decreased to save
    #   energy.
    # 
    # * Current Up Step Width: Sets the up step increment per Stallguard value. The value range is 0-3,
    #   corresponding to the increments 1, 2, 4 and 8.
    # 
    # * Current Down Step Width: Sets the down step decrement per Stallguard value. The value range is 0-3,
    #   corresponding to the decrements 1, 2, 8 and 16.
    # 
    # * Minimum Current: Sets the minimum current for Coolstep current control. You can choose between
    #   half and quarter of the run current.
    # 
    # * Stallguard Threshold Value: Sets the level for stall output (see BrickletSilentStepperV2#get_driver_status).
    #   A lower value gives a higher sensitivity. You have to find a suitable value for your
    #   motor by trial and error, 0 works for most motors.
    # 
    # * Stallguard Mode: Set to 0 for standard resolution or 1 for filtered mode. In filtered mode the Stallguard
    #   signal will be updated every four full-steps.
    def set_coolstep_configuration(minimum_stallguard_value, maximum_stallguard_value, current_up_step_width, current_down_step_width, minimum_current, stallguard_threshold_value, stallguard_mode)
      check_validity

      send_request FUNCTION_SET_COOLSTEP_CONFIGURATION, [minimum_stallguard_value, maximum_stallguard_value, current_up_step_width, current_down_step_width, minimum_current, stallguard_threshold_value, stallguard_mode], 'C C C C C c C', 8, ''
    end

    # Returns the configuration as set by BrickletSilentStepperV2#set_coolstep_configuration.
    def get_coolstep_configuration
      check_validity

      send_request FUNCTION_GET_COOLSTEP_CONFIGURATION, [], '', 15, 'C C C C C c C'
    end

    # Note: If you don't know what any of this means you can very likely keep all of
    # the values as default!
    # 
    # Sets miscellaneous configuration parameters.
    # 
    # * Disable Short To Ground Protection: Set to false to enable short to ground protection, otherwise
    #   it is disabled.
    # 
    # * Synchronize Phase Frequency: With this parameter you can synchronize the chopper for both phases
    #   of a two phase motor to avoid the occurrence of a beat. The value range is 0-15. If set to 0,
    #   the synchronization is turned off. Otherwise the synchronization is done through the formula
    #   f_sync = f_clk/(value*64). In Classic Mode the synchronization is automatically switched off.
    #   f_clk is 12.8MHz.
    def set_misc_configuration(disable_short_to_ground_protection, synchronize_phase_frequency)
      check_validity

      send_request FUNCTION_SET_MISC_CONFIGURATION, [disable_short_to_ground_protection, synchronize_phase_frequency], '? C', 8, ''
    end

    # Returns the configuration as set by BrickletSilentStepperV2#set_misc_configuration.
    def get_misc_configuration
      check_validity

      send_request FUNCTION_GET_MISC_CONFIGURATION, [], '', 10, '? C'
    end

    # Configures the error LED to be either turned off, turned on, blink in
    # heartbeat mode or show an error.
    # 
    # If the LED is configured to show errors it has three different states:
    # 
    # * Off: No error present.
    # * 250ms interval blink: Overtemperature warning.
    # * 1s interval blink: Input voltage too small.
    # * full red: motor disabled because of short to ground in phase a or b or because of overtemperature.
    def set_error_led_config(config)
      check_validity

      send_request FUNCTION_SET_ERROR_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletSilentStepperV2#set_error_led_config
    def get_error_led_config
      check_validity

      send_request FUNCTION_GET_ERROR_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the current driver status.
    # 
    # * Open Load: Indicates if an open load is present on phase A, B or both. This could mean that there is a problem
    #   with the wiring of the motor. False detection can occur in fast motion as well as during stand still.
    # 
    # * Short To Ground: Indicates if a short to ground is present on phase A, B or both. If this is detected the driver
    #   automatically becomes disabled and stays disabled until it is enabled again manually.
    # 
    # * Over Temperature: The over temperature indicator switches to "Warning" if the driver IC warms up. The warning flag
    #   is expected during long duration stepper uses. If the temperature limit is reached the indicator switches
    #   to "Limit". In this case the driver becomes disabled until it cools down again.
    # 
    # * Motor Stalled: Is true if a motor stall was detected.
    # 
    # * Actual Motor Current: Indicates the actual current control scaling as used in Coolstep mode.
    #   It represents a multiplier of 1/32 to 32/32 of the
    #   ``Motor Run Current`` as set by BrickletSilentStepperV2#set_basic_configuration. Example: If a ``Motor Run Current``
    #   of 1000mA was set and the returned value is 15, the ``Actual Motor Current`` is 16/32*1000mA = 500mA.
    # 
    # * Stallguard Result: Indicates the load of the motor. A lower value signals a higher load. Per trial and error
    #   you can find out which value corresponds to a suitable torque for the velocity used in your application.
    #   After that you can use this threshold value to find out if a motor stall becomes probable and react on it (e.g.
    #   decrease velocity).
    #   During stand still this value can not be used for stall detection, it shows the chopper on-time for motor coil A.
    # 
    # * Stealth Voltage Amplitude: Shows the actual PWM scaling. In Stealth mode it can be used to detect motor load and
    #   stall if autoscale is enabled (see BrickletSilentStepperV2#set_stealth_configuration).
    def get_driver_status
      check_validity

      send_request FUNCTION_GET_DRIVER_STATUS, [], '', 16, 'C C C ? C ? C C'
    end

    # Sets the minimum voltage, below which the CALLBACK_UNDER_VOLTAGE callback
    # is triggered. The minimum possible value that works with the Silent Stepper
    # Bricklet 2.0 is 8V.
    # You can use this function to detect the discharge of a battery that is used
    # to drive the stepper motor. If you have a fixed power supply, you likely do
    # not need this functionality.
    def set_minimum_voltage(voltage)
      check_validity

      send_request FUNCTION_SET_MINIMUM_VOLTAGE, [voltage], 'S', 8, ''
    end

    # Returns the minimum voltage as set by BrickletSilentStepperV2#set_minimum_voltage.
    def get_minimum_voltage
      check_validity

      send_request FUNCTION_GET_MINIMUM_VOLTAGE, [], '', 10, 'S'
    end

    # Sets the time base of the velocity and the acceleration of the Silent Stepper
    # Bricklet 2.0.
    # 
    # For example, if you want to make one step every 1.5 seconds, you can set
    # the time base to 15 and the velocity to 10. Now the velocity is
    # 10steps/15s = 1steps/1.5s.
    def set_time_base(time_base)
      check_validity

      send_request FUNCTION_SET_TIME_BASE, [time_base], 'L', 8, ''
    end

    # Returns the time base as set by BrickletSilentStepperV2#set_time_base.
    def get_time_base
      check_validity

      send_request FUNCTION_GET_TIME_BASE, [], '', 12, 'L'
    end

    # Returns the following parameters: The current velocity,
    # the current position, the remaining steps, the stack voltage, the external
    # voltage and the current consumption of the stepper motor.
    # 
    # The current consumption is calculated by multiplying the ``Actual Motor Current``
    # value (see BrickletSilentStepperV2#set_basic_configuration) with the ``Motor Run Current``
    # (see BrickletSilentStepperV2#get_driver_status). This is an internal calculation of the
    # driver, not an independent external measurement.
    # 
    # The current consumption calculation was broken up to firmware 2.0.1, it is fixed
    # since firmware 2.0.2.
    # 
    # There is also a callback for this function, see CALLBACK_ALL_DATA callback.
    def get_all_data
      check_validity

      send_request FUNCTION_GET_ALL_DATA, [], '', 22, 'S l l S S'
    end

    # Sets the period with which the CALLBACK_ALL_DATA callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_all_callback_configuration(period)
      check_validity

      send_request FUNCTION_SET_ALL_CALLBACK_CONFIGURATION, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletSilentStepperV2#set_all_callback_configuration.
    def get_all_data_callback_configuraton
      check_validity

      send_request FUNCTION_GET_ALL_DATA_CALLBACK_CONFIGURATON, [], '', 12, 'L'
    end

    # Sets the GPIO configuration for the given channel.
    # You can configure a debounce and the deceleration that is used if the action is
    # configured as ``normal stop``. See BrickletSilentStepperV2#set_gpio_action.
    def set_gpio_configuration(channel, debounce, stop_deceleration)
      check_validity

      send_request FUNCTION_SET_GPIO_CONFIGURATION, [channel, debounce, stop_deceleration], 'C S S', 8, ''
    end

    # Returns the GPIO configuration for a channel as set by BrickletSilentStepperV2#set_gpio_configuration.
    def get_gpio_configuration(channel)
      check_validity

      send_request FUNCTION_GET_GPIO_CONFIGURATION, [channel], 'C', 12, 'S S'
    end

    # Sets the GPIO action for the given channel.
    # 
    # The action can be a normal stop, a full brake or a callback. Each for a rising
    # edge or falling edge. The actions are a bitmask they can be used at the same time.
    # You can for example trigger a full brake and a callback at the same time or for
    # rising and falling edge.
    # 
    # The deceleration speed for the normal stop can be configured with
    # BrickletSilentStepperV2#set_gpio_configuration.
    def set_gpio_action(channel, action)
      check_validity

      send_request FUNCTION_SET_GPIO_ACTION, [channel, action], 'C L', 8, ''
    end

    # Returns the GPIO action for a channel as set by BrickletSilentStepperV2#set_gpio_action.
    def get_gpio_action(channel)
      check_validity

      send_request FUNCTION_GET_GPIO_ACTION, [channel], 'C', 12, 'L'
    end

    # Returns the GPIO state for both channels. True if the state is ``high`` and
    # false if the state is ``low``.
    def get_gpio_state
      check_validity

      send_request FUNCTION_GET_GPIO_STATE, [], '', 9, '?2'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletSilentStepperV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletSilentStepperV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletSilentStepperV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletSilentStepperV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
