# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures Sound Pressure Level in dB(A/B/C/D/Z)
  class BrickletSoundPressureLevel < Device
    DEVICE_IDENTIFIER = 290 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Sound Pressure Level Bricklet' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletSoundPressureLevel#set_decibel_callback_configuration.
    # 
    # The parameter is the same as BrickletSoundPressureLevel#get_decibel.
    CALLBACK_DECIBEL = 4

    # See CALLBACK_SPECTRUM
    CALLBACK_SPECTRUM_LOW_LEVEL = 8

    # This callback is triggered periodically according to the configuration set by
    # BrickletSoundPressureLevel#set_spectrum_callback_configuration.
    # 
    # The parameter is the same as BrickletSoundPressureLevel#get_spectrum.
    # 
    # .. note::
    #  If reconstructing the value fails, the callback is triggered with nil for spectrum.
    CALLBACK_SPECTRUM = -8

    FUNCTION_GET_DECIBEL = 1 # :nodoc:
    FUNCTION_SET_DECIBEL_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_DECIBEL_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_GET_SPECTRUM_LOW_LEVEL = 5 # :nodoc:
    FUNCTION_SET_SPECTRUM_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_SPECTRUM_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 9 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 10 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    FFT_SIZE_128 = 0 # :nodoc:
    FFT_SIZE_256 = 1 # :nodoc:
    FFT_SIZE_512 = 2 # :nodoc:
    FFT_SIZE_1024 = 3 # :nodoc:
    WEIGHTING_A = 0 # :nodoc:
    WEIGHTING_B = 1 # :nodoc:
    WEIGHTING_C = 2 # :nodoc:
    WEIGHTING_D = 3 # :nodoc:
    WEIGHTING_Z = 4 # :nodoc:
    WEIGHTING_ITU_R_468 = 5 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_DECIBEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DECIBEL_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DECIBEL_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPECTRUM_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPECTRUM_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_SPECTRUM_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_DECIBEL] = [10, 'S']
      @callback_formats[CALLBACK_SPECTRUM_LOW_LEVEL] = [72, 'S S S30']

      @high_level_callbacks[CALLBACK_SPECTRUM] = [['stream_length', 'stream_chunk_offset', 'stream_chunk_data'], {'fixed_length' => nil, 'single_chunk' => false}, nil]
      @ipcon.add_device self
    end

    # Returns the measured sound pressure in decibels.
    # 
    # The Bricklet supports the weighting standards dB(A), dB(B), dB(C), dB(D),
    # dB(Z) and ITU-R 468. You can configure the weighting with BrickletSoundPressureLevel#set_configuration.
    # 
    # By default dB(A) will be used.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_DECIBEL callback. You can set the callback configuration
    # with BrickletSoundPressureLevel#set_decibel_callback_configuration.
    def get_decibel
      check_validity

      send_request FUNCTION_GET_DECIBEL, [], '', 10, 'S'
    end

    # The period is the period with which the CALLBACK_DECIBEL callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_DECIBEL callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_decibel_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_DECIBEL_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k S S', 8, ''
    end

    # Returns the callback configuration as set by BrickletSoundPressureLevel#set_decibel_callback_configuration.
    def get_decibel_callback_configuration
      check_validity

      send_request FUNCTION_GET_DECIBEL_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k S S'
    end

    # Returns the frequency spectrum. The length of the spectrum is between
    # 512 (FFT size 1024) and 64 (FFT size 128). See BrickletSoundPressureLevel#set_configuration.
    # 
    # Each array element is one bin of the FFT. The first bin is always the
    # DC offset and the other bins have a size between 40Hz (FFT size 1024) and
    # 320Hz (FFT size 128).
    # 
    # In sum the frequency of the spectrum always has a range from 0 to
    # 20480Hz (the FFT is applied to samples with a frequency of 40960Hz).
    # 
    # The returned data is already equalized, which means that the microphone
    # frequency response is compensated and the weighting function is applied
    # (see BrickletSoundPressureLevel#set_configuration for the available weighting standards). Use
    # dB(Z) if you need the unaltered spectrum.
    # 
    # The values are not in dB form yet. If you want a proper dB scale of the
    # spectrum you have to apply the formula f(x) = 20*log10(max(1, x/sqrt(2)))
    # on each value.
    def get_spectrum_low_level
      check_validity

      send_request FUNCTION_GET_SPECTRUM_LOW_LEVEL, [], '', 72, 'S S S30'
    end

    # The period is the period with which the CALLBACK_SPECTRUM callback is
    # triggered periodically. A value of 0 turns the callback off.
    # 
    # Every new measured spectrum will be send at most once. Set the period to 1 to
    # make sure that you get every spectrum.
    def set_spectrum_callback_configuration(period)
      check_validity

      send_request FUNCTION_SET_SPECTRUM_CALLBACK_CONFIGURATION, [period], 'L', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletSoundPressureLevel#get_spectrum_callback_configuration.
    def get_spectrum_callback_configuration
      check_validity

      send_request FUNCTION_GET_SPECTRUM_CALLBACK_CONFIGURATION, [], '', 12, 'L'
    end

    # Sets the Sound Pressure Level Bricklet configuration.
    # 
    # With different FFT sizes the Bricklet has a different
    # amount of samples per second and the size of the FFT bins
    # changes. The higher the FFT size the more precise is the result
    # of the dB(X) calculation.
    # 
    # Available FFT sizes are:
    # 
    # * 1024: 512 bins, 10 samples per second, each bin has size 40Hz
    # * 512: 256 bins, 20 samples per second, each bin has size 80Hz
    # * 256: 128 bins, 40 samples per second, each bin has size 160Hz
    # * 128: 64 bins, 80 samples per second, each bin has size 320Hz
    # 
    # The Bricklet supports different weighting functions. You can choose
    # between dB(A), dB(B), dB(C), dB(D), dB(Z) and ITU-R 468.
    # 
    # dB(A/B/C/D) are the standard dB weighting curves. dB(A) is
    # often used to measure volumes at concerts etc. dB(Z) has a
    # flat response, no weighting is applied. ITU-R 468 is an ITU
    # weighting standard mostly used in the UK and Europe.
    def set_configuration(fft_size, weighting)
      check_validity

      send_request FUNCTION_SET_CONFIGURATION, [fft_size, weighting], 'C C', 8, ''
    end

    # Returns the configuration as set by BrickletSoundPressureLevel#set_configuration.
    def get_configuration
      check_validity

      send_request FUNCTION_GET_CONFIGURATION, [], '', 10, 'C C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletSoundPressureLevel#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletSoundPressureLevel#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletSoundPressureLevel#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletSoundPressureLevel#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Returns the frequency spectrum. The length of the spectrum is between
    # 512 (FFT size 1024) and 64 (FFT size 128). See BrickletSoundPressureLevel#set_configuration.
    # 
    # Each array element is one bin of the FFT. The first bin is always the
    # DC offset and the other bins have a size between 40Hz (FFT size 1024) and
    # 320Hz (FFT size 128).
    # 
    # In sum the frequency of the spectrum always has a range from 0 to
    # 20480Hz (the FFT is applied to samples with a frequency of 40960Hz).
    # 
    # The returned data is already equalized, which means that the microphone
    # frequency response is compensated and the weighting function is applied
    # (see BrickletSoundPressureLevel#set_configuration for the available weighting standards). Use
    # dB(Z) if you need the unaltered spectrum.
    # 
    # The values are not in dB form yet. If you want a proper dB scale of the
    # spectrum you have to apply the formula f(x) = 20*log10(max(1, x/sqrt(2)))
    # on each value.
    def get_spectrum
      spectrum_length = nil # assigned in block
      spectrum_data = nil # assigned in block

      @stream_mutex.synchronize {
        ret = get_spectrum_low_level
        spectrum_length = ret[0]
        spectrum_chunk_offset = ret[1]
        spectrum_out_of_sync = spectrum_chunk_offset != 0
        spectrum_data = ret[2]

        while not spectrum_out_of_sync and spectrum_data.length < spectrum_length
          ret = get_spectrum_low_level
          spectrum_length = ret[0]
          spectrum_chunk_offset = ret[1]
          spectrum_out_of_sync = spectrum_chunk_offset != spectrum_data.length
          spectrum_data += ret[2]
        end

        if spectrum_out_of_sync # discard remaining stream to bring it back in-sync
          while spectrum_chunk_offset + 30 < spectrum_length
            ret = get_spectrum_low_level
            spectrum_length = ret[0]
            spectrum_chunk_offset = ret[1]
          end

          raise StreamOutOfSyncException, 'Spectrum stream is out-of-sync'
        end
      }

      spectrum_data[0, spectrum_length]
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
