# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2021-05-06.      #
#                                                           #
# Ruby Bindings Version 2.1.29                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures power, DC voltage and DC current up to 720W/36V/20A
  class BrickletVoltageCurrent < Device
    DEVICE_IDENTIFIER = 227 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Voltage/Current Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletVoltageCurrent#set_current_callback_period. The parameter is the current of the
    # sensor.
    # 
    # The CALLBACK_CURRENT callback is only triggered if the current has changed since
    # the last triggering.
    CALLBACK_CURRENT = 22

    # This callback is triggered periodically with the period that is set by
    # BrickletVoltageCurrent#set_voltage_callback_period. The parameter is the voltage of
    # the sensor.
    # 
    # The CALLBACK_VOLTAGE callback is only triggered if the voltage has changed since
    # the last triggering.
    CALLBACK_VOLTAGE = 23

    # This callback is triggered periodically with the period that is set by
    # BrickletVoltageCurrent#set_power_callback_period. The parameter is the power of the
    # sensor.
    # 
    # The CALLBACK_POWER callback is only triggered if the power has changed since the
    # last triggering.
    CALLBACK_POWER = 24

    # This callback is triggered when the threshold as set by
    # BrickletVoltageCurrent#set_current_callback_threshold is reached.
    # The parameter is the current of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletVoltageCurrent#set_debounce_period.
    CALLBACK_CURRENT_REACHED = 25

    # This callback is triggered when the threshold as set by
    # BrickletVoltageCurrent#set_voltage_callback_threshold is reached.
    # The parameter is the voltage of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletVoltageCurrent#set_debounce_period.
    CALLBACK_VOLTAGE_REACHED = 26

    # This callback is triggered when the threshold as set by
    # BrickletVoltageCurrent#set_power_callback_threshold is reached.
    # The parameter is the power of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletVoltageCurrent#set_debounce_period.
    CALLBACK_POWER_REACHED = 27

    FUNCTION_GET_CURRENT = 1 # :nodoc:
    FUNCTION_GET_VOLTAGE = 2 # :nodoc:
    FUNCTION_GET_POWER = 3 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 4 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 5 # :nodoc:
    FUNCTION_SET_CALIBRATION = 6 # :nodoc:
    FUNCTION_GET_CALIBRATION = 7 # :nodoc:
    FUNCTION_SET_CURRENT_CALLBACK_PERIOD = 8 # :nodoc:
    FUNCTION_GET_CURRENT_CALLBACK_PERIOD = 9 # :nodoc:
    FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 10 # :nodoc:
    FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 11 # :nodoc:
    FUNCTION_SET_POWER_CALLBACK_PERIOD = 12 # :nodoc:
    FUNCTION_GET_POWER_CALLBACK_PERIOD = 13 # :nodoc:
    FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = 14 # :nodoc:
    FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = 15 # :nodoc:
    FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 16 # :nodoc:
    FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 17 # :nodoc:
    FUNCTION_SET_POWER_CALLBACK_THRESHOLD = 18 # :nodoc:
    FUNCTION_GET_POWER_CALLBACK_THRESHOLD = 19 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 20 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 21 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    AVERAGING_1 = 0 # :nodoc:
    AVERAGING_4 = 1 # :nodoc:
    AVERAGING_16 = 2 # :nodoc:
    AVERAGING_64 = 3 # :nodoc:
    AVERAGING_128 = 4 # :nodoc:
    AVERAGING_256 = 5 # :nodoc:
    AVERAGING_512 = 6 # :nodoc:
    AVERAGING_1024 = 7 # :nodoc:
    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    CONVERSION_TIME_140US = 0 # :nodoc:
    CONVERSION_TIME_204US = 1 # :nodoc:
    CONVERSION_TIME_332US = 2 # :nodoc:
    CONVERSION_TIME_588US = 3 # :nodoc:
    CONVERSION_TIME_1_1MS = 4 # :nodoc:
    CONVERSION_TIME_2_116MS = 5 # :nodoc:
    CONVERSION_TIME_4_156MS = 6 # :nodoc:
    CONVERSION_TIME_8_244MS = 7 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_POWER] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CALIBRATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CURRENT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_POWER_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_POWER_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_POWER_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_POWER_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_CURRENT] = [12, 'l']
      @callback_formats[CALLBACK_VOLTAGE] = [12, 'l']
      @callback_formats[CALLBACK_POWER] = [12, 'l']
      @callback_formats[CALLBACK_CURRENT_REACHED] = [12, 'l']
      @callback_formats[CALLBACK_VOLTAGE_REACHED] = [12, 'l']
      @callback_formats[CALLBACK_POWER_REACHED] = [12, 'l']

      @ipcon.add_device self
    end

    # Returns the current.
    # 
    # If you want to get the current periodically, it is recommended to use the
    # CALLBACK_CURRENT callback and set the period with
    # BrickletVoltageCurrent#set_current_callback_period.
    def get_current
      check_validity

      send_request FUNCTION_GET_CURRENT, [], '', 12, 'l'
    end

    # Returns the voltage.
    # 
    # If you want to get the voltage periodically, it is recommended to use the
    # CALLBACK_VOLTAGE callback and set the period with
    # BrickletVoltageCurrent#set_voltage_callback_period.
    def get_voltage
      check_validity

      send_request FUNCTION_GET_VOLTAGE, [], '', 12, 'l'
    end

    # Returns the power.
    # 
    # If you want to get the power periodically, it is recommended to use the
    # CALLBACK_POWER callback and set the period with
    # BrickletVoltageCurrent#set_power_callback_period.
    def get_power
      check_validity

      send_request FUNCTION_GET_POWER, [], '', 12, 'l'
    end

    # Sets the configuration of the Voltage/Current Bricklet. It is
    # possible to configure number of averages as well as
    # voltage and current conversion time.
    def set_configuration(averaging, voltage_conversion_time, current_conversion_time)
      check_validity

      send_request FUNCTION_SET_CONFIGURATION, [averaging, voltage_conversion_time, current_conversion_time], 'C C C', 8, ''
    end

    # Returns the configuration as set by BrickletVoltageCurrent#set_configuration.
    def get_configuration
      check_validity

      send_request FUNCTION_GET_CONFIGURATION, [], '', 11, 'C C C'
    end

    # Since the shunt resistor that is used to measure the current is not
    # perfectly precise, it needs to be calibrated by a multiplier and
    # divisor if a very precise reading is needed.
    # 
    # For example, if you are expecting a measurement of 1000mA and you
    # are measuring 1023mA, you can calibrate the Voltage/Current Bricklet
    # by setting the multiplier to 1000 and the divisor to 1023.
    def set_calibration(gain_multiplier, gain_divisor)
      check_validity

      send_request FUNCTION_SET_CALIBRATION, [gain_multiplier, gain_divisor], 'S S', 8, ''
    end

    # Returns the calibration as set by BrickletVoltageCurrent#set_calibration.
    def get_calibration
      check_validity

      send_request FUNCTION_GET_CALIBRATION, [], '', 12, 'S S'
    end

    # Sets the period with which the CALLBACK_CURRENT callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_CURRENT callback is only triggered if the current has changed since
    # the last triggering.
    def set_current_callback_period(period)
      check_validity

      send_request FUNCTION_SET_CURRENT_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletVoltageCurrent#set_current_callback_period.
    def get_current_callback_period
      check_validity

      send_request FUNCTION_GET_CURRENT_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_VOLTAGE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_VOLTAGE callback is only triggered if the voltage has changed since
    # the last triggering.
    def set_voltage_callback_period(period)
      check_validity

      send_request FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletVoltageCurrent#set_voltage_callback_period.
    def get_voltage_callback_period
      check_validity

      send_request FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_POWER callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_POWER callback is only triggered if the power has changed since the
    # last triggering.
    def set_power_callback_period(period)
      check_validity

      send_request FUNCTION_SET_POWER_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletVoltageCurrent#get_power_callback_period.
    def get_power_callback_period
      check_validity

      send_request FUNCTION_GET_POWER_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the thresholds for the CALLBACK_CURRENT_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the current is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the current is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
    def set_current_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, [option, min, max], 'k l l', 8, ''
    end

    # Returns the threshold as set by BrickletVoltageCurrent#set_current_callback_threshold.
    def get_current_callback_threshold
      check_validity

      send_request FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, [], '', 17, 'k l l'
    end

    # Sets the thresholds for the CALLBACK_VOLTAGE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the voltage is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the voltage is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the voltage is greater than the min value (max is ignored)"
    def set_voltage_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, [option, min, max], 'k l l', 8, ''
    end

    # Returns the threshold as set by BrickletVoltageCurrent#set_voltage_callback_threshold.
    def get_voltage_callback_threshold
      check_validity

      send_request FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, [], '', 17, 'k l l'
    end

    # Sets the thresholds for the CALLBACK_POWER_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the power is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the power is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the power is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the power is greater than the min value (max is ignored)"
    def set_power_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_POWER_CALLBACK_THRESHOLD, [option, min, max], 'k l l', 8, ''
    end

    # Returns the threshold as set by BrickletVoltageCurrent#set_power_callback_threshold.
    def get_power_callback_threshold
      check_validity

      send_request FUNCTION_GET_POWER_CALLBACK_THRESHOLD, [], '', 17, 'k l l'
    end

    # Sets the period with which the threshold callbacks
    # 
    # * CALLBACK_CURRENT_REACHED,
    # * CALLBACK_VOLTAGE_REACHED,
    # * CALLBACK_POWER_REACHED
    # 
    # are triggered, if the thresholds
    # 
    # * BrickletVoltageCurrent#set_current_callback_threshold,
    # * BrickletVoltageCurrent#set_voltage_callback_threshold,
    # * BrickletVoltageCurrent#set_power_callback_threshold
    # 
    # keep being reached.
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickletVoltageCurrent#set_debounce_period.
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # A Bricklet connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always at
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
